;;; $Id: rename.scm,v 1.1 1994/10/04 21:08:41 queinnec Exp $

;;; Rename uniformly (global or local) variables throughout a program.

;;; Exportations:
;;;                (rename! Program alist) : Program
;;; end of exportations.

(define-generic (rename! (o) r))

(define-method (rename! (o Program) r)
  (update-walk! rename! o r) )

(define-method (rename! (o Reference) r)
  (let ((v (assq (Reference-variable o) r)))
    (when (pair? v)
      (set-Reference-variable! o (cdr v)) ) )
  o )

(define-method (rename! (o Box-Creation) r)
  (let ((v (assq (Box-Creation-variable o) r)))
    (when (pair? v)
      (set-Box-Creation-variable! o (cdr v)) ) )
  (call-next-method) )

(define-method (rename! (o Global-Assignment) r)
  (let ((v (assq (Global-Assignment-variable o) r)))
    (when (pair? v)
      (set-Global-Assignment-variable! o (cdr v)) ) )
  (call-next-method) )

(define-method (rename! (o Function) r)
  (let ((newv* (map (lambda (var)
                      (let ((v (assq var r)))
                        (if (pair? v) (cdr v) var) ) )
                    (Function-variables o) )))
    (set-Function-variables! o newv*)
    (call-next-method) ) )

;;; No method on Predefined-Application: predefined variables do not change.

;;; end of rename.scm
