;;; $Id: rmseq.scm,v 1.1 1996/08/27 17:15:59 queinnec Exp $

;;; This analysis removes useless first term of Sequences. The
;;; A-normalization generates on Sequences new sequences looking like
;;; (begin X ...) which may be improved if the evaluation of X does
;;; not yield error.

;;; Exportation
;;;             (simplify-sequence! e)
;;; end of exportations

(define-generic (simplify-sequence! (e))
  (update-walk! simplify-sequence! e) )

(define-method (simplify-sequence! (e Sequence))
  (call-next-method)
  (if (and (Reference? (Sequence-first e))
           (always-initialized-reference? (Sequence-first e)) )
      (Sequence-last e)
      e ) )

(define-generic (always-initialized-reference? (e))
  #f )

(define-method (always-initialized-reference? (e Predefined-Reference))
  #t )

(define-method (always-initialized-reference? (e Global-Reference))
  (always-initialized-reference? (Global-Reference-variable e)) )

(define-method (always-initialized-reference? (e Global-Variable))
  (Global-Variable-initialized? e) )

(define-method (always-initialized-reference? (e Quotation-Variable))
  #t )
;;; inherited by all Linearized-Quotation-Variable

(define-method (always-initialized-reference? (e Local-Variable))
  #t )
;;; inherited by Renamed-Local-Variable

(define-method (always-initialized-reference? (e Predefined-Variable))
  #t )

(define-method (always-initialized-reference? (e Local-Reference))
  #t )
;;; inherited by Free-Local-Reference

;;; end of rmseq.scm
