;;; $Id: walk.scm,v 1.1.1.1 1995/06/20 17:15:30 queinnec Exp $

;;; This file defines the code-walker. It is not very general but
;;; sufficient for all the analyzes we wanted to add.

;;; Exportation: 
;;;                (update-walk! g o . args)
;;; End of exportations.

;;; The code-walker. It recursively applies the function G on any
;;; field of O provided its value is a Program (with additional
;;; arguments ARGS). The yielded value replaces the original field.

(define (update-walk! g o . args)
  (for-each (lambda (field)
              (let ((vf (field-value o field)))
                (when (Program? vf)
                  (let ((v (if (null? args) (g vf) (apply g vf args))))
                    (set-field-value! o v field) ) ) ) )                  
            (Class-fields (object->class o)) )
  o )

;;; end of walk.scm
