;;; $Id: rtbgl.scm,v 1.8 1996/08/29 16:54:13 queinnec Exp $

;;; This is the adaptation to Bigloo of the language of Icslas.

;;; The normal and error output ports.
  
(define stderr (current-error-port))
(define stdout (current-output-port))

;;; Icslas use the 'monitor' special form that is implemented as a macro
;;; in Scheme. The implementation should define two helper functions:
;;;   a protected-eval function
;;; 	(protected-eval thunk) computes the thunk and returns a vector 
;;;     of its value. If an error occurs, it returns a list describing
;;;     the error.
;;;   a protected-error function that signals an error to the underlying 
;;;     Scheme implementation.

;;; With Bigloo, use the try special form and if discovering an underlying
;;; Bigloo exception, diagnose it as a Underlying-Exception instance.
;;; It seems that the handler is invoked still protected by the same try.

(define (protected-eval thunk)
  (try (vector (thunk))
       (lambda (k proc msg obj)
         ;;(dump-lambda-stack)              ;; DEBUG
         (k (list proc msg obj)) ) ) )

(define (protected-error . e*)
  (error 'diagnose "uncaught exception" e*) )

;;; end of rtbgl.scm
