;;; $Id: glue.scm,v 1.14 1997/12/09 19:47:18 queinnec Exp $

;;; This file parameterizes and customizes Icslas wrt the underlying
;;; Scheme interpreter. 

(define objectify-error
  (create-compilation-exception-raiser 
   "Objectification" ) )

(define expand-error
  (create-compilation-exception-raiser 
   "Macroexpansion" ) )

(define syntax-check-error
  (create-compilation-exception-raiser 
   "Syntactic check" ) )

(define compile-error
  (create-compilation-exception-raiser 
   "Generation towards C" ) )

(define linearize-quotation-error
  (create-compilation-exception-raiser
   "Linearization of quotations" ) )

(define evaluate-error 
  (create-compilation-exception-raiser
   "Evaluation error" ) )

(define ->Scheme-error 
  (create-compilation-exception-raiser
   "Translating back to Scheme" ) )

(define Tree-Code-error
  (create-compilation-exception-raiser
   "Tree-Code'fication" ) )

(define Byte-Code-error
  (create-compilation-exception-raiser
   "Byte-Code'fication" ) )

(define Byte-Code-warning
  (create-compilation-warning-raiser
   "Byte-Code'fication" ) )

(define meroonet-error 
  (create-compilation-exception-raiser
   "Meroonet" ) )

(define walk-error
  (create-compilation-exception-raiser
   "Macroexpansion" ) )

(define tester-error
  (create-compilation-exception-raiser
   "Testing" ) )

(define compiler-error
  (create-compilation-exception-raiser
   "Compiling" ) )

;;;=================================================================

;;; This is the evaluator used for macroexpansion. Caution: it is not
;;; the Icslas evaluator but the eval function of the underlying Scheme.

(define expand-eval eval)

;;; end of utils.scm
