;;; $Id: prepare.scm,v 1.5 1995/07/01 18:15:52 queinnec Exp $

;;; This file defines the basic interface for all compilers. They take an
;;; expression, a global environment and they fill missing slots.
;;; It also defines some utility functions to deal with files.

(define-class Preparation Object
  ( original       ; the original Sexpression
    globalenv      ; the global environment
    (= extendible? ; a boolean telling if the global environment 
                   ; can be extended
       :initializer (lambda () #f) )
    prepared       ; the prepared program
    verbose?       ; a boolean telling the verbosity level (from #f to numbers)
    ) :virtual :maybe-uninitialized )

;;; This is the generic function that prepares a program. To prepare it,
;;; just allocate a preparation object with the original field containing
;;; the program to submit to prepare.

(define-generic (prepare (p Preparation)))

;;; end of prepare.scm
