;;; $Id: utils.scm,v 1.8 1997/12/09 19:47:18 queinnec Exp $

;;; Missing functions.

(if-icslas-feature (or Bigloo Bigloo++ Gambit Scheme2C OScheme Scm Icslas)
  (define (atom? e)
    (not (pair? e)) )
  )

(if-icslas-feature (or Bigloo Scheme2C Gambit OScheme Scm Icslas)
  (define (symbol-concatenate . names)
    (string->symbol
     (apply string-append
            (map (lambda (thing)
                   (cond ((symbol? thing)
                          (symbol->string thing) )
                         ((string? thing) thing)
                         ((number? thing)
                          (number->string thing) )
                         (else (internal-error
                                "non coercible to String"
                                thing )) ) )
                 names ) ) ) )
  )

(if-icslas-feature (or Scheme2C Scm Icslas)
  (define gensym
    (let ((counter 99))
      (lambda args
        (set! counter (+ counter 1))
        (symbol-concatenate (if (pair? args) (car args) 'G)
                            counter ) ) ) )
  )

(if-icslas-feature (or Bigloo Scheme2C Gambit OScheme Scm Icslas)
  (define (flat l)
    (define (flatten l r)
      (if (pair? l)
          (flatten (car l) (flatten (cdr l) r))
          (if (null? l)
              r
              (cons l r) ) ) )
    (flatten l '()) )
  )

(if-icslas-feature (or Scheme2C Slib Elk Gambit Guile Scm Icslas)
  (define (reverse! l)
    (define (nreverse l r)
      (if (pair? l)
          (let ((cdrl (cdr l)))
            (set-cdr! l r)
            (nreverse cdrl l) )
          r ) )
    (nreverse l '()) )
  )

(if-icslas-feature (or Scheme2C Slib Elk Gambit Scm Icslas)
  (define (append! l1 l2)
    (cond ((pair? l1)
           (if (pair? (cdr l1))
               (append! (cdr l1) l2)
               (set-cdr! l1 l2) )
           l1 )
          (else l2) ) )
    )

(if-icslas-feature (or Scm Gambit Icslas)
    (define (last-pair l)
      (if (pair? l)
          (let scan ((cdrl (cdr l)) (result l))
            (if (pair? cdrl)
                (scan (cdr cdrl) cdrl)
                result ) )
          (internal-error 'last-pair "Not a pair" l) ) )
    )

(define (string-uppercase string)
  (let* ((n (string-length string))
         (s  (make-string n)) )
    (do ((i 0 (+ i 1)))
        ((= i n) s)
      (string-set! s i (char-upcase (string-ref string i))) ) ) )

(define (string-lowercase string)
  (let* ((n (string-length string))
         (s  (make-string n)) )
    (do ((i 0 (+ i 1)))
        ((= i n) s)
      (string-set! s i (char-downcase (string-ref string i))) ) ) )

;;; These are variables needed if one wants to use a different reader
;;; for the programs to be analysed/compiled.

(if-icslas-feature (not Icslas)
  (begin
    (define %read read)
    (define preferred-case char-upcase) ) 
  )

;;; end of utils.scm
