;;; $Id: alldir.scm,v 1.2 1995/07/29 18:02:27 queinnec Exp $

;;; This file allows to extract all directories that contain sources. 

;;; Caution, this file is evaluated in the TARGET directory!
;;; NOTE: this file must not use macros at all to be portable.

;;; Load the configuration parameters. This configuration file is 
;;; generated in the TARGET directory.

(load "config.scm")

;;;==================================================================
;;; Load some utilities

(load (string-append TOP "/Bootstrap/filutl.scm"))

;;;==================================================================
;;; Load the processor of Icslas sources.

(load (string-append TOP "/icslas.scm"))

;;; Load the precise features describing what must be generated.  This
;;; file should have already be generated in the TARGET/Bootstrap
;;; directory.

(load "Bootstrap/features.scm")

;;;==================================================================
;;; Two auxiliary files are generated.
;;; Tmp/modules is the sequence of all processed files.
;;; Tmp/directories is the sequence of all directories.

(define *modules* '())

(define (generate-tmp-modules modules)
  (call-with-output-file "Tmp/modules"
    (lambda (out)
      (for-each (lambda (basefile)
                  (display basefile out)
                  (newline out) )
                modules ) ) ) )

(define (generate-tmp-directories modules)
  (call-with-output-file "Tmp/directories"
    (lambda (out)
      (for-each (lambda (basefile)
                  (display (extract-directory basefile) out)
                  (newline out) )
                modules ) ) ) )

;;;==================================================================
;;; Everything is ready: process every source files (due to
;;; process-icslas-sources, they are processed in order which is very
;;; convenient for state-macros).

(define (work)
  (process-icslas-sources
   icslas-features
   (lambda (basefile)
     (set! *modules* (cons basefile *modules*)) ) )
  ;; Put module names in order
  (set! *modules* (reverse *modules*))
  ;; Generate auxiliary files
  (generate-tmp-modules *modules*)
  (generate-tmp-directories *modules*)
  (display "all names and directories extracted.")
  (newline) )

;;; Test: (work)

;;; end of alldir.scm
