;;; $Id: mksngl.scm,v 1.1 1995/07/29 12:06:25 queinnec Exp $

;;; This file builds the initial image of the ByteCode interpreter.
;;; It reads all necessary files, expands them, compiles them towards
;;; bytecode and converts the resulting .xlo file into C.

;;; Caution, this file is evaluated in the TARGET directory!

;;; Load the configuration parameters. This configuration file is 
;;; generated in the TARGET directory.

(load "config.scm")

;;; Load expfil.scm which is required to neutrally expand files.

(load (string-append TOP "/Bootstrap/expfil.scm"))
(load (string-append TOP "/Bootstrap/filutl.scm"))

;;; To be able to use file->list.

(define %read read)

;;; Define precisely what features are required.

(set! icslas-features
      '( AddLibrary
         Meroonet ;; later will become:       DMeroonet
         TraditionalMacros
         ByteCode
         ;; debug              ; TEMP
         ;; Icslas             ; Conditionalize wrt this language.
         ) )

;;;==================================================================
;;; Neutrally expand every source file and gather all expressions into 
;;; a single Sexp.

(define (generate-single)
  ;; neutrally expand all files into .SCM files
  (work)
  ;; gather all bodies of .SCM files
  (let ((bodies '()))
    (process-icslas-sources
     icslas-features
     (lambda (basefile)
       (set! bodies 
             (cons `(begin . ,(file->list (string-append basefile ".SCM")))
                   bodies ) )
       (newline) ) )
    ;; write it
    (call-with-output-file (string-append "Tmp/single.scm")
      (lambda (out)
        (write-flattening-begin-forms 
         `(begin . ,(reverse bodies))
         out ) ) ) )
  #t )
;;; Test: (generate-single)

;;; end of mksngl.scm
