;;; $Id: BCpred.scm,v 1.7 1997/03/27 19:55:24 queinnec Exp $

;;; This file defines the indexes defining the primitives of Icslas.
;;; This must be the same as the ones used by the ByteCode interpreter
;;; written in C. It is rather similar to BCenv.scm except that it
;;; does not define values but fixes the indexes.

;;; Create the predefined environment to be used by the ByteCode compiler.
;;; This should really be an Hashtable to speedup variable lookup.

(define g.icslas '())

(define-icslas-macro (defvalue name code)
  `(begin 
     (set! g.icslas
           (cons (make-BC-Predefined-Variable 
                  ',name 
                  #f 
                  ,code )
                 g.icslas ) )
     ',name ) )

;;; This is how to define a function.

(define-icslas-macro (deffunction name comparator arity code)
  `(begin
     (set! g.icslas 
           (cons (make-BC-Predefined-Variable
                  ',name
                  (make-Functional-Description ,comparator ,arity)
                  ,code )
                 g.icslas ) )
     ',name ) )

;;; Comparators are =, >= or or=or=+1

(define (or=or=+1 arguments-number arity)
  (or (= arguments-number arity)
      (= arguments-number (+ arity 1)) ) )

;;; The definitions appear in file predenv.scm so you can compile the
;;; BCpred.scm file and still dynamically change the predefined env.

;;; end of BCpred.scm
