/* $Id: xlamain.c,v 1.14 1997/03/27 19:55:35 queinnec Exp $ 
 * This is for test purpose
 */

#include "xla.h"

/* This is the reference to an external module that will be interpreted.
 */

extern DMeroon_object DM_external_module_object;

static
void DM_finish (DM_SupportPointer wrapped_thread) {
  DM_Thread *thread = DM_FromSupport(wrapped_thread);

  DM_show_object(DM_ToSupport(thread->val), 
                 (DM_SupportPointer)stdout );
  fprintf(stdout,"\n");
  exit(0);
}

static
DM_InternalContinuation_wrapped DM_initial_continuation_object = {
  DM_SupportPrefixInitialization(DM_InternalContinuation_wrapped,
                                 DM_initial_continuation_object)
  DM_ReferenceToClass(InternalContinuation),
  DM_ProxyInitialization(),
  { { {
    DM_ReferenceTo(DM_initial_continuation), /* Hack ? */
    DM_CodeOf(DM_finish)
  } } }
};

static
DM_Thread_wrapped initial_thread_object = {
  DM_SupportPrefixInitialization(DM_Thread_wrapped,
                                 DM_initial_thread_object)
  DM_ReferenceToClass(Thread),
  DM_ProxyInitialization(),
  { { {
    DM_ReferenceTo(DM_user),
    DM_TheConstant(uninitialized),             /* ModuleEnvironment (to be filled) */
    DM_ReferenceTo(DM_null_environment),
    0,                                  /* initial pc */
    DM_ReferenceTo(DM_unspecified),     /* val register */
    DM_ReferenceTo(DM_initial_continuation),
    DM_ReferenceTo(initial_thread),     /* left thread */
    DM_ReferenceTo(initial_thread)      /* right thread */
  } } }
};

int
main(int argc, char (*argv)[]) {

  /* activate the trace */
  DM_trace = 0;
  if ( argc>1 ) DM_trace = 1;

  /* First initialize DMeroon and its Icslas binding. */
  DM_initialize();
  DM_xlaenv_initialize();
  DM_xlaobj_initialize();

  /* Start Icslas. */
  { DM_User   *user   = (DM_User*)(DM_ReferenceTo(DM_user));
    DM_Thread *thread = (DM_Thread*)(DM_ReferenceTo(initial_thread));
    DM_Module *test   = (DM_Module*)(DM_ReferenceTo(DM_external_module));
    DM_SupportPointer wrapped_user   = DM_ToSupport(user);
    DM_SupportPointer wrapped_thread = DM_ToSupport(thread);
    DM_SupportPointer wrapped_test   = DM_ToSupport(test);
    
    thread->genv = 
      DM_FromSupport(DM_link_module(wrapped_user, wrapped_test));
    DM_byte_eval(wrapped_thread);
  }
}

/* end of xlamain.c */
