;;; $Id: ctest.scm,v 1.4 1995/07/28 19:36:55 queinnec Exp $

;;; This file allow to test the ByteCompiler with the C ByteCode interpreter.

;;; Caution, this file is evaluated in the TARGET directory!

;;; Load the configuration parameters. This configuration file is
;;; generated in the TARGET directory.

(load "config.scm")

;;; Load what is necessary for the ByteCode compiler e tutti quanti...

(load (string-append TOP "/ByteCode/mkcodop.scm"))
(load (string-append TOP "/ByteCode/mkcmod.scm"))

;;;==================================================================
;;; Define the main test function.

;;; There are some tests that must be skipped.
;;; Global variables are automatically created so tests trying to read the 
;;; value of xyzzy may be left. The one that sets xyzzy must be removed.
;;; The two using set-car! or set-cdr! are removed for Icslas that prefers
;;; immutability.

(define *tests-to-skip*
  '( 
    ;; XYZZY related tests.
    ;;xyzzy 
    (set! xyzzy 3)
    ;;((lambda (x y) xyzzy) 1 2)
    
    ;; By default, pairs are immutable
    (begin (set! a (cons 'a b)) (set-car! a 'c) a)
    (begin (set! a (cons 'a b)) (set-cdr! a 'd) a)
    ) )

(define (test-bci file)
  (suite-test
   file
   "Icslas? "
   ""
   #t
   (lambda (read-test check err)
     (define-method (icslas-handler (exc Exception) c?) (err exc))
     (lambda ()
       (monitor icslas-handler
         (let ((e (read-test)))
           ;; skip that tests
           (if (member e *tests-to-skip*)
               (err '***)
               (let ((result (test-compile-run e)))
                 (if (eof-object? result)
                     (err '***)
                     (check result) ) ) ) ) ) ) )
   equal? ) )
;;; Test: (test-bci (string-append TOP "/Test/scheme.tst"))

(define (test-compile-run e)
  (let* ((exp (icslas-expand e))
         (bc  (compile->Byte-code "test" exp g.icslas))
         (bm (Byte-Compilation->BCRT-Module bc)) )
    (Byte-Compilation->file bc "Test/test.xlo") ; DEBUG
    (display (BCRT-disassemble bm))(newline)    ; DEBUG
    (call-with-output-file "Test/test.c"
      (lambda (out)
        (BCRT-Module->C-file bm out) ) )
    (system "make test.bc.test")
    (call-with-input-file "Test/test.out" read) ) )

;;; end of ctest.scm
