;;; $Id: predenv.scm,v 1.2 1997/08/17 19:30:46 queinnec Exp $

;;; {{{ Predefined variables
;;; This is the definition of the predefined immutable global Scheme
;;; environment. They use macros defined in BCpred.scm. 

;;; These are the constants.

;(defvalue f 			0)
;(defvalue t 			1)
(defvalue nil 			2)
(defvalue unspecified 		3)
(defvalue end-of-file 		4)

;;; These are DMeroon constants.

(defvalue <Char1>			300)
(defvalue <Char1.value>			301)
(defvalue <MutablePair>			302)
(defvalue <MutablePair.value>		303)
(defvalue <MutablePair.rest>		304)
(defvalue <ImmutablePair>		305)
(defvalue <ImmutablePair.value>		306)
(defvalue <ImmutablePair.rest>		307)
(defvalue <Symbol>			308)
(defvalue <MutableString>		310)
(defvalue <MutableString.character>	311)
(defvalue <ImmutableString>		312)
(defvalue <ImmutableString.character>	313)
(defvalue <MutableVector>		314)
(defvalue <MutableVector.item>		315)
(defvalue <ImmutableVector>		316)
(defvalue <ImmutableVector.item>	317)

(defvalue <Number>			320)
(defvalue <Boolean>			321)
(defvalue <True>			322)
(defvalue <False>			323)
;; <Function>           324
(defvalue <Continuation>		325)
(defvalue <Anomaly>			326)
(defvalue <Anomaly.code>		327)
(defvalue <Anomaly.msg>			328)
(defvalue <Module>			329)
(defvalue <Module.name>			330)
(defvalue <Port>			331)
(defvalue <InputPort>			332)
(defvalue <InputPort.poken>		333)
(defvalue <OutputPort>			334)
(defvalue <ImmutableByteVector>		335)
(defvalue <ImmutableByteVector.item>	336)

;;; Long series of functions. 
;;; Not all of them are predefined but their index is reserved.

(deffunction boolean? = 1 			10)
(deffunction not = 1 				11)
(deffunction eqv? = 2 				12)
(deffunction eq? = 2 				13)
(deffunction equal? = 2 			14)
(deffunction pair? = 1 				15)
(deffunction cons = 2 				16)
(deffunction car = 1 				17)
(deffunction cdr = 1 				18)
(deffunction set-car! = 2 			19)
(deffunction set-cdr! = 2 			20)
(deffunction caar = 1 				21)
(deffunction cadr = 1 				22)
(deffunction cdar = 1 				23)
(deffunction cddr = 1 				24)
(deffunction caaar = 1 				25)
(deffunction caadr = 1 				26)
(deffunction cadar = 1 				27)
(deffunction caddr = 1 				28)
(deffunction cdaar = 1 				29)
(deffunction cdadr = 1 				30)
(deffunction cddar = 1 				31)
(deffunction cdddr = 1 				32)
(deffunction caaaar = 1 			33)
(deffunction caaadr = 1 			34)
(deffunction caadar = 1 			35)
(deffunction caaddr = 1 			36)
(deffunction cadaar = 1 			37)
(deffunction cadadr = 1 			38)
(deffunction caddar = 1 			39)
(deffunction cadddr = 1 			40)
(deffunction cdaaar = 1 			41)
(deffunction cdaadr = 1 			42)
(deffunction cdadar = 1 			43)
(deffunction cdaddr = 1 			44)
(deffunction cddaar = 1 			45)
(deffunction cddadr = 1 			46)
(deffunction cdddar = 1 			47)
(deffunction cddddr = 1 			48)
(deffunction null? = 1 				49)
(deffunction list? = 1 				50)
(deffunction list >= 0 				51)
(deffunction length = 1 			52)
(deffunction append >= 0 			53)
(deffunction reverse = 1 			54)
(deffunction list-tail = 2 			55)
(deffunction list-ref = 2 			56)
(deffunction memq = 2 				57)
(deffunction memv = 2 				58)
(deffunction member = 2 			59)
(deffunction assq = 2 				60)
(deffunction assv = 2 				61)
(deffunction assoc = 2 				62)
(deffunction symbol? = 1 			63)
(deffunction symbol->string = 1 		64)
(deffunction string->symbol = 1 		65)
(deffunction integer? = 1 			66)
(deffunction rational? = 1 			67)
(deffunction real? = 1 				68)
(deffunction complex? = 1 			69)
(deffunction number? = 1 			70)
(deffunction exact? = 1 			71)
(deffunction inexact? = 1 			72)
(deffunction = >= 2 				73)
(deffunction < >= 2 				74)
(deffunction > >= 2 				75)
(deffunction <= >= 2 				76)
(deffunction >= >= 2 				77)
(deffunction zero? = 1 				78)
(deffunction positive? = 1 			79)
(deffunction negative? = 1 			80)
(deffunction odd? = 1 				81)
(deffunction even? = 1 				82)
(deffunction max >= 1 				83)
(deffunction min >= 1 				84)
(deffunction + >= 0 				85)
(deffunction - >= 0 				86)
(deffunction * >= 0 				87)
(deffunction / >= 1 				88)
(deffunction abs = 1 				89)
(deffunction quotient = 2 			90)
(deffunction remainder = 2 			91)
(deffunction modulo = 2 			92)
(deffunction gcd >= 0 				93)
(deffunction lcm >= 0 				94)
(deffunction numerator = 1 			95)
(deffunction denominator = 1 			96)
(deffunction floor = 1 				97)
(deffunction ceiling = 1 			98)
(deffunction truncate = 1 			99)
(deffunction round = 1 				100)
(deffunction rationalize = 2 			101)
(deffunction sqrt = 1 				102)
(deffunction expt = 2 				103)
(deffunction make-rectangular = 2 		104)
(deffunction make-polar = 2 			105)
(deffunction real-part = 1 			106)
(deffunction imag-part = 1 			107)
(deffunction angle = 1 				108)
(deffunction exact->inexact = 1 		109)
(deffunction inexact->exact = 1 		110)
(deffunction number->string = 1 		111)
(deffunction string->number or=or=+1 1 		112)
(deffunction char? = 1 				113)
(deffunction char=? = 1 			114)
(deffunction char<? = 1 			115)
(deffunction char>? = 1 			116)
(deffunction char<=? =  1 			117)
(deffunction char>=? = 1 			118)
(deffunction char=-ci? = 1 			119)
(deffunction char<-ci? = 1 			120)
(deffunction char>-ci? = 1 			121)
(deffunction char<=-ci? =  1 			122)
(deffunction char>=-ci? = 1 			123)
(deffunction char-alphabetic? = 1 		124)
(deffunction char-numeric? = 1 			125)
(deffunction char-whitespace? = 1 		126)
(deffunction char-upper-case? = 1 		127)
(deffunction char-lower-case? = 1 		128)
(deffunction char->integer = 1 			129)
(deffunction integer->char = 1 			130)
(deffunction char-upcase = 1 			131)
(deffunction char-downcase = 1 			132)
(deffunction string? = 1 			133)
(deffunction make-string or=or=+1 1 		134)
(deffunction string >= 0 			135)
(deffunction string-length = 1 			136)
(deffunction string-ref = 2 			137)
(deffunction string-set! = 3 			138)
(deffunction string=? = 1 			139)
(deffunction string<? = 1 			140)
(deffunction string>? = 1 			141)
(deffunction string>=? = 1 			142)
(deffunction string<=? = 1 			143)
(deffunction string=-ci? = 1 			144)
(deffunction string<-ci? = 1 			145)
(deffunction string>-ci? = 1 			146)
(deffunction string>=-ci? = 1 			147)
(deffunction string<=-ci? = 1 			148)
(deffunction substring = 3 			149)
(deffunction string-append >= 0 		150)
(deffunction string->list = 1 			151)
(deffunction list->string = 1 			152)
(deffunction string-copy = 1 			153)
(deffunction string-fill! = 2 			154)
(deffunction vector? = 1 			155)
(deffunction make-vector or=or=+1 1 		156)
(deffunction vector >= 0 			157)
(deffunction vector-length = 1 			158)
(deffunction vector-ref = 2 			159)
(deffunction vector-set! = 3 			160)
(deffunction vector->list = 1 			161)
(deffunction list->vector = 1 			162)
(deffunction vector-fill! = 2 			163)
(deffunction procedure? = 1 			164)
(deffunction apply >= 2 			165)
(deffunction map >= 2 				166)
(deffunction for-each >= 2 			167)
(deffunction force = 1 				168)
(deffunction call/cc = 1 			169)
(deffunction call-with-input-file = 2 		170)
(deffunction call-with-output-file = 2 		171)
(deffunction with-input-file = 2 		172)
(deffunction with-output-file = 2 		173)
(deffunction input-port? = 1 			174)
(deffunction output-port? = 1 			175)
(deffunction current-input-port = 0 		176)
(deffunction current-output-port = 0 		177)
(deffunction open-input-file = 1 		178)
(deffunction open-output-file = 1 		179)
(deffunction close-input-port = 1 		180)
(deffunction close-output-port = 1 		181)
(deffunction read or=or=+1 0 			182)
(deffunction read-char or=or=+1 0 		183)
(deffunction peek-char or=or=+1 0 		184)
(deffunction eof-object? = 1 			185)
(deffunction char-ready? or=or=+1 0 		186)
(deffunction write or=or=+1 1 			187)
(deffunction display or=or=+1 1 		188)
(deffunction newline or=or=+1 0 		189)
(deffunction write-char or=or=+1 1 		190)
(deffunction load = 1 				191)
(deffunction transcript-on = 1 			192)
(deffunction transcript-off = 0 		193)

;;; DMeroon primitives

(deffunction is-a = 2				254)
(deffunction class-of = 1			255)

;;; }}}
;;; {{{ Names correspondance

;;; These are the names that correspond to functions that are not
;;; predefined in C. They will be defined in Scheme in the bootstrap
;;; process. This variable is defined in mkcmod.scm

(set! *ignored-names*
  '( caar cadr cdar cddr
     caaar caadr cadar caddr cdaar cdadr cddar cdddr
     caaaar caaadr caadar caaddr cadaar cadadr caddar cadddr
     cdaaar cdaadr cdadar cdaddr cddaar cddadr cdddar cddddr
     equal? list? length append reverse list-tail list-ref 
     memq memv member assq assv assoc 
     rational? exact? inexact? zero? positive? negative?
     odd? even? max min abs gcd lcm numerator denominator 
     rationalize make-rectangular make-polar real-part imag-part
     angle exact->inexact inexact->exact number->string string->number
     char=? char>? char<? char>=? char<=? 
     char=-ci? char>-ci? char<-ci? char>=-ci? char<=-ci? 
     char-numeric? char-alphabetic? char-whitespace?
     char-upper-case? char-lower-case? char->integer integer->char
     char-upcase char-downcase string-length string-ref string-set!
     string=? string>? string<? string>=? string<=? 
     string=-ci? string>-ci? string<-ci? string>=-ci? string<=-ci? 
     complex? substring string-append string->list list->string
     string-fill! vector-length vector-ref vector-set! 
     vector->list list->vector vector-fill! 
     map for-each force call-with-input-file call-with-output-file
     with-input-file with-output-file 
     read read-char peek-char eof-object? char-ready? write 
     newline write-char
    load 
    transcript-on
    transcript-off
    ) )

;;; This is the Alist mapping Scheme names to C-written Icslas
;;; predefined functions or values. It will be dynamically read by
;;; mkcmod.scm. If you change it, you don't need to recompile the
;;; compiler. This variable is defined in mkcmod.scm

(set! *predefined-translations*
      '(  (eq? . "eq")
          (eqv? . "eqv")
          (+ . "plus")
          (- . "difference")
          (* . "times")
          (/ . "divide")
          (=  . "binary_numeric_equal") ; TEMP (should rather be nary).
          (>= . "binary_numeric_greater_equal") ; TEMP
          (<= . "binary_numeric_less_equal") ; TEMP
          (>  . "binary_numeric_greater") ; TEMP
          (<  . "binary_numeric_less")  ; TEMP
          (boolean? . "is_boolean")
          (pair? . "is_pair")
          (null? . "is_null")
          (list? . "is_list")
          (symbol? . "is_symbol")
          (integer? . "is_integer")
          (rational? . "is_rational")
          (real? . "is_real")
          (complex? . "is_complex")
          (number? . "is_number")
          (exact? . "is_exact")
          (inexact? . "is_inexact")
          (char? . "is_char")
          (string? . "is_string")
          (vector? . "is_vector")
          (procedure? . "is_procedure")
          (input-port? . "is_input_port")
          (output-port? . "is_output_port")
          (eof-object? . "is_eof_object")

          ;; DMeroon names

          (<Char1> . "Char1_class")
          (<Char1.value> . "Char1_value_field")
          (<MutablePair> . "MutablePair_class")
          (<MutablePair.value> . "MutablePair_value_field")
          (<MutablePair.rest> . "MutablePair_rest_field")
          (<ImmutablePair> . "ImmutablePair_class")
          (<ImmutablePair.value> . "ImmutablePair_value_field")
          (<ImmutablePair.rest> . "ImmutableLink_rest_field");; !?
          (<Symbol> . "Symbol_class")
          (<MutableString> . "MutableString_class")
          (<MutableString.character> . "MutableString_character_field")
          (<ImmutableString> . "String_class")
          (<ImmutableString.character> . "String_character_field")
          (<MutableVector> . "MutableVector_class")
          (<MutableVector.item> . "MutableVector_item_field")
          (<ImmutableVector> . "ImmutableVector_class")
          (<ImmutableVector.item> . "ImmutableVector_item_field")
          (<ImmutableByteVector> . "ImmutableByteVector_class")
          (<ImmutableByteVector.item> . "ImmutableByteVector_item_field")
          (<Fixnum> . "Fixnum_class")
          (<Floatnum> . "Floatnum_class")
          (<Number> . "Number_class")
          (<Boolean> . "Boolean_class")
          (<True> . "True_class")
          (<False> . "False_class")
          ;;(<Function> . "Function_class") ; not implemented yet.
          (<Continuation> . "Continuation_class")
          (<Anomaly> . "Anomaly_class")
          (<Anomaly.code> . "Anomaly_code_field")
          (<Anomaly.msg> . "Anomaly_msg_field")
          (<Module> . "Module_class")
          (<Module.name> . "Module_name_field")
          (<Port> . "Port_class")
          (<InputPort> . "InputPort_class")
          (<InputPort.poken> . "InputPort_poken_field")
          (<OutputPort> . "OutputPort_class")

          ;; DMeroon functions                   FUTURE

          ) )

;;; }}}

;;; end of predenv.scm
