;;; $Id: Cdynqu.scm,v 1.1 1995/06/20 18:23:46 queinnec Exp $

;;; This files compiles Linearized quotations into C code that will be
;;; dynamically run when the file is begun.      NOT FINISHED.

(define (generate-quotations prg out)                               ; NEW
  (let ((lqv*  (Linearized-Flattened-Program-linearizations prg)))
    (when (pair? lqv*)
      (format out "~%/* Quotations: */~%")
      (for-each (lambda (lqv) (->C lqv out)) lqv*)   ; TEMP
      (reserve-quotation-global-variables prg out) )
    (format out "~%void SCM_initialize_quotations(void) {~%")
    (when (pair? lqv*)
      (->C (Linearized-Flattened-Program-initialization prg) out) )
    (format out ";~%}~%") ) ) )

(define (reserve-quotation-global-variables prg out)
  (for-each (lambda (qv) 
              (format out "SCM quotation~A;~%"
                      (Quotation-variable-name qv) ) )
            (Linearized-Flattened-Program-quotations prg) )
  ''(for-each (lambda (lqv)                                    ; TEMP
              (format out "SCM thing~A;~%"
                      (Quotation-variable-name lqv) ) )
            (Linearized-Flattened-Program-quotations prg) ) )

(define-method (->C (qv Cons-Quotation-Variable) out)
  (let ((aqv (Cons-Quotation-Variable-car qv))
        (dqv (Cons-Quotation-Variable-cdr qv)) )
    (format out "thing~A=SCM_cons(thing~A,thing~A);  /* ~S */~%"
            (Quotation-Variable-name qv)
            (Quotation-Variable-name aqv)
            (Quotation-Variable-name dqv)
            (Quotation-Variable-value qv) ) ) )

(define-method (->C (qv Immediate-Quotation-Variable) out)
  (let ((value (Quotation-Variable-value qv))
        (index (Quotation-Variable-name qv)) )
    (cond ((null? value)
           (format out "thing~A=SCM_nil;~%" index) )
          ((boolean? value)
           (format out "thing~A=~A;	/* ~S */~%"
                   index (if value "SCM_true" "SCM_false") value ) )
          ((integer? value)
           (format out "thing~A=SCM_Int2fixnum(~A)~%"
                   index value ) )
          ((string? value)
           (format out "thing~A=SCM_Cstring2SCMstring(\"~A\");~%"
                   index value ) )
          (else (compiler-error "Unknown quotation value" value)) ) ) )

(define-method (->C (qv Symbol-Quotation-Variable) out)
  (let ((strqv (Symbol-Quotation-Variable-string qv)))
    (format out "thing~A=SCM_string2symbol(thing~A);       /* ~S */~%"
            (Quotation-Variable-name qv)
            (Quotation-Variable-name strqv)
            (Quotation-Variable-value qv) ) ) )

(define (generate-main prg out)
  (let ((form (Flattened-Program-body prg)))
    (format out "~%/* Expression: */~%void main(void) {~%")
    (format out "  SCM_initialize_quotations();~%")           ; NEW
    (format out "  SCM_print")
    (between-parentheses out
      (->C form out) )
    (format out ";~%  exit(0);~%}~%") ) )

;;; end of Cdynqu.scm
