#! /bin/sh
# This script should be started with nohup from the TARGET directory,
# something like:
#      nohup ~/icslas/DMeroon/Commands/dmeroond.sh &
# Statistics are produced in /usr/local/DMeroon/statistics.
# $Id: dmeroond.sh,v 1.4 1996/11/27 18:52:05 queinnec Exp $

# Load configuration parameters.

if [ -f config.sh ]
then  . config.sh
else 
        echo "You are probably not in the TARGET directory."
        exit 1
fi

# This is the absolute path naming a DMeroon executable. Their name is
# generally made of the name of the binding language followed by
# +DMeroon. 

eval "DMEROON_SERVER=`ls -t ${TARGET}/*+DMeroon | head -1`"

# The file that contains the pid of the DMeroon daemon.

PIDFILE=dmeroond.pid

# Install trapper for normal exit and TERM signal.

trap "rm -f ${PIDFILE} ; exit 0" 0
trap "logger -t DMeroon -i -p user.info Restarting ${DMEROON_SERVER} ;\
      if kill -9 `cat ${PIDFILE}` ;\
      then rm -f ${PIDFILE} ;\
      else exit 0 ;\
      fi" 15

# Erase possible remains. Delete the oldest log file.

if [ -f ${PIDFILE} ] 
then rm ${PIDFILE}
fi
touch dmeroond.log$$
rm -f ` ls -t dmeroond.log* | tail -1 `

# Start a DMeroon server, perform statistics and keep 100 last lines.

( ${DMEROON_SERVER} -linger 2>&1 &
  echo $! > ${PIDFILE}
  ) | ${TOP}/DMeroon/Commands/stat.prl -tee \
    | ${TOP}/DMeroon/Commands/keep.prl dmeroond.log$$ 100

# end of dmeroond.sh
