;;; $Id: api.tst,v 1.6 1997/02/28 19:50:52 queinnec Exp $

;;; Tests for the api.scm file that implements the higher level API.
;;; For now it only tests local properties and nothing needing a
;;; remote site.

(DM-initialize!)
   ---

(DM-is-object? (DM-initialize!))
   #t
(DM-is-object? #t)
   #f

;;; arguments must be DMeroon objects.
(DM-is-a? DM-nil DM-Site-class)
   #f
(DM-is-a? (DM-initialize!) DM-Site-class)
   #t

(eq? (DM-class-of (DM-initialize!))
     DM-Site-class )
   #t

(DM-is-initialized? (DM-allocate DM-MutableVector-class 3))
   #f
(DM-is-initialized? (DM-set-sharable! (DM-allocate DM-MutableVector-class 0)))
   #t
(DM-set-sharable!
 (DM-set-sharable! 
  (DM-allocate DM-MutableVector-class 0)))
   ---
;;; Same with set-copyable
(DM-is-initialized? (DM-set-copyable! (DM-allocate DM-MutableVector-class 0)))
   #t
(DM-set-copyable!
 (DM-set-copyable! 
  (DM-allocate DM-MutableVector-class 0)))
   ---


;;; Field access
(DM-is-a? (DM-field-value DM-site DM-Site-name-field)
          DM-String-class )
   #t
(DM-is-a? (DM-field-value DM-Class-class DM-Class-field-field 1)
              DM-Field-class )
   #t
(eq? DM-Class-options-field 
     (DM-field-value DM-Class-class DM-Class-field-field 1) )
   #t
(DM-set-field-value! DM-nil DM-Class-class DM-Class-field-field 1)
   *** ; immutable field

;;; reading an not yet initialized instance
(DM-field-value (DM-allocate DM-MutableVector-class 3)
                DM-MutableVector-item-field
                1 )
   *** ; not yet initialized instance
(DM-field-value (let ((o (DM-allocate DM-MutableVector-class 3)))
                  (DM-set-field-value! DM-nil o DM-MutableVector-item-field 1)
                  o )
                DM-MutableVector-item-field
                1 )
   *** ; not yet initialized instance (even if the field is)
(DM-field-value (let ((o (DM-allocate DM-MutableVector-class 1)))
                  (DM-set-field-value! DM-nil o DM-MutableVector-item-field 0)
                  (DM-set-sharable! o)
                  o )
                DM-MutableVector-item-field
                0 )
   ---

;;; 13 XII 95 non portable because of paving.
;(let ((o (DM-allocate DM-MutableVector-class 3)))
;  (DM-set-sharable! o) )
;   *** ; object not yet initialized
;(let ((o (DM-allocate DM-MutableVector-class 3)))
;  (DM-set-field-value! o o DM-MutableVector-item-field 0)
;  (DM-set-sharable! o) )
;   *** ; object still not yet initialized
(let ((o (DM-allocate DM-MutableVector-class 3)))
  (DM-set-field-value! o o DM-MutableVector-item-field 0)
  (DM-set-field-value! o o DM-MutableVector-item-field 2)
  (DM-set-field-value! o o DM-MutableVector-item-field 1)
  (DM-set-sharable! o) )
   ---
(let ((o (DM-allocate DM-MutableVector-class 3)))
  (DM-set-field-value! o o DM-MutableVector-item-field 0)
  (DM-set-field-value! o o DM-MutableVector-item-field 2)
  (DM-set-field-value! o o DM-MutableVector-item-field 1)
  (DM-set-sharable! o)
  (DM-set-field-value! DM-nil o DM-MutableVector-item-field 2) )
   ---
(let ((o (DM-allocate DM-ImmutableVector-class 3)))
  (DM-set-field-value! o o DM-ImmutableVector-item-field 0)
  (DM-set-field-value! o o DM-ImmutableVector-item-field 2)
  (DM-set-field-value! o o DM-ImmutableVector-item-field 1)
  (DM-set-sharable! o)
  (DM-set-field-value! DM-nil o DM-ImmutableVector-item-field 2) )
   *** ; immutable field

;;; Associating clocks to objects.
(let ((clock (DM-make DM-Clock-class 0 0))
      (o     (DM-make DM-MutableVector-class 1 DM-nil)) )
  (DM-set-clock-of! o clock) )
   ---
(let ((clock (DM-make DM-Clock-class 0 0))
      (o     (DM-make DM-ImmutableVector-class 1 DM-nil)) )
  (DM-set-clock-of! o clock) )
   *** ; immutable objects don't need clocks.
(let ((clock (DM-make DM-Clock-class 0 0))
      (o     (DM-allocate DM-MutableVector-class 1)) )
  (DM-set-clock-of! o clock) )
   *** ; not yet initialized objects cannot be monitored by clocks.

;;; changing clock
(let ((clock1 (DM-make DM-Clock-class 0 0))
      (clock2 (DM-make DM-Clock-class 11 0))
      (o      (DM-make DM-MutableVector-class 1 DM-nil)) )
  (DM-set-clock-of! o clock1)
  (DM-set-clock-of! o clock2)
  (cons (DM-field-value clock1 DM-Clock-time-field)
        (DM-field-value clock2 DM-Clock-time-field) ) )
   (1 . 11)

;;; Getting sites.
(eq? (DM-initialize!) (DM-site-of DM-nil))
   #t
(DM-set-site-of! (DM-make DM-MutableVector-class 1 DM-nil)
                     (DM-initialize!) )
   ---


" *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                      All api.tst tests successfully run!
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***"
   ---

;;; end of api.tst
