;;; $Id: code.tst,v 1.11 1995/09/11 18:21:10 queinnec Exp $
;;; This file tests the encoding/decoding process.


;;; Create a class with all types.
(define Testf-class
  (DM-create-class "Testf" DM-Object-class 25
   "-field" "nat1" "-type" DM-nat1-type "-mutable"
   "-field" "nat2" "-type" DM-nat2-type "-mutable"
   "-field" "nat3" "-type" DM-nat3-type "-mutable"
   "-field" "nat4" "-type" DM-nat3-type "-mutable"
   "-field" "int1" "-type" DM-int1-type "-mutable"
   "-field" "int2" "-type" DM-int2-type "-mutable"
   "-field" "int3" "-type" DM-int3-type "-mutable"
   "-field" "int4" "-type" DM-int3-type "-mutable"
   "-field" "int1" "-type" DM-int1-type "-mutable"
   "-field" "int2" "-type" DM-int2-type "-mutable"
   "-field" "int3" "-type" DM-int3-type "-mutable"
   "-field" "int4" "-type" DM-int3-type "-mutable"
   "-field" "char1" "-type" DM-char1-type "-mutable"
   "-field" "netnat2" "-type" DM-netnat2-type "-mutable"
   "-field" "netnat3" "-type" DM-netnat3-type "-mutable"
   "-field" "float1" "-type" DM-float1-type "-mutable"
   "-field" "float2" "-type" DM-float2-type "-mutable"
   "-field" "float1" "-type" DM-float1-type "-mutable"
   "-field" "float2" "-type" DM-float2-type "-mutable"
   "-field" "float1" "-type" DM-float1-type "-mutable"
   "-field" "float2" "-type" DM-float2-type "-mutable"
   "-field" "float1" "-type" DM-float1-type "-mutable"
   "-field" "float2" "-type" DM-float2-type "-mutable"
   "-field" "float1" "-type" DM-float1-type "-mutable"
   "-field" "float2" "-type" DM-float2-type "-mutable" ) )
   ---
;;; Test encode/decode on this class.
(let ()
  (define c 1)
  (define b 2)
  (define o 3)
  (set! b (DM-allocate DM-Buffer-class 64))
  (set! c (DM-make DM-Connection-class
                   0 5 0   ; 
                   0 0 0 0 ; sockaddr
                   0 0 b b ))
  (set! o (DM-make Testf-class
                   11 
                   #x1234
                   #x12345678
                   #x12345678  ; nat4
                   11 
                   #x1234
                   #x12345678
                   #x12345678  ; int4
                   (- 11)
                   (- #x1234)
                   (- #x12345678)
                   (- #x12345678)  ; int4
                   #\Q
                   #x1234          ; netnat2
                   #x0abcde        ; netnat3
                   0.0          ; float1
                   0.0          ; float2
                   3.14         ; float1
                   2.78e+5      ; float2
                   3.14e-4
                   2.78e-7
                   -3.14e+4
                   -2.78e+7
                   -3.14e-4
                   -2.78e-7 ))
  ;; look at the instance
  ;;(unveil o (current-output-port))(newline)
  (show-bytes o)
  ;; encode/decode every field.
  (let loop ((i 0))
    (if (< i (DM-ClassToFieldLength Testf-class))
        (let* ((field         (DM-ClassToField Testf-class i))
               (value         (field-value o field))
               (offset-number (DM-FieldToOffsetLength field))
               (offset        (DM-FieldToOffset field (- offset-number 1)))
               (translation   (DM-OffsetToTranslation offset))
               (itemtyp       (offset.item-type offset)) )
          (display `(sending field ,i with value ,value))(newline)
          (set-field-value! b 0 (->Field DM-Buffer-class "index"))
          (DM-encode itemtyp o translation c)
          (set-field-value! b 
                            (field-value b (->Field DM-Buffer-class "index"))
                            (->Field DM-Buffer-class "maximum") )
          (set-field-value! b 0 (->Field DM-Buffer-class "index"))
          (DM-decode itemtyp o translation c)
          (let ((new (field-value o field)))
            (display `(received ,new))(newline)
            (if (or (equal? value new)
                    (and (number? value)
                         (let ((delta (/ (- value new) value)))
                           (display `(relative delta is ,delta ))
                           (newline)
                           (< (abs delta) 1.e-6) ) ) )
                (loop (+ i 1))
                (begin (show-bytes o)
                       (show-bytes b)
                       #f ) ) ) )
        #t ) ) )
   #t
;;; Test again after repeating twice the encoding/decoding process.
;;; Normally, floats should change the first time not the second time.
;;; This is what really happens on SonyNews.
(let ()
  (define c 1)
  (define b 2)
  (define o 3)
  (set! b (DM-allocate DM-Buffer-class 64))
  (set! c (DM-make DM-Connection-class
                   0 5 0   ; 
                   0 0 0 0 ; sockaddr
                   0 0 b b ))
  (set! o (DM-make Testf-class
                   11 
                   #x1234
                   #x12345678
                   #x12345678  ; nat4
                   11 
                   #x1234
                   #x12345678
                   #x12345678  ; int4
                   (- 11)
                   (- #x1234)
                   (- #x12345678)
                   (- #x12345678)  ; int4
                   #\Q
                   #x1234          ; netnat2
                   #x0abcde        ; netnat3
                   0.0          ; float1
                   0.0          ; float2
                   3.14         ; float1
                   2.78e+5      ; float2
                   3.14e-4
                   2.78e-7
                   -3.14e+4
                   -2.78e+7
                   -3.14e-4
                   -2.78e-7 ))
  ;; look at the instance
  ;;(unveil o (current-output-port))(newline)
  (show-bytes o)
  ;; encode/decode every field.
  (let loop ((i 0))
    (if (< i (DM-ClassToFieldLength Testf-class))
        (let* ((field         (DM-ClassToField Testf-class i))
               (value         (field-value o field))
               (new           'wait)
               (newnew        'wait)
               (offset-number (DM-FieldToOffsetLength field))
               (offset        (DM-FieldToOffset field (- offset-number 1)))
               (translation   (DM-OffsetToTranslation offset))
               (itemtyp       (offset.item-type offset)) )
          (display `(sending field ,i with value ,value))(newline)
          ;; first encoding
          (set-field-value! b 0 (->Field DM-Buffer-class "index"))
          (DM-encode itemtyp o translation c)
          (set-field-value! b 
                            (field-value b (->Field DM-Buffer-class "index"))
                            (->Field DM-Buffer-class "maximum") )
          (set-field-value! b 0 (->Field DM-Buffer-class "index"))
          (DM-decode itemtyp o translation c)
          (set! new (field-value o field))
          (display `(received ,new))(newline)
          ;; second encoding
          (set-field-value! b 0 (->Field DM-Buffer-class "index"))
          (DM-encode itemtyp o translation c)
          (set-field-value! b 
                            (field-value b (->Field DM-Buffer-class "index"))
                            (->Field DM-Buffer-class "maximum") )
          (set-field-value! b 0 (->Field DM-Buffer-class "index"))
          (DM-decode itemtyp o translation c)
          (set! newnew (field-value o field))
          (display `(received again ,newnew))(newline)
          ; comparison
          (if (or (equal? value newnew)
                  (and (number? value)
                       (let ((delta1 (/ (- value new) value))
                             (delta2 (/ (- new newnew) new)) )
                         (display `(first relative delta is ,delta1))
                         (newline)
                         (display `(second relative delta is ,delta2))
                         (newline)
                         (and (< (abs delta1) 1.e-6)
                              (< (abs delta2) 1.e-6) ) ) ) )
              (loop (+ i 1))
              (begin (show-bytes o)
                     (show-bytes b)
                     #f ) ) )
        #t ) ) )
   #t

;;; Let's test now the upper level of send/receive.
;;; First define a predicate to compare objects.
(define (egal? o new)
  (define (scan i t)
    (define class (DM-ObjectToClass o))
    (if (< i (DM-ClassToFieldLength class))
        (let* ((field          (DM-ClassToField class i))
               (offsets-number (DM-FieldToOffsetLength field))
               (last-offset    (DM-FieldToOffset field (- offsets-number 1)))
               (reptypindex    (DM-OffsetToRepetitionTypeIndex last-offset))
               (reptyp         (DM-index-to-type reptypindex))
               (itemtypindex   (DM-OffsetToItemTypeIndex last-offset))
               (itemtyp        (DM-index-to-type itemtypindex)) )
          (if (= DM-nought-index reptypindex)
              ;; Regular field
              (begin
                (set! t (pad t itemtyp))
                (display `(egal? itemtyp on ,t))(newline)
                (and (egal? (DM-local-read itemtyp o t)
                            (DM-local-read itemtyp new t) )
                     (scan (+ i 1) (extend t itemtyp)) ) )
              ;; Indexed field
              (begin
                (set! t (pad t reptyp))
                (let ((rep (DM-local-read reptyp o t)))
                  (display `(egal? reptyp on ,t (,rep)))(newline)
                  (and (= rep (DM-local-read reptyp new t))
                       (begin
                         (let enum ((j 0)(t (extend t reptyp)))
                           (if (< j rep)
                               (begin
                                 (set! t (pad t itemtyp))
                                 (display `(egal? repitemtyp on ,t))(newline)
                                 (and (egal? (DM-local-read itemtyp o t)
                                             (DM-local-read itemtyp new t) )
                                      (enum (+ j 1) (extend t itemtyp)) ) )
                               (scan (+ i 1) (realign t)) ) ) ) ) ) ) ) )
        #t ) )
  (or (equal? o new)
      (if (DM-is-a new DM-Exit-class)
          ;; compare the original object with the object associated to the
          ;; entry remotely referenced by the Exit instance got as `new'.
          (egal? o (let* ((nat4-name (DM-exit2string new))
                          (entry     (DM-string2entry nat4-name)) )
                     (DM-local-get DM-reference-type entry DM-Entry-object-field) ))
          (and (egal? (DM-ObjectToClass o) (DM-ObjectToClass new))
               (scan 0 0) ) ) ) )
   ---
;;; Test a little that egal? predicate
(egal? DM-nil DM-nil)
   #t
(egal? 13 13)
   #t
(egal? (DM-make DM-Nat1-class 13) (DM-make DM-Nat1-class 13))
   #t
(egal? (DM-make DM-ImmutableVector-class 1 DM-Class-class)
       (DM-make DM-ImmutableVector-class 1 DM-Class-class) )
   #t
(egal? (DM-make DM-ImmutableVector-class 1 DM-Class-class)
       (DM-make DM-MutableVector-class 1 DM-Class-class) )
   #f
(egal? (DM-make DM-ImmutableVector-class 1 DM-Class-class)
       (DM-make DM-ImmutableVector-class 2 DM-Class-class DM-nil) )
   #f
             
;;; Now test the exchange of object.
(define (test-exchange o)
  (define c 1)
  (define be 2)
  (define br 22)
  (set! be (DM-allocate DM-Buffer-class 64))
  (set! br (DM-allocate DM-Buffer-class 64))
  (set! c (DM-make DM-Connection-class
                   0 5 0                ; 
                   0 0 0 0              ; sockaddr
                   0 0 br be ))
  (let ((new 'wait))
    (display `(sending ,o))(newline)
    (unveil o (current-output-port))(newline)
    (set-field-value! be 0 (->Field DM-Buffer-class "index"))
    (DM-send c o)
    (show-bytes o)
    (set-field-value! be
                      (field-value be (->Field DM-Buffer-class "index"))
                      (->Field DM-Buffer-class "maximum") )
    (set-field-value! be 0 (->Field DM-Buffer-class "index"))
    (show-bytes be)
    ;; take care of not disturbing the buffer we read if the receiver
    ;; wants to send back some commands to the emitter. Since the
    ;; field is immutable, bypass protection. We just exchange the
    ;; emission and reception buffers.
    (DM-local-write DM-reference-type
                    c
                    (DM-OffsetToTranslation
                     (DM-FieldToOffset
                      (->Field DM-Connection-class "emission") 0 ) ) 
                    br )
    (DM-local-write DM-reference-type
                    c
                    (DM-OffsetToTranslation
                     (DM-FieldToOffset
                      (->Field DM-Connection-class "reception") 0 ) ) 
                    be )
    (set-field-value! br 0 (->Field DM-Buffer-class "index"))
    (set! new (DM-receive c))
    (display `(received ,new))(newline)
    (show-bytes new)
    ;; NOTE: html-unveil also externalizes values.
    (html-unveil new (current-output-port))(newline)
    ;; comparison
    (if (egal? o new)
        #t
        (begin (show-bytes o)
               (show-bytes new)
               (show-bytes be)
               #f ) ) ) )
   ---
;;; test exchange on predefined objects.
(test-exchange DM-nil)
   #t
(test-exchange DM-nat2-type)
   #t
(test-exchange DM-Class-class)
   #t
;;; test other kind of objects with known class 
;;; but without references inside them.
(test-exchange (DM-make DM-Nat1-class 12))
   #t
(test-exchange (DM-make DM-Nat2-class 1234))
   #t
;;; test object with a trivial reference
(test-exchange (DM-make DM-Reference-class DM-nil))
   #t
(test-exchange (DM-make DM-Reference-class DM-nat3-type))
   #t
;;; test repeated objects with trivial references
(test-exchange (DM-make DM-ImmutableVector-class
                        2 DM-nil DM-nat1-type ))
   #t
;;; test object with non trivial references
(test-exchange (DM-make DM-Reference-class 
                        (DM-make DM-Nat2-class 1234) ) )
   #t
(test-exchange (DM-make DM-Reference-class 
                        (DM-make DM-Reference-class
                                 (DM-make DM-Nat2-class 1234) ) ) )
   #t
;;; test repeated field with non trivial references.
(test-exchange (DM-make DM-ImmutableVector-class
                        4 (DM-make DM-Reference-class DM-nat3-type)
                          DM-nil
                          (DM-make DM-Nat2-class 1234)
                          (DM-make DM-Reference-class 
                                   (DM-make DM-Reference-class
                                            (DM-make DM-Nat2-class 1234) ) )))
   #t
;;; test object with non predefined class.
;;; Only an Exit is made on the receiver.
(define Pair-class (DM-create-class "Pair" DM-Object-class 2
                           "-field" "x" "-mutable"
                           "-field" "y" "-mutable" ))
   ---
(test-exchange (DM-make Pair-class
                        DM-nil DM-nat4-type ))
   #t
(test-exchange (DM-make Testf-class
                   11 
                   #x1234
                   #x12345678
                   #x12345678  ; nat4
                   11 
                   #x1234
                   #x12345678
                   #x12345678  ; int4
                   (- 11)
                   (- #x1234)
                   (- #x12345678)
                   (- #x12345678)  ; int4
                   #\Q
                   #x1234          ; netnat2
                   #x0abcde        ; netnat3
                   0.0          ; float1
                   0.0          ; float2
                   3.14         ; float1
                   2.78e+5      ; float2
                   3.14e-4
                   2.78e-7
                   -3.14e+4
                   -2.78e+7
                   -3.14e-4
                   -2.78e-7 ) )
   #t

;;; Send an object twice (received as an exit) and expects a decrement
;;; message the second time.
(let ()
  (define c 1)
  (define be 2)
  (define br 22)
  (set! be (DM-allocate DM-Buffer-class 64))
  (set! br (DM-allocate DM-Buffer-class 64))
  (set! c (DM-make DM-Connection-class
                   0 5 0                ; 
                   0 0 0 0              ; sockaddr
                   0 0 br be ))
  ;; for each of them, 
  (let ((new 'wait)
        (newnew 'wait)
        (o (DM-make Pair-class DM-nil DM-nat4-type)) )
    (display `(sending ,o))(newline)
    (set-field-value! be 0 (->Field DM-Buffer-class "index"))
    (DM-send c o)
    (DM-send c o)
    ;;(show-bytes o)
    (set-field-value! be
                      (field-value be (->Field DM-Buffer-class "index"))
                      (->Field DM-Buffer-class "maximum") )
    (set-field-value! be 0 (->Field DM-Buffer-class "index"))
    ;;(show-bytes be)
    ;; take care of not disturbing the buffer we read if the receiver
    ;; wants to send back some commands to the emitter. Since the
    ;; field is immutable, bypass protection. We just exchange the
    ;; emission and reception buffers.
    (DM-local-write DM-reference-type
                    c
                    (DM-OffsetToTranslation
                     (DM-FieldToOffset
                      (->Field DM-Connection-class "emission") 0 ) ) 
                    br )
    (DM-local-write DM-reference-type
                    c
                    (DM-OffsetToTranslation
                     (DM-FieldToOffset
                      (->Field DM-Connection-class "reception") 0 ) ) 
                    be )
    (set-field-value! br 0 (->Field DM-Buffer-class "index"))
    (set! new (DM-receive c))
    (display `(received ,new))(newline)
    (show-bytes new)
    (set! newnew (DM-receive c))
    (display `(received ,newnew))(newline)
    (show-bytes newnew)
    ;; comparison
    (and (egal? o newnew)
         ;; must be the same exit:
         (eq? new newnew)
         ;; must contain a decrement message:
         (field-value br (->Field DM-Buffer-class "index")) ) ) )
   9 ; #xb0 followed by a nat4.

" *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                      All tests successfully run!
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***"
   ---

;;; end of code.tst
