;;; $Id: compat.tst,v 1.8 1995/09/11 18:21:11 queinnec Exp $
;;; This file tests Scheme functions wrt their C counterpart.

;;; DM-size is now written in C, the Scheme original version is known
;;; as DM-content-size.

(DM-size DM-nil)
   0
(let ((o (->String "foo")))
  (= (DM-size o) (old-DM-size o)) )
   #t
(let ((o (->String "foob")))
  (= (DM-size o) (old-DM-size o)) )
   #t
(let ((o (->String "foobar")))
  (= (DM-size o) (old-DM-size o)) )
   #t
(let ((o (->String "foobarbaz")))
  (= (DM-size o) (old-DM-size o)) )
   #t
(let ((o DM-Class-class))
  (= (DM-size o) (old-DM-size o)) )
   #t

;;; DM-clone uses DM-size
(DM-size (DM-clone DM-nil))
   0
(= (DM-size DM-Class-class) (DM-size (DM-clone DM-Class-class)))
   #t
;;; test the last field of a second indexed field.
(let ((c (DM-clone DM-Class-class)))
  (eq? (DM-local-indexed-get DM-reference-type
                             DM-Class-class 
                             DM-Class-field-field 
                             (- (DM-local-length DM-nat3-type
                                                 DM-Class-class 
                                                 DM-Class-field-field )
                                1 ) )
       (DM-local-indexed-get DM-reference-type
                             c
                             DM-Class-field-field 
                             (- (DM-local-length DM-nat3-type
                                                 c
                                                 DM-Class-field-field )
                                1 ) ) ) )
   #t

;;; compute-layout is now written in C as well as DM-predefined-classes
(define (verify-layout class)
  (let ((fields-number (DM-ClassToFieldLength class)))
    (let loop ((i                 0)
               (t                 0)
               (previous-indexed? #t) )
      (if (< i fields-number)
          (let* ((field          (DM-ClassToField class i))
                 (offsets-number (DM-FieldToOffsetLength field))
                 (last-offset    (DM-FieldToOffset field (- offsets-number 1)))
                 (reptypindex    (DM-OffsetToRepetitionTypeIndex last-offset))
                 (itemtypindex   (DM-OffsetToItemTypeIndex last-offset))
                 (indexed?       (not (= reptypindex DM-nought-index)))
                 (prevlim        (- offsets-number 1))
                 (new-offset     (create-simple-offset 
                                  (if previous-indexed?
                                      (if (> offsets-number 1) 0 t)
                                      t )
                                  last-offset )) )
            ;; check the previous offsets 
            (if (> offsets-number 1)
                (let ((previous-field (DM-ClassToField class (- i 1))))
                  (do ((j 0 (+ j 1)))
                      ((>= j prevlim))
                    (if (not (= (DM-FieldToOffset previous-field j)
                                (DM-FieldToOffset field j) ))
                        (DM-error "error on offset" class i j) ) )  ) )
            ;; compare the current one
            (if (not (= new-offset (DM-FieldToOffset field (- offsets-number 1))))
                (DM-error "error on offset" class i) )
            ;; recurse on next field.
            (loop (+ i 1) 
                  (if indexed?
                      0
                      (let ((t    (DM-OffsetToTranslation new-offset))
                            (type (DM-index-to-type itemtypindex)) )
                        (DM-OffsetExtend (DM-OffsetPad t type) type) ) )
                  indexed? ) ) ) ) ) )  
   ---
(do ((i 1 (+ i 1)))
    ((>= i (DM-local-length DM-nat3-type 
                            DM-predefined-classes
                            DM-ImmutableVector-item-field )))
  (let ((c (DM-local-indexed-get DM-reference-type 
                                 DM-predefined-classes
                                 DM-ImmutableVector-item-field 
                                 i )))
    (display `(checking native ,(DM-string->string (DM-ClassToName c))))
    (verify-layout c)
    (display " OK")(newline)
    (DM-compute-layout c)
    (display `(checking ,(DM-string->string (DM-ClassToName c))
                        after DM-compute-layout ))
    (verify-layout c)
    (display " OK")(newline)
    (old-compute-layout! c)
    (display `(checking ,(DM-string->string (DM-ClassToName c))
                        after old-compute-layout! ))
    (verify-layout c)
    (display " OK")(newline) ) )
   ---


   
" *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                      All compat.tst tests successfully run!
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***"
   ---

;;; end of compat.tst
