;;; $Id$

;;; This file is to be evaluated by a server (known here as THREE).
;;; It waits for TWO to connect itself then it connects to
;;; ONE. Finally, ONE and TWO are connected through THREE.

;;; assume TOP/DMeroon/dmlib.scm to be loaded.

;;; Leave time for TWO to establish a Connection. Then recover its
;;; representing Site object. 

(define three DM-site)
   ---
;;; Wait for the other site to connect itself. When the other site
;;; will be connected, the current site will receive a Fact mentioning
;;; it (if, of course, the current site has the DM_SITE_WANTS_FACT
;;; option on).
(define two 
  (let wait ((count 0))
    (let ((o (DM-receive 10)))
      (if (> count 10)
          #f  ; stop waiting after 100 seconds.
          (if o 
              (if (DM-is-a? o DM-Fact-class)
                  (begin
                    (display "*** Got a Fact")(newline)
                    ;; get the site (should verify that errcode is DME_GOT_SITE.
                    (DM-indexed-field-value o DM-Fact-item-field 0) )
                  (wait count) )
              (wait (+ count 1)) ) ) ) ) )
   ---
;;; Verify we got a site before continuing.
(DM-is-a? two DM-Site-class)
   #t
;;; Now connect to ONE
(define ONE (DM-connect "localhost" PORT1))
   ---
;;; and serve until getting false from TWO.
(define (DM-receive-object)
  (let ((o (DM-receive 10)))
    (if o
        (if (eq? o DM-false)
            o
            (DM-receive-object) )
        (DM-receive-object) ) ) )
   ---
;;; Transmit that DM-false to ONE.
(let loop ((o (DM-receive-object)))
  (DM-send o ONE)
  (DM-serve 10) )
   ---

" *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                      All connect1.tst tests successfully run!
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***"
   ---

;;; end of connect1.tst
