;;; same as DEA/meroonet/dmeroonet.tst but adapted some tests.
;;; $Id: dmeroonet.tst,v 1.4 1997/10/03 21:12:05 queinnec Exp $

;;;        Testing DMeroonet

(define Class?
  (DM-make-predicate DM-Class-class) )
 ---

;;; testing define-class and generated functions
(DM-define-class Point Object (x y))
   ---
(set! the-Point (make-Point 2 44))
   ---
(Point-x the-Point)
   2
(Point-y the-Point)
   44
(Point? the-Point)
   #t
(DM-is-object? the-Point)
   #t
(Class? the-Point)
   #f
(allocate-Point)
   ---
(begin (set-Point-x! the-Point 3) (Point-x the-Point))
   3
(begin (set-Point-y! the-Point 55) (Point-y the-Point))
   55

;;; testing a subclass of the previous one and related functions
(DM-define-class ColoredPoint Point (color))
   ---
(set! the-Point (make-ColoredPoint 2 44 'white))
   ---
(Point-x the-Point)
   2
(Point-y the-Point)
   44
(Point? the-Point)
   #t
(ColoredPoint? the-Point)
   #t
(DM-is-object? the-Point)
   #t
(Class? the-Point)
   #f
(allocate-ColoredPoint)
   ---
(begin (set-Point-x! the-Point 3) (Point-x the-Point))
   3
(begin (set-Point-y! the-Point 55) (Point-y the-Point))
   55
(begin (set-Point-x! the-Point 33) (ColoredPoint-x the-Point))
   33
(begin (set-Point-y! the-Point 5) (ColoredPoint-y the-Point))
   5
(begin (set-ColoredPoint-x! the-Point 3)(ColoredPoint-x the-Point))
   3
(begin (set-ColoredPoint-y! the-Point 55) (ColoredPoint-y the-Point))
   55
(begin (set-ColoredPoint-x! the-Point 33) (Point-x the-Point))
   33
(begin (set-ColoredPoint-y! the-Point 5) (Point-y the-Point))
   5
(ColoredPoint-color the-Point)
   white
(begin (set-ColoredPoint-color! the-Point 'black) 
       (ColoredPoint-color the-Point) )
   black

;;; Testing vectorship 
(DM-define-class NamedColoredPoint ColoredPoint ((* names)))
   ---
(set! the-Point 
      (make-NamedColoredPoint 
       2 44 'pink 
            3 'joe 'jill 'jack ) )
   ---
(NamedColoredPoint-names-length the-Point)
   3
(NamedColoredPoint-names the-Point 1)
   jill
(set-NamedColoredPoint-names! the-Point 0 'jean)
   ---
(NamedColoredPoint-names the-Point 0)
   jean
(NamedColoredPoint-names the-Point 2)
   jack
(Point-x the-Point)
   2
(Point-y the-Point)
   44
(Point? the-Point)
   #t
(ColoredPoint? the-Point)
   #t
(NamedColoredPoint? the-Point)
   #t
(DM-is-object? the-Point)
   #t
(Class? the-Point)
   #f
(ColoredPoint-color the-Point)
   pink
(allocate-NamedColoredPoint 3)
   ---
(begin (set-Point-x! the-Point 3) (Point-x the-Point))
   3
(begin (set-Point-y! the-Point 55) (Point-y the-Point))
   55
(begin (set-Point-x! the-Point 33) (ColoredPoint-x the-Point))
   33
(begin (set-Point-y! the-Point 5) (ColoredPoint-y the-Point))
   5
(begin (set-ColoredPoint-x! the-Point 3)(ColoredPoint-x the-Point))
   3
(begin (set-ColoredPoint-y! the-Point 55) (ColoredPoint-y the-Point))
   55
(begin (set-ColoredPoint-x! the-Point 33) (Point-x the-Point))
   33
(begin (set-ColoredPoint-y! the-Point 5) (Point-y the-Point))
   5
(ColoredPoint-color the-Point)
   pink
(begin (set-ColoredPoint-color! the-Point 'black) 
       (ColoredPoint-color the-Point) )
   black
(set! the-Point (make-NamedColoredPoint 1 33 'pink 0))
   ---
(NamedColoredPoint-names-length the-Point)
   0
(NamedColoredPoint-names the-Point 0)
   ***
(NamedColoredPoint-names the-Point 3)
   ***
(set-NamedColoredPoint-names! the-Point 0 'jill)
   ***
(make-NamedColoredPoint 3 2 1 'foo)
   *** ; not a repetition factor
;; NOTE: This error is caught by list-tail which is invoked with a non numeric
;; second argument. Your test-meroonet function should catch these errors
;; by gaining control on the errors detected by the underlying Scheme.
(make-NamedColoredPoint 3 2 1 2 'foo)
   *** ; too less
; Not tested in Meroonet
;(make-NamedColoredPoint 3 2 1 2 'foo 'bar 'hux)
;   *** ; too much
(set! the-Point (make-NamedColoredPoint 1 33 'pink 1 'joe))
   ---
(NamedColoredPoint-names-length the-Point)
   1
(NamedColoredPoint-names the-Point 0)
   joe
(NamedColoredPoint-names the-Point 1)
   ***
(set-NamedColoredPoint-names! the-Point 0 'jill)
   ---
(NamedColoredPoint-names the-Point 0)
   jill
(set-NamedColoredPoint-names! the-Point 1 'jack)
   ***
(NamedColoredPoint-names the-Point 0)
   jill
(set! the-Point (allocate-NamedColoredPoint 2))
   ---
(set-NamedColoredPoint-names! the-Point 0 'jill)
   ---
(NamedColoredPoint-names the-Point 0)
   jill
(set-NamedColoredPoint-names! the-Point 1 'jack)
   ---
(NamedColoredPoint-names the-Point 1)
   jack
(set-NamedColoredPoint-names! the-Point 2 'joe)
   ***
(NamedColoredPoint-names the-Point 2)
   ***



;;; Testing vectorship inheritance 
(DM-define-class NickNamedColoredPoint NamedColoredPoint ((* nicknames)))
   ---
(set! the-Point 
      (make-NickNamedColoredPoint 
       2 44 'pink 
            3 'joe 'jill 'jack
            2 'adam 'eve ) )
   ---
(NamedColoredPoint-names-length the-Point)
   3
(NickNamedColoredPoint-names-length the-Point)
   3
(NickNamedColoredPoint-nicknames-length the-Point)
   2
(NamedColoredPoint-names the-Point 1)
   jill
(NickNamedColoredPoint-names the-Point 1)
   jill
(NickNamedColoredPoint-names the-Point 2)
   jack
(NickNamedColoredPoint-nicknames the-Point 0)
   adam
(NickNamedColoredPoint-nicknames the-Point 1)
   eve
(NickNamedColoredPoint-nicknames the-Point 2)
   ***
(set-NamedColoredPoint-names! the-Point 0 'jill)
   ---
(NamedColoredPoint-names the-Point 0)
   jill
(set-NickNamedColoredPoint-names! the-Point 0 'jill)
   ---
(NickNamedColoredPoint-names the-Point 0)
   jill
(set-NickNamedColoredPoint-nicknames! the-Point 0 'chaim)
   ---
(NickNamedColoredPoint-nicknames the-Point 0)
   chaim
(Point-x the-Point)
   2
(Point-y the-Point)
   44
(Point? the-Point)
   #t
(ColoredPoint? the-Point)
   #t
(NamedColoredPoint? the-Point)
   #t
(DM-is-object? the-Point)
   #t
(Class? the-Point)
   #f
(ColoredPoint-color the-Point)
   pink
(allocate-NickNamedColoredPoint 3 2)
   ---
(begin (set-Point-x! the-Point 3) (Point-x the-Point))
   3
(begin (set-Point-y! the-Point 55) (Point-y the-Point))
   55
(begin (set-Point-x! the-Point 33) (ColoredPoint-x the-Point))
   33
(begin (set-Point-y! the-Point 5) (ColoredPoint-y the-Point))
   5
(begin (set-ColoredPoint-x! the-Point 3)(ColoredPoint-x the-Point))
   3
(begin (set-ColoredPoint-y! the-Point 55) (ColoredPoint-y the-Point))
   55
(begin (set-ColoredPoint-x! the-Point 33) (Point-x the-Point))
   33
(begin (set-ColoredPoint-y! the-Point 5) (Point-y the-Point))
   5
(begin (set-ColoredPoint-color! the-Point 'black) 
       (ColoredPoint-color the-Point) )
   black
(set! the-Point (make-NickNamedColoredPoint 1 33 'pink 0 0))
   ---
(NickNamedColoredPoint-names-length the-Point)
   0
(NickNamedColoredPoint-nicknames-length the-Point)
   0
(NickNamedColoredPoint-names the-Point 1)
   ***
(NickNamedColoredPoint-names the-Point 3)
   ***
(set-NickNamedColoredPoint-names! the-Point 0 'jill)
   ***
(set-NickNamedColoredPoint-names! the-Point 1 'jill)
   ***
(NickNamedColoredPoint-nicknames the-Point 3)
   ***
(set-NickNamedColoredPoint-nicknames! the-Point 1 'jill)
   ***
(make-NickNamedColoredPoint 3 2 1 'foo)
   *** ; not a repetition factor
(make-NickNamedColoredPoint 3 2 1 2 'foo)
   *** ; too less
(make-NickNamedColoredPoint 3 2 1 2 'foo 'bar 'hux)
   *** ; not a repetition factor
; not checked in Meroonet
;(make-NickNamedColoredPoint 3 2 1 2 'foo 'bar 0 'hux)
;   *** ; too much
(make-NickNamedColoredPoint 3 2 1 2 'foo 'bar 2 'hux)
   *** ; too less
; not checked in Meroonet
;(make-NickNamedColoredPoint 3 2 1 2 'foo 'bar 2 'hux 'bar 'wrek 'quux)
;   *** ; too much

;;; test fields after two sequences
(DM-define-class extra-NickNamedColoredPoint NickNamedColoredPoint
  (extra1 extra2) )
   ---
(set! the-Point 
      (make-extra-NickNamedColoredPoint 
       2 44 'pink 
            3 'joe 'jill 'jack
            2 'adam 'eve 
            'apiali 'docious ) )
   ---
(extra-NickNamedColoredPoint-extra2 the-Point)
   docious
(set-extra-NickNamedColoredPoint-extra2! the-Point 'foo)
   ---
(extra-NickNamedColoredPoint-extra2 the-Point)
   foo
(NamedColoredPoint-names-length the-Point)
   3
(extra-NickNamedColoredPoint-names-length the-Point)
   3
(extra-NickNamedColoredPoint-nicknames-length the-Point)
   2
(NamedColoredPoint-names the-Point 1)
   jill
(extra-NickNamedColoredPoint-names the-Point 1)
   jill
(extra-NickNamedColoredPoint-nicknames the-Point 1)
   eve
(set-NamedColoredPoint-names! the-Point 0 'jill)
   ---
(NamedColoredPoint-names the-Point 0)
   jill
(set-extra-NickNamedColoredPoint-names! the-Point 0 'jill)
   ---
(extra-NickNamedColoredPoint-names the-Point 0)
   jill
(set-extra-NickNamedColoredPoint-nicknames! the-Point 0 'chaim)
   ---
(extra-NickNamedColoredPoint-nicknames the-Point 0)
   chaim
(Point-x the-Point)
   2
(Point-y the-Point)
   44
(Point? the-Point)
   #t
(ColoredPoint? the-Point)
   #t
(NamedColoredPoint? the-Point)
   #t
(DM-is-object? the-Point)
   #t
(Class? the-Point)
   #f
(ColoredPoint-color the-Point)
   pink
(allocate-extra-NickNamedColoredPoint 3 2)
   ---
(begin (set-Point-x! the-Point 3) (Point-x the-Point))
   3
(begin (set-Point-y! the-Point 55) (Point-y the-Point))
   55
(begin (set-Point-x! the-Point 33) (ColoredPoint-x the-Point))
   33
(begin (set-Point-y! the-Point 5) (ColoredPoint-y the-Point))
   5
(begin (set-ColoredPoint-x! the-Point 3)(ColoredPoint-x the-Point))
   3
(begin (set-ColoredPoint-y! the-Point 55) (ColoredPoint-y the-Point))
   55
(begin (set-ColoredPoint-x! the-Point 33) (Point-x the-Point))
   33
(begin (set-ColoredPoint-y! the-Point 5) (Point-y the-Point))
   5
(begin (set-ColoredPoint-color! the-Point 'black) 
       (ColoredPoint-color the-Point) )
   black
(set! the-Point (make-NickNamedColoredPoint 1 33 'pink 0 0))
   ---
(extra-NickNamedColoredPoint-names-length the-Point)
   0
(extra-NickNamedColoredPoint-nicknames-length the-Point)
   0
(extra-NickNamedColoredPoint-names the-Point 3)
   ***
(set-extra-NickNamedColoredPoint-names! the-Point 0 'jill)
   ***
(extra-NickNamedColoredPoint-nicknames the-Point 3)
   ***
(set-extra-NickNamedColoredPoint-nicknames! the-Point 0 'jill)
   ***
(make-extra-NickNamedColoredPoint 3 2 1 'foo)
   *** ; not a repetition factor
(make-extra-NickNamedColoredPoint 3 2 1 2 'foo)
   *** ; too less
(make-extra-NickNamedColoredPoint 3 2 1 2 'foo 'bar 'hux)
   *** ; not a repetition factor
; not checked in Meroonet
;(make-extra-NickNamedColoredPoint 3 2 1 2 'foo 'bar 0 'hux)
;   *** ; too much
(make-extra-NickNamedColoredPoint 3 2 1 2 'foo 'bar 2 'hux)
   *** ; too less
(make-extra-NickNamedColoredPoint 3 2 1 2 'foo 'bar 2 'hux 'bar 'wrek 'quux)
   ---
; not checked in Meroonet
;(make-extra-NickNamedColoredPoint 3 2 1 2 'foo 'bar 
; 2 'hux 'bar 'wrek 'quux 55)
;   *** ; too much
  

;;; generic functions
; not defined in Meroonet
;(initialize! 3)
;   3
;(initialize! #t)
;   #t
;(initialize! the-Point)
;   ---
;(show (->Class 'Class))
;   ---
;(show the-Point)
;   ---
;(show 34)
;   ---
;(show 3.14)
;   ---
;(show #\space)
;   ---
;(show #\a)
;   ---
;(show (list #t #f '()))
;   ---
;(equal? (clone (->Class 'Class)) (->Class 'Class))
;   #t
;(let ((pt (make-Point 1 2)))
;  (equal? pt (clone pt)) )
;   #t
;(clone 3) ; 3 is not an instance
;   ***
   
;;; generic with default method, discriminating on the second variable
(DM-define-generic (foo x (y) z)
  (list x y z) )
   ---
(DM-describe foo)
   ---
(DM-invoke foo 3 the-Point 4)
   ---
(length (DM-invoke foo 3 the-Point 4))
   3
(DM-invoke foo 3 4 5) ; 4 is not an instance but there is a default method
   (3 4 5) 
   
;;; Adding methods
(DM-define-method (foo x (o ColoredPoint-class) z)
  (ColoredPoint-x o) )
   ---
(let ((pt (make-Point 1 2)))
  (length (DM-invoke foo 9 pt 8)) )
   3
(let ((pt (make-ColoredPoint 1 2 'red)))
  (DM-invoke foo 9 pt 8) )
   1
(let ((pt (make-NamedColoredPoint 1 2 'red 1 'jill)))
  (DM-invoke foo 9 pt 8) )
   1

;;; Adding a method above
(DM-define-method (foo x (o DM-Object-class) z)
  'foo )
   ---
(let ((pt (make-Point 1 2)))
  (DM-invoke foo 9 pt 8) )
   foo
(let ((pt (make-ColoredPoint 1 2 'red)))
  (DM-invoke foo 9 pt 8) )
   1
(let ((pt (make-NamedColoredPoint 1 2 'red 1 'jill)))
  (DM-invoke foo 9 pt 8) )
   1

;;; redefining method
(DM-define-method (foo x (o ColoredPoint-class) z)
  (ColoredPoint-y o) )
   ---
(let ((pt (make-Point 1 2)))
  (DM-invoke foo 9 pt 8) )
   foo
(let ((pt (make-ColoredPoint 1 2 'red)))
  (DM-invoke foo 9 pt 8) )
   2
(let ((pt (make-NamedColoredPoint 1 2 'red 1 'jill)))
  (DM-invoke foo 9 pt 8) )
   2

;;; Incoherent method
(DM-define-method (foo x) 3)
   ***
(DM-define-method (foo (x) y z) 4)
   ***
(DM-define-method (foo x (y) z . others) 5)
   ***
   
(DM-define-class Point-3d Point (z))
   ---

;;; Redefinition of a class (exists no more in Meroonet)
;(DM-define-class Point-3d Point (h))
;   ---

;;; Show guts (exists no more in Meroonet)
;(show *classes*)
;   ---
;(show (Class-fields (->Class 'NamedColoredPoint)))
;   ---
;(show-hierarchy)
;   ---
;(show-hierarchy 'Object)   ; same as above
;   ---
;(show-hierarchy 'Field)
;   ---
;(show-generic 'show)
;   ---

;;; Tracing generic functions (exists no more in Meroonet)
(DM-define-generic (foo (x) y z) `default)
   ---
(DM-invoke foo 1 2 3)
   default
(DM-define-method (foo (x Point-class) y z) `point)
   ---
(DM-invoke foo (make-Point 1 2) 3 4)
   point
;(generic-trace (->Generic 'foo)
;               (lambda (x y z) (set! foo-args `call))
;               (lambda (result) 
;                 `(return ,result) ) )
;   ---
;(set! foo-args 'void)
;   ---
;(foo 'a 'b 'c)
;   (return default)
;foo-args
;   call
;(set! foo-args 'void)
;   ---
;(foo (make-Point 1 2) 3 4)
;   (return point)
;foo-args
;   call
;(generic-untrace (->Generic 'foo))
;   ---
;(set! foo-args 'void)
;   ---
;(foo 'a 'b 'c)
;   default
;foo-args
;   void
;(foo (make-Point 1 2) 3 4)
;   point

;;; Tracing generic functions with a dotted variable list
(DM-define-generic (foo (x) y . z) `(default . ,z))
   ---
(DM-invoke foo 1 2)
   (default)
(DM-invoke foo 1 2 3)
   (default 3)
(DM-invoke foo 1 2 3 4 5)
   (default 3 4 5)
(DM-define-method (foo (x Point-class) y . z) `(point . ,z))
   ---
(DM-invoke foo (make-Point 1 2) 3)
   (point)
(DM-invoke foo (make-Point 1 2) 3 4)
   (point 4)
(DM-invoke foo (make-Point 1 2) 3 4 5 6)
   (point 4 5 6)
;(generic-trace (->Generic 'foo)
;               (lambda (x y . z) (set! foo-args `call))
;               (lambda (result) 
;                 `(return ,result) ) )
;   ---
;(set! foo-args 'void)
;   ---
;(foo 1 2)
;   (return (default))
;foo-args
;   call
;(set! foo-args 'void)
;   ---
;(foo (make-Point 1 2) 3 4 5)
;   (return (point 4 5))
;foo-args
;   call
;(generic-untrace (->Generic 'foo))
;   ---
;(set! foo-args 'void)
;   ---
;(foo 'a 'b 'c)
;   (default c)
;foo-args
;   void
;(foo (make-Point 1 2) 3 4)
;   (point 4)


;;; testing call-next-method
(DM-define-generic (bar (o)) 'root)
   ---
(DM-describe bar)
   ---
(DM-define-method (bar (o DM-Object-class)) 'object)
   ---
(DM-describe bar)
   ---
(DM-define-method (bar (o ColoredPoint-class))
  (cons (call-next-method) (call-next-method)) )
   ---
(DM-invoke bar (allocate-ColoredPoint))
   (object . object)
(DM-describe bar)
   ---
(DM-define-method (bar (o Point-class)) 'point)
   ---
(DM-describe bar)
   ---
(DM-invoke bar (allocate-ColoredPoint))
   (point . point)


;;; Testing meta object protocol (Not in Meroonet)
;((Class-predicate (->Class 'Point)) (make-Point 1 2))
;   #t
;((Class-predicate (->Class 'ColoredPoint)) (make-Point 1 2))
;   #f
;(Point? ((Class-maker (->Class 'Point)) 1 2))
;   #t
;(Point? ((Class-allocator (->Class 'Point))))
;   #t

;;; Testing some errors
;(make-Class 'foo) ;; cannot handle this error
;   ***  ; too less arguments
;(DM-define-class foo Point (x))
;   *** ; redefinition of X

;;; Testing mutability of fields     (Not in Meroonet)
;(DM-define-class Immutable-Point Object 
;  ((= x :immutable)
;   (= y :immutable) ) )
;   Immutable-Point
;(set! the-Point (make-Immutable-Point 2 44))
;   ---
;(Immutable-Point-x the-Point)
;   2
;(Immutable-Point-y the-Point)
;   44
;(Immutable-Point? the-Point)
;   #t
;(DM-is-object? the-Point)
;   #t
;(Class? the-Point)
;   #f
;(map Mutable-Mono-Field? (Class-fields (->Class 'Immutable-Point)))
;   (#f #f)
;;; Testing immutability conservation by inheritance
;(DM-define-class Colored-Immutable-Point Immutable-Point
;  (color) )
;   Colored-Immutable-Point
;(map Mutable-Mono-Field? 
;     (Class-fields (->Class 'Colored-Immutable-Point)) )
;   (#f #f #t)

;;; Testing immutability of a class and carelessness
;(DM-define-class Other-Immutable-Point Object 
;  (x y) :immutable :careless )
;   Other-Immutable-Point
;(set! the-Point (make-Other-Immutable-Point 2 44))
;   ---
;(Other-Immutable-Point-x the-Point)
;   2
;(Other-Immutable-Point-y the-Point)
;   44
;(Other-Immutable-Point? the-Point)
;   #t
;(DM-is-object? the-Point)
;   #t
;(Class? the-Point)
;   #f
;(map Mutable-Mono-Field? 
;     (Class-fields (->Class 'Other-Immutable-Point)) )
;   (#f #f)
;;; Testing immutability conservation by inheritance
;(DM-define-class Colored-Other-Immutable-Point Other-Immutable-Point
;  (color) )
;   Colored-Other-Immutable-Point
;(map Mutable-Mono-Field? 
;     (Class-fields (->Class 'Colored-Other-Immutable-Point)) )
;   (#f #f #t)
;;; Testing Mutable-Field? generic function
;(map Mutable-Field? 
;     (Class-fields (->Class 'Other-Immutable-Point)) )
;   (#f #f)
;;; testing care(ful,less)
;(set! the-Point (make-Point 2 44))
;   ---
;(Point-x the-Point)
;   2
;(Other-Immutable-Point-x the-Point)
;   2
;(Colored-Other-Immutable-Point-x the-Point)
;   2
;(set! the-Point (make-Colored-Immutable-Point 2 44 'pink))
;   ---
;(Point-x the-Point)
;   ***
;(Other-Immutable-Point-x the-Point)
;   2
;(Colored-Other-Immutable-Point-x the-Point)
;   2
;; test on predefined classes
;(Class-name (make-Object))
;   ***

;;; Testing that :prototype does no harm (no more in Meroonet)
(DM-define-generic (zztop (o)) 'default)
   ---
(DM-define-method (zztop (o ColoredPoint-class)) 'ColoredPoint)
   ---
(set! the-Point (make-NamedColoredPoint 33 44 'red 2 'joe 'jill))
   ---
(DM-invoke zztop the-Point)
   ColoredPoint
(DM-invoke zztop (make-ColoredPoint 55 66 'blue))
   ColoredPoint
(DM-invoke zztop (make-Point 55 66))
   default
;(DM-define-class Point Object (x y) :prototype)
;   ---
(DM-invoke zztop the-Point)
   ColoredPoint
(DM-invoke zztop (make-ColoredPoint 55 66 'blue))
   ColoredPoint
(DM-invoke zztop (make-Point 55 66))
   default
;(DM-define-class ColoredPoint Point (color) :prototype)
;   ---
(DM-invoke zztop the-Point)
   ColoredPoint
(DM-invoke zztop (make-ColoredPoint 55 66 'blue))
   ColoredPoint
(DM-invoke zztop (make-Point 55 66))
   default
;(DM-define-class NamedColoredPoint ColoredPoint ((* names)) :prototype)
;   NamedColoredPoint
(DM-invoke zztop the-Point)
   ColoredPoint
(DM-invoke zztop (make-ColoredPoint 55 66 'blue))
   ColoredPoint
(DM-invoke zztop (make-Point 55 66))
   default
; this cannot be done in interpreted mode.
;(DM-define-class Point Object (x y z) :prototype) ;; one more field
;   ***
;(DM-define-class Point Object (x) :prototype) ;; one field less
;   ***
;(DM-define-class Point Object (x yy) :prototype) ;; one field name changed
;   ***


;;; testing show-generic-trace (No more in Meroonet)

;(show-generic-trace 'foo)
;   ---
;(foo (make-Point 1 2) 3)
;   (point)
;(foo (make-Point 1 2) 3 4)
;   (point 4)
;(foo (make-Point 1 2) 3 4 5 6)
;   (point 4 5 6)
;(show-generic-trace 'foo)
;   ---   ; just redefine foo to be traced exactly the same
;(foo (make-Point 1 2) 3)
;   (point)
;(foo (make-Point 1 2) 3 4)
;   (point 4)
;(foo (make-Point 1 2) 3 4 5 6)
;   (point 4 5 6)
;(show-generic-untrace 'foo)
;   ---  ; no more trace
;(foo (make-Point 1 2) 3)
;   (point)
;(foo (make-Point 1 2) 3 4)
;   (point 4)
;(foo (make-Point 1 2) 3 4 5 6)
;   (point 4 5 6)
;(show-generic-untrace 'foo)
;   ---
;(foo (make-Point 1 2) 3)
;   (point)
;(foo (make-Point 1 2) 3 4)
;   (point 4)
;(foo (make-Point 1 2) 3 4 5 6)
;   (point 4 5 6)

;;; test a class without slots
(DM-define-class X Object ())
   ---
(make-X)
   ---
(X? (make-X))
   #t
(DM-define-class X-Point Point ())
   ---
(set! the-Point (make-X-Point 11 22))
   ---
(X-Point-x the-Point)
   11
(X-Point? the-Point)
   #t
(X? the-Point)
   #f


;;; Testing exceptions
;(DM-define-class 3 Object ())
;   ***
(DM-define-class X 3 ())
   ***
(DM-define-class X Unknown ())
   ***
;(DM-define-class Anomaly Object ())
;   ***
;(DM-define-class Anomaly Anomaly ())
;   ***
;(allocate-NamedColoredPoint 1 -3 3)
;   ***
(allocate-NamedColoredPoint 'foo)
   ***
(allocate-NamedColoredPoint -2)
   ***
(allocate-NamedColoredPoint)
   ***
;(make-Point 11 22 33)
;   ***
(make-Point)
   ***
(make-Point 11)
   ***
;(make-NamedColoredPoint 11 22 'red 0 9)
;   ***
;(make-NamedColoredPoint 11 22 'red 0 9 8)
;   ***
;(make-NamedColoredPoint 11 22 'red 1 9 8)
;   ***
(make-NamedColoredPoint 11 22 'red 'foo 9)
   ***
;(make-NamedColoredPoint 11 22 'red -3 9)
;   ***
(DM-define-class Y Point (x))
   ***
(DM-define-class Y Point ((* x)))
   ***
(DM-define-class Y Object (3))
   ***
(DM-define-class Y Object ((= 3)))
   ***
;(DM-define-class Y Object ((= foo :bla-bla)))        ; Not an error
;   ---
(ColoredPoint-color (make-Point 111 222))
   ***
(set-ColoredPoint-color! (make-Point 111 222) 'red)
   ***
;(->Class 3)
;   ***
;(->Generic 4)
;   ***
(DM-define-generic (zz))
   ***
(DM-define-generic (zz a b . c))
   ***
(DM-define-generic foo (a b))
   ***
(DM-define-method foo)
   ***
(DM-define-method foo a)
   ***
(DM-define-generic (zz a (o) . c))
   ---
(DM-define-method (zz (a)))
   ***
(DM-define-method (zz (a) b))
   ***
(DM-define-method (zz (a) c . b))
   ***
(DM-define-method (zz s (a) b))
   ***
(DM-define-method (zz (a Point-class)))
   ***
(DM-define-method (zz (a Point-class) b))
   ***
(DM-define-method (zz (a Point-class) c . b))
   ***
(DM-define-method (zz s (a Point-class) b))
   ***
(DM-define-method (yy (a DM-Class-class)) 4)
   ***
(DM-define-method (clone (a ZZZ)) 5)
   ***
;(show-hierarchy 3)
;   ***
;(show-generic 3)
;   ***
;(generic-trace 33 car car)
;   ***
;(generic-trace zz 2 car)
;   ***
;(generic-trace zz car cdr)
;   ***
;(generic-untrace 3)
;   ***
;(show-generic-trace 44)
;   ***
;(show-generic-untrace 44)
;   ***

;;; Test metaclass
;(DM-define-class Counting-Class Class (counter))
;   ---
;(DM-define-method (initialize! (o Counting-Class-class))
;  (call-next-method)
;  (set-Counting-Class-counter! o 0)
;  (let ((original-maker (Class-maker o)))
;    (set-Counting-Class-maker! 
;     o (lambda args
;         (set-Counting-Class-counter! o (+ 1 (Counting-Class-counter o))) 
;         (apply original-maker args) ) ) )
;  o )
;   ---
;(DM-define-class Counted-Point Point () :metaclass Counting-Class)
;   ---
;(->Class 'Counted-Point)
;   ---
;(Counting-Class-counter (->Class 'Counted-Point))
;   0
;(set! pt (make-Counted-Point 22 33))
;   ---
;(Counted-Point-x pt)
;   22
;(Point-y pt)
;   33
;(Counting-Class-counter (->Class 'Counted-Point))
;   1

;;;testing :eponymous
;(DM-define-class foo Object (x) :eponymous)
;   ---
;(eq? foo (->Class 'foo))
;   #t

;;; Testing show-unveiled
;(unveil (->Class 'Mutable-Poly-Field))
;   ---
;;; testing unveil with circularity
;(DM-define-class A Object (x))
;   ---
;(DM-define-class B Object (y))
;   ---
;(begin (set! the-Point (make-A (make-B 'wait)))
;       (set-B-y! (A-x the-Point) the-Point)
;       (unveil the-Point) )
;   ---
;(DM-define-class C A ((* z)))
;   ---
;(begin (set! the-Point (make-C (make-B 'wait)
;                               3 (make-C 11 0) 
;                                 (make-B 22)
;                                 (make-B 33) ))
;       (set-B-y! (A-x the-Point) the-Point)
;       (set-B-y! (C-z the-Point 1) (C-z the-Point 2))
;       (unveil the-Point) )
;   ---

;;; testing field-value (these tests come from Meroon-V3)
(DM-define-class A Object (x))
   ---
(DM-define-class C A (y (* z)))
   ---
(DM-define-class D C (t))
   ---
(DM-define-class E D ((* u)))
   ---
(DM-define-class F E (v))
   ---
(set! the-Point (make-F 'xx 'yy 3 'zz0 'zz1 'zz2 'tt 4 'u0 'u1 'u2 'u3 'vv))
   ---

(define (Class-fields class)
  (let ((n (DM-indexed-field-length class DM-Class-field-field)))
    (let enum ((i 0))
      (if (< i n)
          (cons (DM-indexed-field-value class DM-Class-field-field i)
                (enum (+ i 1)) )
          '() ) ) ) )
   ---
(length (Class-fields DM-Object-class))
   0
(length (Class-fields DM-Class-class))
   4
(let ((f (list-ref (Class-fields A-class) 0)))
  (DM-field-value the-Point f) )
   xx
(let ((f (list-ref (Class-fields C-class) 0)))
  (DM-field-value the-Point f) )
   xx
(let ((f (list-ref (Class-fields C-class) 1)))
  (DM-field-value the-Point f) )
   yy
(let ((f (list-ref (Class-fields C-class) 2)))
  (DM-indexed-field-value the-Point f 0) )
   zz0
(let ((f (list-ref (Class-fields C-class) 2)))
  (DM-indexed-field-value the-Point f 2) )
   zz2
(let ((f (list-ref (Class-fields D-class) 2)))
  (DM-indexed-field-value the-Point f 2) )
   zz2
(let ((f (list-ref (Class-fields F-class) 2)))
  (DM-indexed-field-value the-Point f 2) )
   zz2
(let ((f (list-ref (Class-fields D-class) 3)))
  (DM-field-value the-Point f) )
   tt
(let ((f (list-ref (Class-fields F-class) 4)))
  (DM-indexed-field-value the-Point f 2) )
   u2
(let ((f (list-ref (Class-fields F-class) 5)))
  (DM-field-value the-Point f) )
   vv
;;;;;;;;;;;;;;;;;;;;;;;;;;                        testing DM-set-field-value
;(let ((f (list-ref (Class-fields A-class) 0)))
;  (DM-set-field-value! the-Point 'xxx f)
;  (DM-field-value the-Point f) )
;   *** ; immutable field
;(let ((f (list-ref (Class-fields C-class) 0)))
;  (DM-set-field-value! the-Point 'xxxx f)
;  (DM-field-value the-Point f) )
;   *** ; immutable field by inheritance
(let ((f (list-ref (Class-fields C-class) 1)))
  (DM-set-field-value! the-Point f 'yyy)
  (DM-field-value the-Point f) )
   yyy
(let ((f (list-ref (Class-fields C-class) 2)))
  (DM-set-indexed-field-value! the-Point f 0 'zzz0)
  (DM-indexed-field-value the-Point f 0) )
   zzz0
(let ((f (list-ref (Class-fields C-class) 2)))
  (DM-set-indexed-field-value! the-Point f 2 'zzz2)
  (DM-indexed-field-value the-Point f 2) )
   zzz2
(let ((f (list-ref (Class-fields D-class) 2)))
  (DM-set-indexed-field-value! the-Point f 2 'zzz22)
  (DM-indexed-field-value the-Point f 2) )
   zzz22
(let ((f (list-ref (Class-fields F-class) 2)))
  (DM-set-indexed-field-value! the-Point f 2 'zzz222)
  (DM-indexed-field-value the-Point f 2) )
   zzz222
(let ((f (list-ref (Class-fields D-class) 3)))
  (DM-set-field-value! the-Point f 'ttt)
  (DM-field-value the-Point f) )
   ttt
(let ((f (list-ref (Class-fields F-class) 4)))
  (DM-set-indexed-field-value! the-Point f 2 'uu2)
  (DM-indexed-field-value the-Point f 2) )
   uu2
(let ((f (list-ref (Class-fields F-class) 5)))
  (DM-set-field-value! the-Point f 'vvv)
  (DM-field-value the-Point f) )
   vvv
;;;;;;;;;;;;;;;;;;;;;;; testing indexed-field-length
(let ((f (list-ref (Class-fields F-class) 2)))
  (DM-indexed-field-length the-Point f) )
   3
(let ((f (list-ref (Class-fields F-class) 4)))
  (DM-indexed-field-length the-Point f) )
   4
; not detected in Meroonet
;(let ((f (list-ref (Class-fields F-class) 3)))
;  (DM-indexed-field-length the-Point f) )
;   *** ; not a poly-field

;;; Additional tests on supplementary special forms or functions
;;; DM-generic, DM-method, DM-add-methods, call-former-method.

(DM-define-class P Object
  ((x :type nat2)
   (y :type nat2) ) )
   ---
(DM-define-class Q P
  ((next :type reference :refer Object)) )
   ---
(define m1 (DM-method (foo1 (o P-class) d)
              (+ (P-x o) (P-y o) d) ))
   ---
(define m11 (DM-method (foo11 (o P-class) d)
              (+ (P-x o) (P-y o) (- d)) ))
   ---
(define m1t (DM-method (foo41 (o P-class) d)
              (display `(foo41 <- ,o ,d))(newline)
              (let ((r (call-former-method o d)))
                (display `(foo41 -> ,r))(newline)
                (- r) ) ))
   ---
;;; test recursion through the label.
(define m2 (DM-method (foo2 (o Q-class) d)
              ;(DM-describe-all o)
              (* (call-next-method) d (DM-invoke foo2 (Q-next o) d)) ))
   ---
(define m2t (DM-method (foo42 (o Q-class) d)
              (display `(foo42 <- ,o ,d))(newline)
              (let ((r (call-former-method o d)))
                (display `(foo42 -> ,r))(newline)
                (- r) ) ))
   ---
(define f (DM-generic (foo3 (o) d) 
             1 ))
   ---
(DM-invoke f 2 3)
   1
(DM-invoke f (make-P 22 33) 4)
   1
;;; g = (m2:Q)
(define g (DM-add-methods f m2))
   ---
(DM-invoke g 2 3)
   1
(DM-invoke g (make-P 22 33) 4)
   1
(DM-invoke g (make-Q 2 3 (make-P 4 5)) 6)
   6
(DM-invoke g (make-Q 2 3 (make-Q 4 5 (make-P 6 7))) 8)
   64 ; (* 1 8 (* 1 8 1))
;;; g = (m1:P m2:Q)
(set! g (DM-add-methods f m1 m2))
   ---
(DM-invoke g 2 3)
   1
(DM-invoke g (make-P 22 33) 4)
   59
(DM-invoke g (make-Q 2 3 (make-P 4 5)) 6)
   990 ; (* (+ 2 3 6) 6 (+ 4 5 6))
(DM-invoke g (make-Q 2 3 (make-Q 4 5 (make-P 6 7))) 8)
   297024 ; (* (+ 2 3 8) 8 (* (+ 4 5 8) 8 (+ 6 7 8)))
;;; add same methods again: g = (m1:P m2:Q)
(set! g (DM-add-methods g m1 m2))
   ---
(DM-invoke g 2 3)
   1
(DM-invoke g (make-P 22 33) 4)
   59
(DM-invoke g (make-Q 2 3 (make-P 4 5)) 6)
   990 ; (* (+ 2 3 6) 6 (+ 4 5 6))
(DM-invoke g (make-Q 2 3 (make-Q 4 5 (make-P 6 7))) 8)
   297024 ; (* (+ 2 3 8) 8 (* (+ 4 5 8) 8 (+ 6 7 8)))
;;; change next-method: g = (m11:P m2:Q)
(set! g (DM-add-methods (DM-add-methods f m1 m2) m11))
   ---
(DM-invoke g 2 3)
   1
(DM-invoke g (make-P 22 33) 4)
   51
(DM-invoke g (make-Q 2 3 (make-P 4 5)) 6)
   -18 ; (* (+ 2 3 -6) 6 (+ 4 5 -6))
(DM-invoke g (make-Q 2 3 (make-Q 4 5 (make-P 6 7))) 8)
   -960 ; (* (+ 2 3 -8) 8 (* (+ 4 5 -8) 8 (+ 6 7 -8)))
;;; testing call-former-method. Same function as g but traced on Q.
;;; h = ((m11:P m2:Q) < (m11:P m2t:Q))
(define h (DM-add-methods g m2t))
   ---
(DM-invoke h 2 3)
   1
(DM-invoke h (make-P 22 33) 4)
   51
(DM-invoke h (make-Q 2 3 (make-P 4 5)) 6)
   18 ; plus some trace.
(DM-invoke h (make-Q 2 3 (make-Q 4 5 (make-P 6 7))) 8)
   -960 ; (- (* (+ 2 3 -8) 8 (- (* (+ 4 5 -8) 8 (- (+ 6 7 -8)))))) 
        ; plus some trace.
;;; testing call-former-method. Same function as g but traced on P.
;;; h = ((m11:P m2:Q) < (m1t:P m2:Q))
(set! h (DM-add-methods g m1t))
   ---
(DM-invoke h 2 3)
   1
(DM-invoke h (make-P 22 33) 4)
   -51 ; plus some trace
(DM-invoke h (make-Q 2 3 (make-P 4 5)) 6)
   -18 ; (* (- (+ 2 3 -6)) 6 (- (+ 4 5 -6))) plus some trace
(DM-invoke h (make-Q 2 3 (make-Q 4 5 (make-P 6 7))) 8)
   960 ; (* -3 8 (* 1 8 (- (+ 6 7 -8)))) plus some trace
       ;            1 = (- (+ 4 5 -8))
       ;    3 = (- (+ 2 3 -8))



"
*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                     Successful end of dmeroonet tests
*** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
"
   ---
;;; end of dmeroonet.tst
