;;; $Id: dump.tst,v 1.7 1995/09/23 18:20:44 queinnec Exp $

;;; Testing marshal/unmarshal-ing on a local basis.

;;; Prepare a connection for test.
;;; TEMP: most of the fields are empty since they are useless.
(define (create-thetcp sz)
  (let* ((be (DM-allocate1 DM-OutBuffer-class sz))
         (br (DM-allocate1 DM-InBuffer-class sz))
         (ce (DM-make DM-BoundedStack-class 0 2 DM-nil DM-nil))
         (cr (DM-make DM-BoundedStack-class 0 2 DM-nil DM-nil))
         (conn (DM-make DM-Connection-class
                        0               ; fd
                        5               ; retries
                        0               ; options
                        0               ; family
                        0               ; port
                        0               ; address
                        0               ; zero
                        br              ; reception
                        be              ; emission
                        0               ; clocker
                        DM-nil          ; site
                        '()             ; objects
                        ) ) )
    (DM-local-set DM-reference-type be DM-Buffer-port-field conn)
    (DM-local-set DM-reference-type br DM-Buffer-port-field conn)
    (DM-local-set DM-reference-type be DM-Buffer-cache-field ce)
    (DM-local-set DM-reference-type br DM-Buffer-cache-field cr)
    (DM-set-initialized be)
    (DM-set-initialized br)
    conn ) )
   ---
;;; (define thetcp (create-thetcp 30))
(define thetcp (create-thetcp 1024))
   ---
(define last-unmarshaled-object #f)
   ---
;;; Send an object onto the tcp, copy the emission buffer into the
;;; reception buffer then unmarshal and compare.
(define (marshal-unmarshal o)
  (let ((be (DM-field-value thetcp DM-Connection-emission-field))
        (br (DM-field-value thetcp DM-Connection-reception-field)) )
    ;; reset index of the emission buffer
    (DM-local-set DM-nat3-type be DM-Buffer-index-field 0)
    (DM-marshal be o)
    ;(newline) ;; DEBUG
    ;; copy the emission buffer into the reception buffer.
    (DM-local-copy
     (DM-local-length DM-nat3-type be DM-Buffer-byte-field)
     br
     (DM-indexed-compute-offset br DM-Buffer-byte-field 0)
     be
     (DM-indexed-compute-offset be DM-Buffer-byte-field 0) )
    ;; reset index/maximum of the reception buffer
    (DM-local-set DM-nat3-type br DM-Buffer-index-field 0)
    (DM-local-set DM-nat3-type br DM-Buffer-maximum-field
                  (DM-local-get DM-nat3-type be DM-Buffer-index-field) )
    ;; Use DM-unmarshal in Lisp
    (let ((newo (DM-unmarshal br)))
      (DM-local-set DM-nat3-type br DM-Buffer-index-field 0)
      ;; Use the direct DM-busy-read-object facility.
      (let ((othero (DM-busy-read-object br)))
        (set! last-unmarshaled-object newo)
        ;(unveil newo) ;; DEBUG
        (if (egal? o newo)
            (if (egal? o othero)
                #t
                `(wrong DM-busy-read-object ,o) )
            `(wrong DM-unmarshal ,o) ) ) ) ) )
   ---
;;; Compare two DMeroon objects.
(define (egal? o1 o2)
  (define memory '())
  (define (compare o1 o2)
    (define class (if (DM-is-object o1)
                      (DM-ObjectToClass o1)
                      #f ))
    (define (scan i t)
      (if (< i (DM-ClassToFieldLength class))
          (let* ((field          (DM-ClassToField class i))
                 (offsets-number (DM-FieldToOffsetLength field))
                 (last-offset    (DM-FieldToOffset field (- offsets-number 1)))
                 (reptypindex    (DM-OffsetToRepetitionTypeIndex last-offset))
                 (reptyp         (DM-index-to-type reptypindex))
                 (itemtypindex   (DM-OffsetToItemTypeIndex last-offset))
                 (itemtyp        (DM-index-to-type itemtypindex)) )
            (if (= DM-nought-index reptypindex)
                ;; Regular field
                (begin
                  (set! t (DM-OffsetPad t itemtyp))
                  ;;(display `(egal? itemtyp ,o1 ,o2 on ,t))(newline)
                  (and (compare (DM-local-read itemtyp o1 t)
                                (DM-local-read itemtyp o2 t) )
                       (scan (+ i 1) (DM-OffsetExtend t itemtyp)) ) )
                ;; Indexed field
                (begin
                  (set! t (DM-OffsetPad t reptyp))
                  (let ((rep (DM-local-read reptyp o1 t)))
                    ;;(display `(egal? reptyp ,o1 ,o2 on ,t (,rep)))(newline)
                    (and (= rep (DM-local-read reptyp o2 t))
                         (begin
                           (let enum ((j 0) (t (DM-OffsetExtend t reptyp)))
                             (if (< j rep)
                                 (begin
                                   (set! t (DM-OffsetPad t itemtyp))
                                   ;;(display `(egal? ,o1 ,o2 repitemtyp on ,t))(newline)
                                   (and (compare (DM-local-read itemtyp o1 t)
                                                 (DM-local-read itemtyp o2 t) )
                                        (enum (+ j 1) 
                                              (DM-OffsetExtend t itemtyp) ) ) )
                                 (scan (+ i 1) 
                                       (DM-OffsetRealign t) ) ) ) ) ) ) ) ) )
          #t ) )
    (or (eq? o1 o2)
        (let look ((mem memory))
          (if (pair? mem)
              (if (or (and (eq? o1 (caar mem))
                           (eq? o2 (cdar mem)) )
                      (and (eq? o1 (cdar mem))
                           (eq? o2 (caar mem)) ) )
                  (begin ;;(display `(supposed egal ,o1 ,o2))(newline)
                         #t )
                  (look (cdr mem)) )
              (begin (set! memory (cons (cons o1 o2) memory))
                     #f )) )
        (if (and (DM-is-object o1)
                 (DM-is-object o2) )
            (and (compare class (DM-ObjectToClass o2))
                 (scan 0 0) )
            (if (and (not (DM-is-object o1))
                     (not (DM-is-object o2)) )
                (or (equal? o1 o2)
                    (and (real? o1)(real? o2)(<= (abs (- o1 o2)) 0.0001)) )
                #f ) ) ) )
  (compare o1 o2) )
   ---


;;; a predefined object
(marshal-unmarshal DM-nil)
   #t
;;; a predefined class
(marshal-unmarshal DM-Class-class)
   #t
;;; a predefined type
(marshal-unmarshal DM-nat3-type)
   #t
;;; a repetition of an atomic value
(marshal-unmarshal (DM-make DM-String-class 3 #\a #\b #\c))
   #t
;;; an embedded reference
(marshal-unmarshal (DM-make DM-ImmutablePair-class DM-true DM-false))
   #t
;;; a repetition of embedded references with predefined objects.
(marshal-unmarshal
 (DM-make DM-ImmutableVector-class
          3 DM-true DM-false DM-nil ) )
   #t
;;; an empty sequence
(marshal-unmarshal
 (DM-make DM-ImmutableVector-class
          0 ) )
   #t
;;; sequences with embedded non predefined objects.
(marshal-unmarshal
 (DM-make DM-ImmutableVector-class
          1 (DM-make DM-ImmutablePair-class DM-true DM-false) ) )
   #t
(marshal-unmarshal
 (DM-make DM-ImmutableVector-class
          3 (DM-make DM-String-class 3 #\a #\b #\c)
            DM-nil
            (DM-make DM-ImmutablePair-class
                     DM-true DM-false ) ) )
   #t

;;; testing cache
(let* ((o (DM-make DM-String-class 3 #\a #\b #\c))
       (o2 (DM-make DM-ImmutableVector-class 2 o o)) )
  (marshal-unmarshal o2) )
   #t
(let* ((o (DM-make DM-String-class 3 #\a #\b #\c))
       (o2 (DM-make DM-ImmutableVector-class 4 o o o o))
       (o3 (DM-make DM-ImmutableVector-class 2 o2 o)) )
  (marshal-unmarshal o2) )
   #t
;;; more objects in the cache
(let* ((o (DM-make DM-String-class 3 #\a #\b #\c))
       (o2 (DM-make DM-ImmutableVector-class 4 o o o o))
       (o3 (DM-make DM-ImmutableVector-class 2 o2 o))
       (o4 (DM-make DM-ImmutablePair-class o3 o2))
       (o5 (DM-make DM-ImmutableVector-class 4 o o2 o3 o4 )) )
  (marshal-unmarshal o4) )
   #t

;;; test cyclic objects.
(let ((o (DM-allocate1 DM-ImmutableVector-class 1)))
  (DM-local-indexed-set DM-reference-type o DM-ImmutableVector-item-field 0 o)
  (DM-set-initialized o)
  (marshal-unmarshal o) )
   #t
;;; test mutually referencing objects
(let ((o1 (DM-allocate1 DM-ImmutableVector-class 1))
      (o2 (DM-allocate1 DM-ImmutableVector-class 1)) )
  (DM-local-indexed-set DM-reference-type o1 DM-ImmutableVector-item-field 0 o2)
  (DM-local-indexed-set DM-reference-type o2 DM-ImmutableVector-item-field 0 o1)
  (DM-set-initialized o1)
  (DM-set-initialized o2)
  (marshal-unmarshal o1) )
   #t


;;; send data (ie scheme) values.
(let ((o (DM-make DM-Data-class '(a #t "abc"))))
  (marshal-unmarshal o) )
   #t

;;; a non predefined class.
(define Point-class
  (DM-create-class "Point" DM-Object-class 1
                   "-field" "x" ) )
   ---
(marshal-unmarshal Point-class)
   #t
(marshal-unmarshal (DM-make Point-class DM-nil))
   #t
(marshal-unmarshal (DM-make Point-class Point-class))
   #t

;;; problems with int4
(marshal-unmarshal (DM-make DM-Int4-class 305419896)) ; (- #x12345678)
   #t
;;; problems with float2.
(marshal-unmarshal (DM-make DM-Float2-class -34.56))
   #t

;;; Create a class with many non pointer types.
(define Testf-class
  (DM-create-class "Testf" DM-Object-class 25
   "-field" "nat1" "-type" DM-nat1-type
   "-field" "nat2" "-type" DM-nat2-type
   "-field" "nat3" "-type" DM-nat3-type
   "-field" "nat4" "-type" DM-nat3-type
   "-field" "int1" "-type" DM-int1-type
   "-field" "int2" "-type" DM-int2-type
   "-field" "int3" "-type" DM-int3-type
   "-field" "int4" "-type" DM-int3-type
   "-field" "int1" "-type" DM-int1-type
   "-field" "int2" "-type" DM-int2-type
   "-field" "int3" "-type" DM-int3-type
   "-field" "int4" "-type" DM-int3-type
   "-field" "char1" "-type" DM-char1-type
   "-field" "netnat2" "-type" DM-netnat2-type
   "-field" "netnat3" "-type" DM-netnat3-type
   "-field" "float1" "-type" DM-float1-type
   "-field" "float2" "-type" DM-float2-type
   "-field" "float1" "-type" DM-float1-type
   "-field" "float2" "-type" DM-float2-type
   "-field" "float1" "-type" DM-float1-type
   "-field" "float2" "-type" DM-float2-type
   "-field" "float1" "-type" DM-float1-type
   "-field" "float2" "-type" DM-float2-type
   "-field" "float1" "-type" DM-float1-type
   "-field" "float2" "-type" DM-float2-type ) )
   ---

;;; send the class
(marshal-unmarshal Testf-class)
   ---

;;; send an instance of that class.
(marshal-unmarshal
 (DM-make Testf-class
          11 
          4660 ; #x1234
          305419896 ; #x12345678
          305419896 ; #x12345678                    ; nat4
          11 
          4660 ; #x1234
          305419896 ; #x12345678
          305419896 ; #x12345678                    ; int4
          (- 11)
          -4660 ; (- #x1234)
          -305419896 ; (- #x12345678)
          -305419896 ; (- #x12345678)                ; int4
          #\Q
          4660 ; #x1234                        ; netnat2
          703710 ; #x0abcde                      ; netnat3
          0.0                           ; float1
          0.0                           ;   float2
          3.14                          ; float1
          2.78e+5                       ;   float2
          3.14e-4                       ; float1
          2.78e-7
          -3.14e+4                      ; float1
          -2.78e+7
          -3.14e-4                      ; float1
          -2.78e-7 ) )
   #t


;;; sending symbols.
(marshal-unmarshal (DM-make DM-Symbol-class (->String "abc")))
   #t
(let ((s #f)(s1 #f)(s2 #f))
  (set! s (DM-make DM-Symbol-class (->String "abc")))
  (marshal-unmarshal s)
  (set! s1 last-unmarshaled-object)
  (marshal-unmarshal s)
  (set! s2 last-unmarshaled-object)
  (eq? s1 s2) )
   #t

;;; This is too huge for a simple bounded buffer as allocated above.
;(marshal-unmarshal DM-site)
;   #t


" *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                      All dump.tst tests successfully run!
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***"
   ---

;;; end of dump.tst
