;;; $Id: exchng1.tst,v 1.8 1997/08/17 19:30:49 queinnec Exp $

;;; This file is to be evaluated by a server (the other being known as
;;; OTHER). OTHER will send a number of objects to test the
;;; marshaling/unmarshaling code.  The current site will just check
;;; that it receives the right objects.

(define other (wait-for-site 100))
   ---

;;; Wait and check received objects.
(eq? (DM-receive-object) DM-false)
   #t
(eq? (DM-receive-object) DM-Class-class)
   #t
(eq? (DM-receive-object) DM-nought-type)
   #t
(eq? (DM-receive-object) DM-nat3-type)
   #t
(eq? (DM-receive-object) DM-Site-support-field)
   #t
(eq? (DM-receive-object) DM-site)
   #t
(eq? (DM-receive-object) other)
   #t
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   11
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   253
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   305419896
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (eq? (DM-field-value o f) DM-site) )
   #t
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   127
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   -127
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   32767
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   -32767
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   8388607
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   -8388607
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   #\q
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   65535
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   305419896
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   3.14e+2
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   -3.14e+2
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   3.14e+2
(let* ((o     (DM-receive-object))
       (class (DM-class-of o))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-field-value o f) )
   -3.14e+2

;;; Try now more complex objects. 
;;; An indexed Vector.
(let* ((o     (DM-receive-object)))
  (and (DM-is-a? o DM-ImmutableVector-class)
       (= 100 (DM-indexed-field-length o DM-ImmutableVector-item-field))
       (eq? DM-nil (DM-indexed-field-value
                    o DM-ImmutableVector-item-field 55 )) ) )
   #t

;;; Receive a Bigloo Scheme value (#t, 37) from a data field
(let ((o (DM-receive-object)))
  (eq? #t (DM-field-value o DM-Data-value-field)) )
   #t
(let ((o (DM-receive-object)))
  (= 37 (DM-field-value o DM-Data-value-field)) )
   #t


" *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                      All exchng1.tst tests successfully run!
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***"
   ---

;;; end of exchng1.tst
