;;; $Id: exchng2.tst,v 1.6 1997/07/14 19:02:29 queinnec Exp $

;;; This file is to be evaluated by a server (the other being known as
;;; OTHER). A Connection to OTHER is supposed to be established. The
;;; current site then send a series of objects. Normally these objects
;;; are directly and completely encoded so DM-field-value on OTHER is
;;; purely local and does not require the remote fetching protocol.

;;; A function to send an object and flush the message right after.
(define (DM-send-object o)
  (DM-send o other)
  (DM-serve 1) )
   ---

;;; Send simple objects of different types.
(DM-send-object DM-false)
   ---
(DM-send-object DM-Class-class)
   ---
(DM-send-object DM-nought-type)
   ---
(DM-send-object DM-nat3-type)
   ---
(DM-send-object DM-Site-support-field)
   ---
(DM-send-object other)
   ---
(DM-send-object DM-site)
   ---
(let* ((class DM-nat1-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f 11)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-nat2-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f 253)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-nat3-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f 305419896)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-reference-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f other)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
;;; Transmit something that may be understood in the other Scheme !?
;;; Should be done elsewhere.
;(let* ((class DM-data-class)
;       (o     (DM-allocate class))
;       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
;  (DM-set-field-value! o f #t)
;  (DM-set-copyable! o)
;  (DM-send-object o) )
;   ---
(let* ((class DM-int1-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f 127)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-int1-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f -127)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-int2-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f 32767)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-int2-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f -32767)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-int3-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f 8388607)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-int3-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f -8388607)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-char1-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f #\q)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-netnat2-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f 65535)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-netnat3-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f 305419896)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-float1-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f 3.14e+2)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-float1-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f -3.14e+2)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-float2-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f 3.14e+2)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-float2-class)
       (o     (DM-allocate class))
       (f     (DM-indexed-field-value class DM-Class-field-field 0)) )
  (DM-set-field-value! o f -3.14e+2)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---

;;; Try now more complex objects
;;; An indexed Vector.
(let* ((class DM-ImmutableVector-class)
       (o     (DM-allocate class 100)) )
  (DM-set-indexed-field-value! o DM-ImmutableVector-item-field 55 DM-nil)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---

;;; Try to send a Bigloo Scheme value (#t, 37) in a data field
(let* ((class DM-Data-class)
       (o     (DM-allocate class)) )
  (DM-set-field-value! o DM-Data-value-field #t)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---
(let* ((class DM-Data-class)
       (o     (DM-allocate class)) )
  (DM-set-field-value! o DM-Data-value-field 37)
  (DM-set-copyable! o)
  (DM-send-object o) )
   ---

;;; After sending the last object (right before), wait a little then
;;; exits. This end of file will finish the server, OTHER will notify
;;; it and finishes as well.

(DM-serve 10)
   ---

" *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                      All exchng2.tst tests successfully run!
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***"
   ---

;;; end of exchng2.tst
