;;; $Id: exchng3.tst,v 1.10 1997/07/14 19:02:29 queinnec Exp $

;;; This file is to be evaluated by a server (the other being known as
;;; TWO). The current site tries to pull as much as possible from the
;;; published objects of TWO.

(define two (wait-for-site 100))
   ---

;;; Fetch the string that names the support language.
(DM-is-a? (DM-field-value two DM-Site-support-field) DM-String-class)
   #t
;;; Verify that the support string is well arrived.
(DM-is-a? (DM-field-value two DM-Site-support-field) DM-String-class)
   #t

;;; Try to cache locally all the objects published by TWO.
(define two-clock (DM-field-value two DM-Site-clock-field))
   ---
(DM-is-a? two-clock DM-Clock-class)
   #t
(number? (DM-field-value two-clock DM-Clock-time-field))
   #t

(define two-dict0 (DM-field-value two DM-Site-information-field))
   ---
(DM-is-a? two-dict0 DM-Dictionary-class)
   #t
(DM-field-value two-dict0 DM-Dictionary-value-field)))
   ---
(let loop ((d two-dict0))
  (display `(examining ,d))(newline)
  (if (and (DM-is-object? d)
           (DM-is-a? d DM-Dictionary-class) )
      (let ((v (DM-field-value d DM-Dictionary-value-field)))
        ;;(loop v) ; non recursive
        (DM->string d DM-Dictionary-name-field)
        (loop (DM-field-value d DM-Dictionary-rest-field)) ) ) )
   ---
;;; And now recursively on the values again.
(let loop ((d two-dict0))
  (display `(examining ,d))(newline)
  (if (and (DM-is-object? d)
           (DM-is-a? d DM-Dictionary-class) )
      (let ((v (DM-field-value d DM-Dictionary-value-field)))
        (loop v) ; recursive now!
        (DM->string d DM-Dictionary-name-field)
        (loop (DM-field-value d DM-Dictionary-rest-field)) ) ) )
   ---

;;; Brings all the protocols of TWO locally
(let loop ((d (DM-field-value two DM-Site-protocol-field)))
  (display `(examining ,d))(newline)
  (if (and (DM-is-object? d)
           (DM-is-a? d DM-Protocol-class) )
      (let ((v (DM-field-value d DM-Protocol-next-field)))
        (loop v) ) ) )
   ---
;;; Now they are all cached, re-ask for them.
(let loop ((d (DM-field-value two DM-Site-protocol-field)))
  (display `(examining ,d))(newline)
  (if (and (DM-is-object? d)
           (DM-is-a? d DM-Protocol-class) )
      (let ((v (DM-field-value d DM-Protocol-next-field)))
        (loop v) ) ) )
   ---

;;; Tells TWO to shut down.
;;; A function to send an object and flush the message right after.
(define (DM-send-object o)
  (DM-send o two)
  (DM-serve 10) )
   ---

(DM-send-object DM-false)
   ---

" *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                      All exchng3.tst tests successfully run!
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***"
   ---

;;; end of exchng3.tst
