;;; $Id: highrt.tst,v 1.6 1997/08/17 19:30:49 queinnec Exp $

;;; This file tests the high-level accessors of DMeroon instances.

'(load "highrt.scm")
   ---

;;; Testing read access, regular or indexed.
(field-value DM-nat3-type DM-type-name-field)
   ---
(eq? (field-value DM-nat3-type DM-type-name-field)
     (DM-TypeToName DM-nat3-type) )
   #t
(field-value (field-value DM-nat3-type DM-type-name-field) 
             DM-String-character-field
             0 )
   #\n
;;; exercice errors.
(field-value DM-nat3-type DM-class-name-field)
   *** ; no such field
(field-value 'foo DM-class-name-field)
   *** ; not a dmeroon object
(field-value (field-value DM-nat3-type DM-type-name-field) 
             DM-String-character-field )
   *** ; missing index
(field-value DM-nat3-type DM-type-name-field 44)
   *** ; superfluous index
(field-value (field-value DM-nat3-type DM-type-name-field) 
             DM-String-character-field
             55 )
   *** ; out of range index
(field-value (field-value DM-nat3-type DM-type-name-field) 
             DM-String-character-field
             -2 )
   *** ; out of range index

;;; Testing length access
(indexed-field-length (field-value DM-nat3-type DM-type-name-field)
                DM-String-character-field )
   5 ; "nat3" + final null.
(indexed-field-length (field-value DM-nat3-type DM-type-name-field)
                DM-type-name-field )
   *** ; wrong class
(indexed-field-length DM-nat3-type DM-type-name-field)
   *** ; not an indexed field
(indexed-field-length #t DM-type-name-field)
   *** ; not a dmeroon object

;;; testing write access.
;;; tests are missing since there are no predefined indexed mutable objects.
(let* ((infos (field-value DM-site (DM-ClassToField DM-Site-class 4)))
       (old   (field-value infos DM-Dictionary-value-field)) )
  (set-field-value! infos DM-nil DM-Dictionary-value-field)
  (set-field-value! infos old DM-Dictionary-value-field) )
   ---
(let ((infos (DM-local-get DM-reference-type DM-site
                     (DM-ClassToField DM-Site-class 4) )))
  (set-field-value! infos #\Q DM-Dictionary-name-field 1) )
   *** ; immutable



" *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                      All highrt.tst tests successfully run!
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***"
   ---

;;; end of highrt.tst
