;;; $Id: msg.tst,v 1.4 1998/04/29 09:20:28 queinnec Exp $

;;; This file tests the low level message machinery. It inquires some
;;; inner DMeron data structures to chose appropriate sizes of
;;; messages send/receive. 

(define (test-send othersite)
  (define sz 0)
  (define (send-string i)
    ;; Get the connection to othersite
    (let ((connection (DM-field-value othersite DM-Site-connection-field)))
      (if (DM-is-a? connection DM-Connection-class)
          (let* ((outbuffer 
                  (DM-field-value connection DM-Connection-emission-field))
                 ;; get its size and current index
                 (size 
                  (DM-indexed-field-length outbuffer DM-Buffer-byte-field) )
                 (index (DM-field-value outbuffer DM-Buffer-index-field))
                 (s (DM-allocate DM-String-class i)) )
            (DM-set-copyable! s)
            (DM-send s othersite)
            (let* ((size0  
                    (DM-indexed-field-length outbuffer DM-Buffer-byte-field))
                   (index0 
                    (DM-field-value outbuffer DM-Buffer-index-field)) )
              (display `(index was ,index is ,index0 /
                               size was ,size is ,size0 ))
              (newline)                 ; DEBUG
              (DM-serve 1)
              (- index0 index) ) )
          (DM-error 'test-send "not a Connection" connection) ) ) )
  (if (DM-is-a? othersite DM-Site-class)
      (begin
        (set! sz (send-string 0))  ; 38 for now
        (for-each (lambda (size)
                    (newline)(display `(**** testing ,size ****))
                    (newline)(newline)
                    (send-string size) )
                  (list (- 1023 sz) (- 1024 sz) (- 1025 sz)
                        (- 2047 sz) (- 2048 sz) (- 2049 sz) 
                        (- 4095 sz) (- 4096 sz) (- 4097 sz) 
                        ) )
        ;; Serve a little to drain outbuffers.
        (DM-serve 20)
        " *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** 
                  End of msg.tst
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** "
        )
      (DM-error 'test-send "not a Site" othersite) ) )

;;; end of msg.tst
