;;; $Id$

;;; Check all the objects that are reachable through the site.
;;; Assume TOP/DMeroon/dmlib.scm file to be loaded.

(define TWO (DM-connect "localhost" 56217))
   ---

;;; Check whether all exported objects of another site are initialized
;;; (as well as their class).

(define (check-all o)
  (define all (list)) ; list of all checked objects
  (call/cc
   (lambda (exit)
     (define (check o path)
       (if (and o (not (memq o all)))
           (let ((path (cons o path)))
             (define (check-item o field itemtyp)
               (if (eq? itemtyp DM-reference-type)
                   (check (DM-field-value o field) path)
                   #f ) )
             (define (check-length o field reptyp itemtyp)
               #f )
             (define (check-indexed-item o field itemtyp j)
               (if (eq? itemtyp DM-reference-type)
                   (check (DM-indexed-field-value o field j) path)
                   #f ) )
             (set! all (cons o all))
             (display `(checking ,path))(newline)
             ;; Check the class
             '''''''(check (DM-class-of o) path)
             ;; Check content if not an Entry.
             (if (not (DM-is-a? o DM-Entry-class))
                 (if (DM-is-initialized? o)
                     (DM-iterate o check-item check-length check-indexed-item)
                     (exit path) ) ) ) ) )
     (check o (list))
     #f ) ) )
   ---

(check-all TWO)
   #f


" *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                      All othersite.tst tests successfully run!
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***"
   ---

;;; end of othersite.tst
