;;; $Id: tcp.tst,v 1.12 1995/12/29 18:05:24 queinnec Exp $

;;; Testing tcp connections. 
;;; This obsolete function is there since much tests use it.
(define (DM-send-some-bytes connection string)
  (DM-print-char-star string 0 connection) )
   ---
(define DM-receive-some-bytes
  (lambda (connection bytes)
    (let ((buf (DM-local-get DM-reference-type connection 
                       DM-Connection-reception-field ))
          (len (string-length bytes))
          (i   0) )
      (let retry ()
        (let ((maximum (DM-local-get DM-nat3-type buf DM-Buffer-maximum-field)))
          (let loop ((index (DM-local-get DM-nat3-type buf DM-Buffer-index-field)))
            (if (< i len)
                (if (< index maximum)
                    (let ((char (DM-local-indexed-get DM-char1-type buf 
                                                DM-Buffer-byte-field index )))
                      (string-set! bytes i char)
                      (set! i (+ i 1))
                      (loop (+ index 1)) )
                    (begin 
                      (DM-local-set DM-nat3-type buf DM-Buffer-index-field index)
                      (DM-fill-connection connection)
                      (retry) ) )
                ;; return the updated string.
                (begin
                  (DM-local-set DM-nat3-type buf DM-Buffer-index-field index)
                  bytes ) ) ) ) ) ) ) )
   ---

;;; Read some bytes emitted by an external server. Choose here the
;;; date server (port 13) which answers as soon as connected.
(let ()
  (define c 1)
  (define received 2)
  (define result #f)
  ;; connect to the date server.
  (set! c (DM-connect "localhost" 13))
  (html-unveil c (current-output-port))
  ;; get the reception buffer.
  (set! received (field-value
                  c (->Field (DM-ObjectToClass c) "reception") ))
  (html-unveil received (current-output-port))
  ;; set the first character of this reception buffer.
  (DM-local-indexed-set dm-char1-type
                  received
                  (->Field (DM-ObjectToClass received) "byte")
                  0
                  #\! )
  (html-unveil received (current-output-port))
  ;; read the banner of the server.
  (DM-fill-connection c)
  (html-unveil c (current-output-port))
  (html-unveil received (current-output-port))
  ;; check we receive it ie the first character changes.
  (set! result
        (DM-local-indexed-get dm-char1-type
                        received
                        (->Field (DM-ObjectToClass received) "byte")
                        0 ) )
  ;; close connection (but consume characters before)
  (DM-process-all-received-bytes c display)
  (DM-finish-connection c)
  ;; check that the first character has been overwritten.
  (char=? result #\!) )
  #f

;;; Read many bytes from the chargen server (port 19). chargen is
;;; character generator. It answers as soon as it is connected with as
;;; many characters the client can read.
(let ()
  (define c 1)
  (define received 2)
  (define n #f)
  (define m #f)
  ;; connect to the date server.
  (set! c (DM-connect "localhost" 19))
  ;; get the reception buffer.
  (set! received (DM-local-get DM-reference-type 
                         c
                         (->Field (DM-ObjectToClass c) "reception") ))
  ;; read the output of the server.
  ;; sometime, we read the length of the buffer (1024), sometime (on solaris)
  ;; we just read the first line (74 characters).
  (DM-fill-connection c)
  (html-unveil c (current-output-port))
  (html-unveil received (current-output-port))
  ;; get the number of read bytes
  (set! n (DM-local-get dm-nat3-type
                  received
                  (->Field (DM-ObjectToClass received) "maximum") ))
  ;; consume the received bytes
  (DM-local-set dm-nat3-type
          received
          (->Field (DM-ObjectToClass received) "index")
          n )
  (html-unveil received (current-output-port))
  ;; read again
  (DM-fill-connection c)
  (html-unveil c (current-output-port))
  (html-unveil received (current-output-port))
  ;; get the number of read bytes
  (set! m (DM-local-get dm-nat3-type
                  received
                  (->Field (DM-ObjectToClass received) "maximum") ))
  ;; consume the received bytes
  (DM-local-set dm-nat3-type
          received
          (->Field (DM-ObjectToClass received) "index")
          m )
  ;; close connection
  (DM-finish-connection c)
  ;; check that we received the correct number of bytes.
  (and (= (+ n m) (DM-local-get dm-nat4-type
                          c
                          (->Field (DM-ObjectToClass c) "read") )) )
  )
  #t

;;; Write bytes to the echo server (port 7) and check them on return.
(let ()
  (define c 1)
  (define received 2)
  (define emitted 3)
  (define result 4)
  ;; connect to the date server.
  (set! c (DM-connect "localhost" 7))
  ;; get the reception/emission buffers.
  (set! received (DM-local-get DM-reference-type 
                         c
                         (->Field (DM-ObjectToClass c) "reception") ))
  (set! emitted (DM-local-get DM-reference-type 
                        c
                        (->Field (DM-ObjectToClass c) "emission") ))
  ;; prepare some bytes
  (DM-send-some-bytes c "Welcome")
  ;;(DM-send-one-byte c #\Return)
  (html-unveil c (current-output-port))
  (html-unveil emitted (current-output-port))
  ;; send these some bytes
  (DM-flush-connection c)
  (html-unveil c (current-output-port))
  (html-unveil emitted (current-output-port))
  ;; receive some bytes
  (DM-fill-connection c)
  (html-unveil c (current-output-port))
  (html-unveil received (current-output-port))
  (set! result "1234567")
  (DM-receive-some-bytes c result)
  ;; drain remaining characters
  (DM-process-all-received-bytes c display)
  ;; close connection
  (DM-close-ports c)
  result )
  "Welcome"

;;; Write many bytes to the echo server (port 7) and check their
;;; correct number on return. Send much more than the buffer can hold.
(let ()
  (define c 1)
  (define received 2)
  (define emitted 3)
  (define result 4)
  (define n 5)
  (define str (make-string 1300 #\?))
  ;; connect to the date server.
  (set! c (DM-connect "localhost" 7))
  ;; get the reception/emission buffers.
  (set! received (DM-local-get DM-reference-type 
                         c
                         (->Field (DM-ObjectToClass c) "reception") ))
  (set! emitted (DM-local-get DM-reference-type 
                        c
                        (->Field (DM-ObjectToClass c) "emission") ))
  ;; get the length of the reception buffer
  (set! n (DM-local-length dm-nat3-type
                     received
                     (->Field (DM-ObjectToClass received) "byte") ))
  ;; prepare many bytes
  (DM-send-some-bytes c str)
  (html-unveil c (current-output-port))
  ;; send these some bytes
  (DM-flush-connection c)
  (html-unveil c (current-output-port))
  (html-unveil emitted (current-output-port))
  ;; receive some bytes
  (do ((i 0 (+ i 1)))
      ((>= (DM-local-get dm-nat4-type
                   c
                   (->Field (DM-ObjectToClass c) "read") )
           1300))
    (DM-fill-connection c)
    (DM-local-set dm-nat3-type
            received
            (->Field (DM-ObjectToClass received) "index")
            n ) )
  (html-unveil c (current-output-port))
  (html-unveil received (current-output-port))
  #t )
   #t

;;; Open a server and a perl client and make them dialog.
(let ()
  (define s 1)
  (define cs 2) 
  (define c 3)
  (define result 4)
  ;; register a server
  (define s (DM-create-server DM-default-port 5))
  ;; spawn a future client
  (system (string-append "client.sh -5 localhost "
                         (number->string DM-default-port)
                         " aaa BBBBB " ))
  ;; wait for this client to connect
  (set! cs (DM-accept-connection s))
  ;; send to the client a banner
  (DM-send-some-bytes cs "Hello!")
  (DM-send-one-byte cs (char->integer #\newline))
  (DM-flush-connection cs)
  ;; read a line from the client and display it
  (DM-fill-connection cs)
  (DM-process-all-received-bytes cs display)
  ;; resend a line in two packets to the client
  (DM-send-one-byte cs (char->integer #\a))
  (DM-flush-connection cs)
  (DM-send-some-bytes cs "bcdefghi")
  (DM-send-one-byte cs (char->integer #\newline))
  (DM-flush-connection cs)
  ;; read a second line from client
  (DM-fill-connection cs)
  (set! result (DM-receive-some-bytes cs "BBBBB"))
  (DM-process-all-received-bytes cs display)
  ;; close connection
  (DM-finish-connection cs)
  ;; close server
  (DM-finish-server s)
  ;; leave time to free the port for the next test.
  (system "sleep 45")
  result )
   "BBBBB"

;;; Open a server and two perl clients and make them all dialogs
(let ()
  (define s 1)
  (define cs 2)
  (define cc 3)
  (define result 4)
  ;; spawn two future clients
  (system (string-append "client.sh -3 localhost "
                         (number->string (+ 1 DM-default-port))
                         " aaa BBBBB " ))
  (system (string-append "client.sh -2 localhost "
                         (number->string (+ 1 DM-default-port))
                         " ccc DDDDD " ))
  ;; register a server
  (set! s (DM-create-server (+ 1 DM-default-port) 5))
  ;; wait for these clients to connect
  (set! cs (DM-accept-connection s))
  (set! cc (DM-accept-connection s))
  ;; send to these clients a banner
  (DM-send-some-bytes cs "Hello!")
  (DM-send-one-byte cs (char->integer #\newline))
  (DM-flush-connection cs)
  (DM-send-some-bytes cc "Hello!")
  (DM-send-one-byte cc (char->integer #\newline))
  (DM-flush-connection cc)
  ;; read a line from the clients and display it
  (DM-fill-connection cs)
  (DM-process-all-received-bytes cs display)
  (DM-fill-connection cc)
  (DM-process-all-received-bytes cc display)
  ;; resend a line in two packets to the clients
  (DM-send-one-byte cs (char->integer #\a))
  (DM-flush-connection cs)
  (DM-send-some-bytes cs "bcdefghi")
  (DM-send-one-byte cs (char->integer #\newline))
  (DM-flush-connection cs)
  (DM-send-one-byte cc (char->integer #\a))
  (DM-flush-connection cc)
  (DM-send-some-bytes cc "bcdefghi")
  (DM-send-one-byte cc (char->integer #\newline))
  (DM-flush-connection cc)
  ;; read a second line from client
  (DM-fill-connection cs)
  (DM-fill-connection cc)
  (set! result (cons (DM-receive-some-bytes cs "bbbbb")
                     (DM-receive-some-bytes cc "bbbbb") ))
  ;; close everything
  (DM-close-ports)
  ;; leave time to free the port for the next test.
  (system "sleep 45")
  (or (equal? result '("BBBBB" . "DDDDD"))
      (equal? result '("DDDDD" . "BBBBB")) ) )
   #t

;;; testing DM-select-tcp on a single client. It must detect that a Server
;;; becomes readable so a connection is wanting to be accepted.
(let ()
  (define s 1)
  (define result 2)
  (define cs 3)
  ;; open a server
  (set! s (DM-create-server (+ 2 DM-default-port) 5))
  ;; starts a client
  (system (string-append "client.sh -4 localhost "
                         (number->string (+ 2 DM-default-port))
                         " aaa BBBBB " ))
  ;; waits for the connection
  (set! result (DM-select-tcp 15 0))
  (if (DM-object? result)
      (begin
        (html-unveil result (current-output-port))
        ;; accept it
        (set! cs (DM-accept-connection result))
        (set! result cs)
        ;; cs waits for a banner
        (let exhaust ()
          (DM-send-some-bytes result "Hello")
          (DM-send-one-byte result (char->integer #\newline))
          (DM-flush-connection result)
          (DM-fill-connection result)
          (DM-process-all-received-bytes result display)
          (set! result (DM-select-tcp 10 1))
          (if result (exhaust)) )
        ;; close everything
        (DM-close-ports)
        ;; leave time to free the port for the next test.
        (system "sleep 45")
        #t )
      (begin 
        ;; close everything
        (DM-close-ports)
        ;; leave time to free the port for the next test.
        (system "sleep 45")
        #f) ) )
   #t

;;; testing DM-select-tcp on multiple clients
(let ()
  (define s 1)
  (define result 2)
  (define cs 3)
  ;; nothing !
  (set! result (DM-select-tcp 0 0))
  (if (DM-object? result) (html-unveil result (current-output-port)))
  ;; open a server
  (set! s (DM-create-server (+ 3 DM-default-port) 5))
  ;; start clients
  (system (string-append "client.sh localhost "
                         (number->string (+ 3 DM-default-port))
                         " aaa BBBBB " ))
  (system (string-append "client.sh localhost "
                         (number->string (+ 3 DM-default-port))
                         " ccc DDDDD EEEE ffff " ))
  ;; waits for connections and use them
  (let exhaust ((counting 1000))
    (set! result (DM-select-tcp 10 1))
    (cond (result 
           (if (DM-is-a? result DM-Server-class)
               (begin
                 (set! result (DM-accept-connection result))
                 ;; send a banner then read some bytes
                 (DM-send-some-bytes result (number->string counting))
                 (DM-send-one-byte result (char->integer #\newline))
                 (DM-flush-connection result) )
               (begin
                 ;; read from the connection and send some bytes
                 (DM-fill-connection result)
                 (DM-process-all-received-bytes result display)
                 (DM-send-some-bytes result (number->string counting))
                 (DM-send-one-byte result (char->integer #\newline))
                 (DM-flush-connection result) ) )
           (exhaust (+ counting 1)) )
          (else (set! result counting)) ) )
  ;; close everything
  (DM-close-ports)
  (system "sleep 45")
  result
  )
   1010

;;; Open a server and two clients, both Meroon and use select between them.
;;; NOTE: It seems that you cannot open a tcp with yourself?
;;; Francis Dupont told me it is a known bug trying to connect a socket
;;; with itself.
'''
(let ()
  (define s 1)
  (define result 2)
  (define cs 3)
  (define cc 3)
  ;; nothing !
  (set! result (DM-select-tcp 0 0))
  (if (DM-object? result) (html-unveil result (current-output-port)))
  ;; open a server
  (set! s (DM-create-server (+ 4 DM-default-port) 5))
  ;; start clients
  (set! cs (DM-connect "localhost"))
  (set! cc (DM-connect "localhost"))
  ;; waits for connections and use them
  (let exhaust ((counting 1000)(i 0))
    (set! result (DM-select-tcp 10 1))
    (if result
        (begin
          (if (DM-is-a? result DM-Server-class)
              ;; accept the waiting connection from the server
              (begin
                (set! result (DM-accept-connection result)) )
              ;; accept the incoming bytes from the connection
              (begin
                (DM-fill-connection result)
                (DM-process-all-received-bytes result display) ) )
          ;; send a banner 
          (if (< i 20)
              (begin
                (DM-send-some-bytes result (number->string counting))
                (DM-send-one-byte result (char->integer #\newline))
                (DM-flush-connection result) )
              (DM-finish-connection result) )
          (exhaust (+ counting 1) (+ i 1)) ) ) )
  ;; close everything
  (DM-close-ports)
  )
   ---

;;; Try to overflow a connection.
;;; SonyNews blocks when sending the 32nd or 33th block of 1Kbyte.
;;; Same problem as the previous test: cannot open a tcp with oneself!
'''
(let ()
  (define c 1)
  (define s 2)
  (define cs 3)
  (define room 16000)
  (define str (make-string 397 #\?))
  (define reception-field (->Field DM-Connection-class "reception"))
  (define maximum-field (->Field DM-Buffer-class "maximum"))
  ;; open a working connection
  (set! s (DM-create-server (+ 5 DM-default-port) 5))
  (set! cs (DM-connect "localhost"))
  (set! c (DM-accept-connection s))
  ;; fill it with many bytes
  (let fill ((i 0))
    (display `(sent ,i bytes))(newline)
    (DM-select-tcp 0 0) ; just to see if c becomes readable
    (if (< i room)
        (begin
          ;; send bytes by bursts of 397 bytes.
          (DM-send-some-bytes cs str)
          (fill (+ i (string-length str))) )
        (begin (DM-flush-connection cs)
               ;; check we receive all of them
               (let receive ((j 0))
                 (if (< j room)
                     (begin
                       ;; receive bytes by bunch of 1024 characters.
                       (DM-fill-connection c)
                       (DM-process-all-received-bytes
                        c (lambda (byte) byte) )
                       (set! j (+ j (DM-local-get dm-nat3-type
                                            (DM-local-get DM-reference-type
                                                    c
                                                    reception-field )
                                            maximum-field )))
                       (display `(received up to ,j bytes))(newline)
                       (receive j) )
                     (begin (DM-close-ports c s cs)
                            (= i j) ) ) ) ) ) ) )
   ---


" *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***
                      All tcp.tst tests successfully run!
 *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** *** ***"
   ---

;;; end of tcp.tst
