/* $Id: dmact.h,v 1.9 1998/08/23 08:54:18 queinnec Exp $ 
 * ///////////////////////////////////////////////////////////////////////
 *                    //          //
 *                   // DMeroon  //
 *                  //          //
 * A continuation-based causal distributed class-based object system.
 * Christian.Queinnec@polytechnique.fr
 * ///////////////////////////////////////////////////////////////////////
 */

#ifndef DM_ACT_H
#define DM_ACT_H

extern DM_UrlState*
DM_interpret_url_script (DM_Context  *context,
                         DM_UrlState *state,
                         void        *output_port );

#define DM_GenerateUrlActionStructWithName(name, _0, _1) \
struct DM_UrlAction_for_##name { \
  DM_code behavior; \
  DM_Object *internal; \
  DM_nat1 name_length; \
  DM_char1 name[_0]; \
 DM_RealignToMostStringent( \
  DM_nat1 argument_length; \
  DM_reference argument[_1]; \
 ); \
}

#define DM_GenerateUrlActionStructWithNameWithoutArgument(name, _0) \
struct DM_UrlAction_for_##name { \
  DM_code behavior; \
  DM_Object *internal; \
  DM_nat1 name_length; \
  DM_char1 name[_0]; \
 DM_RealignToMostStringent( \
  DM_nat1 argument_length; \
  /* No DM_reference argument[0]; */ \
 ); \
}

#define DM_DefineUrlAction0(string, name) \
typedef \
  DM_GenerateUrlActionStructWithNameWithoutArgument(name, sizeof(string)) \
        DM_UrlAction_for_##name; \
DM_DefineWrappedType(DM_UrlAction_for_##name); \
static DM_UrlAction_for_##name##_wrapped DM_##name##_UrlAction_object = { \
  DM_SupportPrefixInitialization(DM_UrlAction_for_##name##_wrapped, \
                                 DM_##name##_UrlAction_object) \
  DM_ReferenceToClass(UrlAction), \
  DM_ProxyInitialization(), \
  { { { \
    DM_CodeOf(DM_##name##_command), \
    DM_NULL, \
    sizeof(string), \
    string, \
    { { \
      0, \
    } } \
  } } } \
}

#define DM_DefineUrlAction1(string, name, class0) \
typedef DM_GenerateUrlActionStructWithName(name, sizeof(string), 1) \
        DM_UrlAction_for_##name; \
DM_DefineWrappedType(DM_UrlAction_for_##name); \
static DM_UrlAction_for_##name##_wrapped DM_##name##_UrlAction_object = { \
  DM_SupportPrefixInitialization(DM_UrlAction_for_##name##_wrapped, \
                                 DM_##name##_UrlAction_object) \
  DM_ReferenceToClass(UrlAction), \
  DM_ProxyInitialization(), \
  { { { \
    DM_CodeOf(DM_##name##_command), \
    DM_NULL, \
    sizeof(string), \
    string, \
    { { \
      1, \
      { \
        DM_ReferenceToClass(class0), \
    } } } \
  } } } \
}

#define DM_DefineUrlAction2(string, name, class0, class1) \
typedef DM_GenerateUrlActionStructWithName(name, sizeof(string), 2) \
        DM_UrlAction_for_##name; \
DM_DefineWrappedType(DM_UrlAction_for_##name); \
static DM_UrlAction_for_##name##_wrapped DM_##name##_UrlAction_object = { \
  DM_SupportPrefixInitialization(DM_UrlAction_for_##name##_wrapped, \
                                 DM_##name##_UrlAction_object) \
  DM_ReferenceToClass(UrlAction), \
  DM_ProxyInitialization(), \
  { { { \
    DM_CodeOf(DM_##name##_command), \
    DM_NULL, \
    sizeof(string), \
    string, \
    { { \
      2, \
      { \
        DM_ReferenceToClass(class0), \
        DM_ReferenceToClass(class1), \
    } } } \
  } } } \
}

#define DM_DefineUrlAction3(string, name, class0, class1, class2) \
typedef DM_GenerateUrlActionStructWithName(name, sizeof(string), 3) \
        DM_UrlAction_for_##name; \
DM_DefineWrappedType(DM_UrlAction_for_##name); \
static DM_UrlAction_for_##name##_wrapped DM_##name##_UrlAction_object = { \
  DM_SupportPrefixInitialization(DM_UrlAction_for_##name##_wrapped, \
                                 DM_##name##_UrlAction_object) \
  DM_ReferenceToClass(UrlAction), \
  DM_ProxyInitialization(), \
  { { { \
    DM_CodeOf(DM_##name##_command), \
    DM_NULL, \
    sizeof(string), \
    string, \
    { { \
      3, \
      { \
        DM_ReferenceToClass(class0), \
        DM_ReferenceToClass(class1), \
        DM_ReferenceToClass(class2), \
    } } } \
  } } } \
}

#define DM_DefineUrlAction4(string, name, class0, class1, class2, class3) \
typedef DM_GenerateUrlActionStructWithName(name, sizeof(string), 4) \
        DM_UrlAction_for_##name; \
DM_DefineWrappedType(DM_UrlAction_for_##name); \
static DM_UrlAction_for_##name##_wrapped DM_##name##_UrlAction_object = { \
  DM_SupportPrefixInitialization(DM_UrlAction_for_##name##_wrapped, \
                                 DM_##name##_UrlAction_object) \
  DM_ReferenceToClass(UrlAction), \
  DM_ProxyInitialization(), \
  { { { \
    DM_CodeOf(DM_##name##_command), \
    DM_NULL, \
    sizeof(string), \
    string, \
    { {  \
      4, \
      { \
        DM_ReferenceToClass(class0), \
        DM_ReferenceToClass(class1), \
        DM_ReferenceToClass(class2), \
        DM_ReferenceToClass(class3), \
    } } } \
  } } } \
}

#define DM_DefineUrlAction8(string, name, class0, class1, class2, class3, class4, class5, class6, class7) \
typedef DM_GenerateUrlActionStructWithName(name, sizeof(string), 8) \
        DM_UrlAction_for_##name; \
DM_DefineWrappedType(DM_UrlAction_for_##name); \
static DM_UrlAction_for_##name##_wrapped DM_##name##_UrlAction_object = { \
  DM_SupportPrefixInitialization(DM_UrlAction_for_##name##_wrapped, \
                                 DM_##name##_UrlAction_object) \
  DM_ReferenceToClass(UrlAction), \
  DM_ProxyInitialization(), \
  { { { \
    DM_CodeOf(DM_##name##_command), \
    DM_NULL, \
    sizeof(string), \
    string, \
    { {  \
      8, \
      { \
        DM_ReferenceToClass(class0), \
        DM_ReferenceToClass(class1), \
        DM_ReferenceToClass(class2), \
        DM_ReferenceToClass(class3), \
        DM_ReferenceToClass(class4), \
        DM_ReferenceToClass(class5), \
        DM_ReferenceToClass(class6), \
        DM_ReferenceToClass(class7), \
    } } } \
  } } } \
}

#define DM_DeclareActionBehavior(name, value) \
  DM_UrlState* (*name)(DM_Context*, DM_UrlAction*, DM_UrlState*, void*, ...) = \
   (DM_UrlState* (*)(DM_Context*, DM_UrlAction*, DM_UrlState*, void*, ...))(value)

#define DM_ReferenceToAction(name) \
  ((DM_UrlAction*)DM_ReferenceTo(DM_##name##_UrlAction))

/* This macro is used to register commands within the standard
 * predefined environment. */

#define DM_RegisterUrlAction(context, name) \
  (DM_register_action(context, DM_ReferenceToAction(name)))

extern void
DM_register_action (DM_Context   *context,
                    DM_UrlAction *action );

extern void
DM_handle_script_evaluation_request (DM_Context                  *context,
                                     DM_UrlStateMigrationRequest *request );
extern void
DM_handle_script_evaluation_answer (DM_Context                 *context,
                                    DM_UrlStateMigrationAnswer *answer );

extern void
DM_act_initialize (DM_Context *context);

#endif /* DM_ACT_H */

/* end of dmact.h */
