/* $Id: dmcache.h,v 1.4 1998/04/03 20:52:34 queinnec Exp $
 * ///////////////////////////////////////////////////////////////////////
 *                    //          //
 *                   // DMeroon  //
 *                  //          //
 * A continuation-based causal distributed class-based object system.
 * Christian.Queinnec@polytechnique.fr
 * ///////////////////////////////////////////////////////////////////////
 */

extern DM_nat3
DM_push_object_in_bounded_stack (DM_Context       *context,
                                 DM_Object        *o,
                                 DM_BoundedStack* *location );

extern DM_Object*
DM_pop_from_bounded_stack (DM_Context      *context,
                           DM_BoundedStack *cache );

extern DM_Object*
DM_top_of_bounded_stack (DM_Context      *context,
                         DM_BoundedStack *stack );

extern void
DM_adjust_stack (DM_Context      *context,
                 DM_BoundedStack *cache,
                 DM_nat3         height );

extern void
DM_swap_top_of_bounded_stack (DM_Context      *context,
                              DM_BoundedStack *cache );

extern void 
DM_dup_top_of_bounded_stack (DM_Context       *context,
                             DM_BoundedStack* *cache );

extern void
DM_reset_stack (DM_Context      *context,
                DM_BoundedStack *cache);

extern void
DM_reset_cache (DM_Context       *context,
                DM_MutableVector *cache );

extern DM_Object*
DM_extract_from_cache (DM_Context       *context,
                       DM_MutableVector *cache,
                       DM_nat3          index );

extern DM_nat3
DM_is_in_cache (DM_Context       *context,
                DM_Object        *o, 
                DM_MutableVector *cache );

extern DM_nat3
DM_is_in_stack (DM_Context      *context,
                DM_Object       *o, 
                DM_BoundedStack *stack );

extern void DM_cache_initialize (DM_Context *context);

/* end of dmcache.h */
