/* $Id: dmdbg.h,v 1.14 1997/08/15 19:29:25 queinnec Exp $ 
 * ///////////////////////////////////////////////////////////////////////
 *                    //          //
 *                   // DMeroon  //
 *                  //          //
 * A continuation-based causal distributed class-based object system.
 * Christian.Queinnec@polytechnique.fr
 * ///////////////////////////////////////////////////////////////////////
 */

#ifndef DM_DEBUG_H
#define DM_DEBUG_H

/* DOCUMENTATION dmdbg.h
 * These are the exportations of dmdbg.c that contains a lot of useful
 * functions for DMeroon debug. Most of them are only defined if compiled
 * with DM_DEBUG on.
 */

extern FILE* DM_debug_stream;

#if defined(DM_DEBUG)

extern void
DM_print_memory_slice (DM_Context *context,
                       void    *q, 
                       DM_nat3 length, 
                       char *ascii_prefix, 
                       char *ascii_postfix,
                       void    *output_port );

extern void
DM_print_types (DM_Context *context,
                void *output_port);

extern void
DM_print_object (DM_Context *context,
                 DM_Object *o,
                 void      *output_port);

extern void
DM_print_bytes (DM_Context *context,
                DM_Object *o, 
                DM_nat3   length,
                void      *output_port );

extern void
DM_print_ports (DM_Context *context,
                DM_nat3 n,
                void    *output_port);

extern DM_c_boolean
DM_handle_debug_request (DM_Context *context,
                         char       *request,
                         void       *output_port);

extern void
DM_debug_monitor (DM_Context *context,
                  DM_nat1 in);

/* RESOURCE DM_EXTERNAL_INSPECTOR_TIMEOUT
 * This macro defines (in seconds) the time during which DMeroon waits
 * for the first command of an external inspector to come. After that time
 * DMeroon will ignore it. It is used by DM_fork_inspector.
 */

#define DM_EXTERNAL_INSPECTOR_TIMEOUT 10

extern void
DM_fork_inspector (DM_Context *context,
                   char *command);

#endif /* defined(DM_DEBUG) */

extern void DM_debug_initialize (DM_Context *context);

#endif /* DM_DEBUG_H */

/* end of dmdbg.h */
