/* $Id: dmhtml.h,v 1.13 1998/05/06 20:03:13 queinnec Exp $  
 * ///////////////////////////////////////////////////////////////////////
 *                    //          //
 *                   // DMeroon  //
 *                  //          //
 * A continuation-based causal distributed class-based object system.
 * Christian.Queinnec@polytechnique.fr
 * ///////////////////////////////////////////////////////////////////////
 */

#ifndef DM_HTML_H
#define DM_HTML_H

/* Adapt these URL to the machines on which I develop DMeroon. */

#if defined(SITE_is_jblaye) || defined(SITE_is_lispou) \
   || defined(SITE_is_merou)

#define DMEROON_URL \
  "http://localhost/html/WWW/DMeroon.html"
#define DMEROON_QUEINNEC_URL \
  "http://localhost/html/WWW/Queinnec.html"

#else

#define DMEROON_URL \
  "http://www-spi.lip6.fr/~queinnec/WWW/DMeroon.html"
#define DMEROON_QUEINNEC_URL \
  "http://www-spi.lip6.fr/~queinnec/WWW/Queinnec.html"

#endif

/* RESOURCE DM_MAX_CHARS_FOR_IMMEDIATE_DISPLAY
 * This constant defines the maximal number of characters an instance of
 * String may contain to be immediately displayed when referenced.
 */

#define DM_MAX_CHARS_FOR_IMMEDIATE_DISPLAY 15

/* 
 * Exportations.
 */

extern void
DM_html_fancy_print (DM_Context *context,
                     DM_Object *o,
                     void      *output_port );

extern void
DM_html_print_object (DM_Context *context,
                      DM_Object  *o,
                      void       *output_port);

extern void
DM_html_byte_print (DM_Context *context,
                    DM_Object *o,
                    void      *output_port );

extern void
DM_answer_html_request (DM_Context *context,
                        char       *request,
                        DM_Object  *argument,
                        void       *output_port );

extern void
DM_dump_urlscript_stack (DM_Context  *context,
                         DM_UrlState *state,
                         void        *output_port );

extern void DM_html_initialize (DM_Context *context);

#endif /* DM_HTML_H */

/* end of dmhtml.h */
