/* $Id: dmprtcl.h,v 1.7 1997/10/19 20:33:56 queinnec Exp $ 
 * ///////////////////////////////////////////////////////////////////////
 *                    //          //
 *                   // DMeroon  //
 *                  //          //
 * A continuation-based causal distributed class-based object system.
 * Christian.Queinnec@polytechnique.fr
 * ///////////////////////////////////////////////////////////////////////
 */

extern DM_c_boolean
DM_handle_protocol (DM_Context  *context,
                    DM_InBuffer *inbuffer,
                    DM_Protocol *protocol);

extern DM_c_boolean
DM_handle_readable_connection (DM_Context    *context,
                               DM_Connection *connection);

extern DM_Protocol*
DM_add_protocol (DM_Context *context,
                 char       *string,
                 DM_c_boolean (*handler)(DM_Context*, DM_InBuffer*) );

extern DM_Protocol*
DM_add_restricted_protocol (DM_Context   *context,
                            char         *string,
                            DM_c_boolean (*handler)(DM_Context*, 
                                                    DM_InBuffer* ) );

extern void
DM_decode_percent (DM_Context  *context,
                   char        *start,
                   char        *end );

extern void
DM_prtcl_initialize (DM_Context *context);

/* RESSOURCE DM_password
 * This global variable holds the current password to use.
 * This password is computed after DMEROON_ADDITIONAL_PASSWORD and
 * DMEROON_PASSWORD. It is also used in dmreqst.c and dmreq.c files.
 * It is initialized in the DM_prtcl_initialize procedure.
 */

extern char DM_password[];

/* RESOURCE DMEROON_ADDITIONAL_PASSWORD 
 * defines the passwd (a cookie) that must be given after the mention
 * of the protocol. This is a simple method to run one's own DMeroon
 * servers. If you plan to also restrict the use of http, then the
 * passwd should probably begin with a / to be compatible with http
 * clients. For example, you may define it as:
 *
 * #define DMEROON_ADDITIONAL_PASSWORD /$USER/$$
 * 
 * The maximal length of the additional password is by default defined
 * to be 64.
 */

#ifndef DMEROON_ADDITIONAL_PASSWORD 
#define DMEROON_ADDITIONAL_PASSWORD ""
#endif

#ifndef DMEROON_PASSWORD_LENGTH
#define DMEROON_PASSWORD_LENGTH     64
#endif

/* end of dmprtcl.h */
