/* $Id: dmreqst.h,v 1.35 1997/08/21 16:14:22 queinnec Exp $ 
 * ///////////////////////////////////////////////////////////////////////
 *                    //          //
 *                   // DMeroon  //
 *                  //          //
 * A continuation-based causal distributed class-based object system.
 * Christian.Queinnec@polytechnique.fr
 * ///////////////////////////////////////////////////////////////////////

 * These are the exportations from the DMeroon API.
 
 * {{{ Function exportations
 */

#define DM_ShortCutReference(context,location) \
  (DM_shortcut_reference(context, (DM_reference*)location))

extern void
DM_shortcut_reference (DM_Context *context,
                       DM_reference *location);

#define DM_LongCutReference(context,location) \
  (DM_longcut_reference(context, (DM_reference*)location)) 

extern void
DM_longcut_reference (DM_Context   *context,
                      DM_reference *location);

#define DM_EnsurePresent(context,address) \
   (DM_ensure_present(context, (DM_Object**)(address) ))

extern void
DM_ensure_class_usable (DM_Context *context,
                        DM_Class *class);

extern void
DM_ensure_present (DM_Context *context,
                   DM_Object* *location);

extern DM_Connection*
DM_reconnect (DM_Context* context,
              DM_Site*    site );

extern void
DM_disconnect (DM_Context* context,
               DM_Site*    site );

extern void
DM_ensure_site_usable (DM_Context *context,
                       DM_Site    *site);

extern void
DM_ensure_up_to_date (DM_Context *context,
                      DM_Object *o);

extern DM_c_boolean
DM_is_class_usable (DM_Context *context,
                    DM_Class *class);

extern DM_ErrorCode
DM_site_handshake (DM_Context *context,
                   DM_Connection *connection);

extern DM_Connection* 			/* May return NULL */
DM_which_connection (DM_Context *context,
                     DM_Site *site);

extern void
DM_send_object_fetch_request (DM_Context *context,
                              DM_Object* *location,
                              DM_Exit    *exit );

extern void
DM_try_prefetch_exit (DM_Context *context,
                      DM_Exit    *exit );

extern void
DM_try_prefetch_address (DM_Context *context,
                         DM_Object* *address );

#define DM_TryPrefetchAddress(context, address) \
  DM_try_prefetch_address(context, (DM_Object**)(address))

extern void
DM_send_object_send_request (DM_Context *context, 
                             DM_Object  *o, 
                             DM_Site    *site);

extern DM_ErrorCode
DM_send_request (DM_Context *context,
                 DM_Object *o,
                 DM_Site   *site );

extern DM_ErrorCode
DM_send_answer (DM_Context *context,
                DM_Object *o,
                DM_Site   *site );

extern void DM_reqst_initialize (DM_Context *context);

/* }}}
 * {{{ Macros

 * NOTE: Although the target site appears in request->requested, a
 * site appears in these macros since it may be a relay towards the
 * finally targetted site.
 */

#define DM_SendRequest(context,request,site) \
  DM_send_request(context, \
                  (DM_Object*)(request), \
                  (site) )

#define DM_SendAnswer(context,answer,site) \
  DM_send_answer(context, \
                 (DM_Object*)(answer), \
                 (site) )

/* }}}
 * end of dmapi.h */
