/* $Id: dmsched.h,v 1.17 1998/04/14 20:05:58 queinnec Exp $ 
 * ///////////////////////////////////////////////////////////////////////
 *                    //          //
 *                   // DMeroon  //
 *                  //          //
 * A continuation-based causal distributed class-based object system.
 * Christian.Queinnec@polytechnique.fr
 * ///////////////////////////////////////////////////////////////////////
 */

#ifdef DM_MONOTHREAD_CONTEXT

extern DM_ErrorCode
DM_monothread_loop (DM_Context *context);

#endif /* !defined(DM_MONOTHREAD_CONTEXT) */

#ifdef DM_COROUTINE_CONTEXT

extern DM_ErrorCode
DM_basic_server_loop (DM_Context *context);

#ifdef DM_SCHEME_IS_BIGLOO

/* These are names of functions or variables exported from the dm.bgl
 * file which is written in Scheme. Since I did not succeed in Bigloo
 * 1.8 to export the DM-handle-object mutable variable with a given C
 * name, I copy its name here. To find it again, just run:
 *      nm Bigloo/?*.o | grep -i handle_object
 *                                 FUTURE: should be automatic    FUTURE
 */

#if DM_BIGLOO_RELEASE==193           /* Bigloo 1.9c */
#define DM_HANDLE_OBJECT_IN_BIGLOO dm_handle_object_192_dm
#endif

#if DM_BIGLOO_RELEASE==182           /* Bigloo 1.8b */
#define DM_HANDLE_OBJECT_IN_BIGLOO dm_handle_object_dm_31
#endif

extern obj_t DM_HANDLE_OBJECT_IN_BIGLOO;

extern DM_SupportPointer
DMbgl_escape_to_server (DM_SupportPointer wrapped_continuation);

extern void
DMbgl_register_return_to_server (obj_t proc);

extern DM_SupportPointer
DMbgl_handle_object (DM_SupportPointer context, DM_SupportPointer object);

extern DM_SupportPointer
DM_apply_continuation (DM_Context *context, void* k, void* value);

extern obj_t
DM_escape_to_server (DM_SupportPointer wrapped_continuation);

#endif /* DM_SCHEME_IS_BIGLOO */

#endif /* DM_COROUTINE_CONTEXT */

extern DM_ErrorCode
DM_wait_until_answer (DM_Context *context,
                      DM_nat3    duration,
                      DM_Answer* *answer,
                      DM_Request *request );

extern void
DM_signal_answer (DM_Context *context,
                  DM_Answer  *answer);

extern DM_ErrorCode
DM_wait_until_object_reception (DM_Context* context,
                                DM_nat3     duration,
                                DM_Object*  *location );

extern void
DM_signal_object_reception (DM_Context *context);

extern void
DM_accumulate_object (DM_Context *context,
                      DM_Object  *object );

extern DM_ErrorCode
DM_wait_until_duration (DM_Context *context,
                        DM_nat3    duration );

extern void
DM_signal_end_of_duration (DM_Context *context,
                           DM_Waiter  *waiter );

extern DM_ErrorCode
DM_wait_until_fd_ready (DM_Context *context,
                        DM_nat3    duration,
                        DM_nat3    fd );

extern void
DM_signal_fd_ready (DM_Context *context,
                    DM_nat3    fd );

extern void 
DM_sched_initialize (DM_Context *context);

/* end of dmsched.h */
