/* $Id: dmzlib.h,v 1.1 1998/05/06 20:03:17 queinnec Exp $ 
 * ///////////////////////////////////////////////////////////////////////
 *                    //          //
 *                   // DMeroon  //
 *                  //          //
 * A continuation-based causal distributed class-based object system.
 * Christian.Queinnec@polytechnique.fr
 * ///////////////////////////////////////////////////////////////////////
 */
#ifdef DM_USE_ZLIB

#ifndef DM_ZLIB_H
#define DM_ZLIB_H

#include "zlib.h"
#include "zconf.h"

/* Size above which messages are to be compressed */
/* Should make it a site variable */
#define DM_ZLIB_COMPRESS_ABOVE 10

/*/////////////////////////////////////////////////////////////////
 *             Additional externalizations
 */

DM_nat3
DM_compress_message(DM_Context   *context,
		    DM_OutBuffer *compressed_buffer,
		    DM_Marker    *marker);


DM_nat3
DM_uncompress_message(DM_Context  *context,
		      DM_InBuffer *inbuffer,
		      DM_InBuffer *uncompressed_buffer,
		      DM_nat3     lf_index);
DM_nat3
DM_zdebug_translate(DM_nat3 error_code);

DM_String * 
DM_zalloc(DM_Context *context,
	  DM_nat3 p1,
	  DM_nat3 p2);
    
void
DM_zfree(DM_Context *context,
	 DM_Object o);

extern void 
DM_zlib_initialize (DM_Context *context);

#endif /* DM_ZLIB_H */
#endif /* DM_USE_ZLIB */

/* end of dmzlib.h */
