#! /bin/sh
# $Id: demo1.sh,v 1.7 1996/07/18 13:56:09 queinnec Exp $
# This is the first DMeroon demo with a unique server.
# This script must be run from the TARGET/DMeroon/demos directory.

# Load configuration parameters.
# The first script sets up the main parameters describing how DMeroon was
# regenerated, the second one sets up the parameters of the demos.

if [ -f ../../config.sh ]
then . ../../config.sh
else 
        echo "You are probably not in the TARGET/DMeroon/demos directory."
        exit 1
fi

. paths.sh

next=1

# Prepare screen for text

clear

cat <<EOF
                        Welcome to DMeroon

This demo will start a single DMeroon server and an HTTP client to
inspect the objects exported by this sole DMeroon server. The exact
executables that are used for that demo are defined in the
TARGET/demos/paths.sh file.

EOF

# Start 1 DMeroon server and 1 HTTP client.

LAUNCH_ARGS=1
. launch.sh

cat <<EOF
Wait a little for these two windows to come up...
Type <return> when they are both present.
EOF

eval ${CONTINUE}

cat <<EOF 
The first (xterm) shows a trace of the activity of the DMeroon server,
the HTTP client (netscape, xmosaic ...) allows you to inspect the
DMeroon server.

If the HTTP client is not already displaying the content of the
following URL (a page saying that DMeroon@${DMEROON_HOST1}:${DMEROON_PORT1} 
is in touch) then ask for it.

        $url1

You may also resize these windows if you care. Type <return> to continue.
EOF

eval ${CONTINUE}

cat <<EOF
A DMeroon server is reified into a DMeroon object (instance of the
Site class).  This object allows you to reach all the objects exported
by this Site as well as all the characteristics of this Site. A
DMeroon server allows you to inspect its site and all reachable
objects.

The page you see is the Help page displayed by a DMeroon server when
nothing else was requested.  If you now click on the <<site>> link
then you will see the content of the site object that represents
DMeroon@${DMEROON_HOST1}:${DMEROON_PORT1}.  You may play a little with
the HTTP client, follow the links and discover many other values and
objects. Of particular interest are the various types of data that
DMeroon supports (nat1, netnat2, int3, reference, date, char1
...). You may seen a lot of them within the site instance.  There are
also a number of predefined classes such as Hashtable, ImmutablePair,
String ...

Additional documentation on this browsing tool may be found within the
first (help) html page displayed by DMeroon under name <<DMeroon>>.
We urge you to consider it a while for some explanations.

Want to proceed? Type <return> to continue (or quit).
EOF

eval ${CONTINUE}

cat <<EOF

If you browse sufficiently, you may notice some regularity in the used
URLs. In fact, there exists a little stack-based language for
them. Multi-lines programs may even be written and sent to the DMeroon
server for execution (with the Perl urlscript command).  For instance,
you may use the next command:

      urlscript ${DMEROON_HOST1}:${DMEROON_PORT1} ${TOP}/DMeroon/urls/demo1.dms

to send the following URLscript program:

`cat ${TOP}/DMeroon/urls/demo1.dms`

Type <return> to let me send for you this URLscript program. You may
observe the server while receiving this request and processing it. The
name of the language bound to DMeroon server will be printed below (as
asked by the program), the end of the URLscript is notified by the
DMeroon server.  
EOF

eval ${CONTINUE}

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST1}:${DMEROON_PORT1} \
                ${TOP}/DMeroon/urls/demo1.dms

cat <<EOF

The previous URLscript program incremented the general clock of the site.
You may check it with your HTTP client. The general clock of the site is 
held in the 'clock' field. You may use the following direct URL to tick
this clock again and see its resulting content:

   http://${DMEROON_HOST1}:${DMEROON_PORT1}/thesite.clock/dup/tick/fancyprint

Impressed! Type <return> to continue.
EOF

eval ${CONTINUE}

cat  <<EOF
This is the end of the first demonstration!
EOF

eval ${NEXT_DEMO}

# end of demo1.sh
