#! /bin/sh
# $Id: demo4.sh,v 1.4 1996/07/18 13:56:13 queinnec Exp $
# This is the fourth DMeroon demo with three interacting servers.
# This script must be run from the TARGET/DMeroon/demos directory.

# Load configuration parameters if not yet done (in demo3.sh).
# The first script sets up the main parameters describing how DMeroon was
# regenerated, the second one sets up the parameters of the demos.

if [ -z "${DMEROON_SERVER1}" ]
then
     if [ -f ../../config.sh ]
     then . ../../config.sh
     else 
           echo "You are probably not in the TARGET/DMeroon/demos directory."
           exit 1
     fi
     . paths.sh
fi

next=4

# Prepare screen for text

clear

cat <<EOF
                        Welcome to DMeroon

This demo will start three DMeroon servers. The exact executables that
are used for that demo are defined in the TARGET/demos/paths.sh file.

EOF

# Start three DMeroon servers.

LAUNCH_ARGS=3
.  launch.sh

cat <<EOF
Let's try now to dynamically create a "Point2d" Class. The basic API function
to create classes can only subclass a given class with *one* additional field.
So to create a "Point2D", we first add the "x" field to the Object class
then the "y" field to the resulting class.

Type <return> to define that class.
EOF

eval ${CONTINUE}

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST1}:${DMEROON_PORT1} <<EOF
        "Object" Class "Point1D" "x" 
        "nought" Type "int3" Type create_subclass "Point1D" define
        Point1D "PseudoPoint2D" "y"
        "nought" Type "int3" Type create_subclass "PseudoPoint2D" define
        thesite .information .rest "userdict" define
        "MutableVector" Class 5 allocate "mv" define
        mv setsharable
        userdict dup "value" Field mv set
        mv dup "item" Field 0 PseudoPoint2D xset
EOF

cat <<EOF
The resulting class is named "PseudoPoint2D" and stored at the following
URL:

http://${DMEROON_HOST1}:${DMEROON_PORT1}/thesite.information.rest.value.item[0]/print

To have a real "Point2D" class, we now ask the API to smash its two last
superclasses into a single class. That is, we create an equivalent class
containing the same fields but whose superclass is Object and not Point1D
as you may have seen with your browser. 

Type <return> to create "Point2D".
EOF

eval ${CONTINUE}

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST1}:${DMEROON_PORT1} <<EOF
        thesite .information .rest .value "mv" define
        mv .item[0] "PseudoPoint2D" define
        PseudoPoint2D "Point2D" 2 smash_class "Point2D" define
        mv dup "item" Field 1 Point2D xset
EOF

cat <<EOF
You may then inspect this new "Point2D" class with the following URL:

http://${DMEROON_HOST1}:${DMEROON_PORT1}/thesite.information.rest.value.item[1]/print

Wanna dynamically instantiate this new class, then type <return>.
EOF

eval ${CONTINUE}

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST1}:${DMEROON_PORT1} <<EOF
        thesite .information .rest .value "mv" define
        mv.item[1] allocate "apoint" define
        apoint setsharable
        mv dup "item" Field 2 apoint xset
EOF

cat <<EOF
The result of the instantiation is at URL (the content of fields "x" and "y" 
is unspecified).

http://${DMEROON_HOST1}:${DMEROON_PORT1}/thesite.information.rest.value.item[2]/print

Want to see something more difficult? Type <return> to proceed.
EOF

eval ${CONTINUE}

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST1}:${DMEROON_PORT1} <<EOF
        thesite .information .rest .value "mv" define
        "String" Class "ColoredString" "color"
        "nought" Type "reference" Type create_subclass "ColoredString" define
        #mv dup "item" Field 3 ColoredString xset
        ColoredString 3 allocate "a_cs" define
        "pink" String "pink_color" define
        pink_color setsharable 
        a_cs dup "color" Field pink_color set
        a_cs setsharable
        mv dup "item" Field 4 a_cs xset
EOF

cat <<EOF
Here, I created a ColoredString, a subclass of the predefined String
class, with an additional field holding a color (Yes the 'color' field is
after the repetition of characters!). I also took the liberty to 
instantiate such a pink ColoredString, contemplate it at URL:

http://${DMEROON_HOST1}:${DMEROON_PORT1}/thesite.information.rest.value.item[4]/print

More thrilling issue after typing <return>...
EOF

eval ${CONTINUE}

cat <<EOF 
We now ask a second site to locally cache this ColoredString instance. This is 
more challenging since its class is not known from the requesting site. 

Type <return> to ask for it...
EOF

eval ${CONTINUE}

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST1}:${DMEROON_PORT1} <<EOF
        # Replace the MutableVector with another one with just the
        # ColoredString instance in it.
        thesite .information .rest "userdict" define
        userdict .value .item[4] "cs" define
        "MutableVector" Class 5 allocate "mv" define
        mv setsharable
        userdict dup "value" Field mv set
        mv dup "item" Field 4 cs xset
EOF

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST2}:${DMEROON_PORT2} <<EOF
        thesite .information .rest "userdict" define
        "MutableVector" Class 3 allocate "mv" define
        mv setsharable
        userdict dup "value" Field mv set
        "${DMEROON_HOST1}" ${DMEROON_PORT1} connect "A_site" define
        A_site .information .rest .value 
EOF

echo DEBUG ; eval ${CONTINUE} # DEBUG

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST2}:${DMEROON_PORT2} <<EOF
        "${DMEROON_HOST1}" ${DMEROON_PORT1} site "A_site" define
        A_site .information .rest .value .item[4] "cs" define
        thesite .information .rest .value "B_mv" define
        B_mv dup "item" Field 1 cs xset
EOF

cat <<EOF
Use now your browser to inspect this instance at URL:

http://${DMEROON_HOST2}:${DMEROON_PORT2}/thesite.information.rest.value.item[1]/print

Type <return> if convinced.
EOF

eval ${CONTINUE}

cat <<EOF
This is the end of the fourth demonstration!
EOF

eval ${NEXT_DEMO}

# end of demo4.sh
