#! /bin/sh
# Start some DMeroon servers or HTTP clients (if not yet done).
# This script starts as many servers and clients as given in LAUNCH_ARGS.

if [ -z "$LAUNCH_ARGS" ]
then
        echo LAUNCH_ARGS variable unset
        exit 1
fi

# The command run after every DMeroon server.

TIMEOUT=30
POST="sleep ${TIMEOUT}" 

if [ "$LAUNCH_ARGS" -ge 1 ]
then 

# Start a DMeroon server. 

command1="DMEROON_SERVING_PORT=${DMEROON_PORT1}; export DMEROON_SERVING_PORT; ${DMEROON_SERVER1} -linger ${LINGERTIME}"

if [ -z "$xtermpid1" ]
then 
     xterm -display ${DISPLAY} \
        -title "DMeroon@${DMEROON_HOST1}:${DMEROON_PORT1}" ${XTERM_FLAGS1} \
        -e rsh ${DMEROON_HOST1} "exec /bin/sh -c '${command1}; ${POST}' " &
    xtermpid1=$!
    sleep 5
fi

# Start an HTTP client. Wait a little for the DMeroon server to be
# operational so it can serve the following url.

if [ -z "$httpclientpid" ]
then 
        sleep 2
        ${HTTP_CLIENT} ${HTTP_FLAGS} 2>/dev/null 1</dev/null &
        httpclientpid=$!
fi

trap "kill -9 $$ ${xtermpid1} ${httpclientpid} ; exit 0" ${TRAP_NUMBERS}

fi


if [ "$LAUNCH_ARGS" -ge 2 ]
then

command2="DMEROON_SERVING_PORT=${DMEROON_PORT2}; export DMEROON_SERVING_PORT; ${DMEROON_SERVER2} -linger ${LINGERTIME}"

if [ -z "$xtermpid2" ]
then 
     xterm -display ${DISPLAY} \
        -title "DMeroon@${DMEROON_HOST2}:${DMEROON_PORT2}" \
        ${XTERM_FLAGS2} \
        -e rsh ${DMEROON_HOST2} "exec /bin/sh -c '${command2}; ${POST}' " &
        xtermpid2=$!
        sleep 5
fi

trap "kill -9 $$ ${xtermpid1} ${httpclientpid} ${xtermpid2} ; exit 0" ${TRAP_NUMBERS}

fi


if [ "$LAUNCH_ARGS" -ge 3 ]
then

command3="DMEROON_SERVING_PORT=${DMEROON_PORT3}; export DMEROON_SERVING_PORT; ${DMEROON_SERVER3} -linger ${LINGERTIME}"

if [ -z "$xtermpid3" ]
then
     xterm -display ${DISPLAY} \
        -title "DMeroon@${DMEROON_HOST3}:${DMEROON_PORT3}" \
        ${XTERM_FLAGS3} \
        -e rsh ${DMEROON_HOST3} "exec /bin/sh -c '${command3}; ${POST}' " &
     xtermpid3=$!
     sleep 5
fi

trap "kill -9 ${xtermpid1} ${httpclientpid} ${xtermpid2} ${xtermpid3} ; exit 0" ${TRAP_NUMBERS}

fi 

# Reexport all these variables.

eval ${EXPORTS}

# end of launch.sh
