;;; $Id: dmtstlib.scm,v 1.5 1998/04/29 09:20:26 queinnec Exp $
;;; Library of functions for test.
;;; This file requires the dmlib.scm file.

;;; Wait for a site to connect itself. Exits after period seconds without 
;;; activity. Shows received objects that are not instances of Site.

(define (wait-for-site period)
  (let ((o (DM-receive period)))
    (if o 
        (if (DM-is-a? o DM-Fact-class)
            (let ((site (DM-indexed-field-value 
                         o DM-Fact-item-field 0 )))
              (display "*** Got a Fact")(newline)
              (flush-output-port (current-output-port))
              ;; should verify that errcode is DME_GOT_SITE.
              (if (DM-is-a? site DM-Site-class)
                  site
                  (wait-for-site period) ) )
            (begin (display "*** Got an Object: ignored!")(newline)
                   (flush-output-port (current-output-port))
                   (wait-for-site period) ) )
        #f ) ) )

;;; Wait for sites to connect and publish these sites.

(define (serve-and-publish-sites duration)
  (let wait ()
    (let ((site (wait-for-site duration)))
      (if site
          (let* ((site-name (DM->string site DM-Site-name-field))
                 (port (DM-field-value site DM-Site-port-field))
                 (key-name (string-append site-name 
                                          ":" 
                                          (number->string port) )) )
            (display `(,key-name is connected))(newline)
            (flush-output-port (current-output-port))
            (DM-publish! site
                         "user" 
                         "connected" 
                         key-name )
            (wait) )
          #t ) ) ) )

;;; Serve until some calm arrive. Publish as well connecting sites.

(define (serve-until-calm duration)
  (serve-and-publish-sites duration)
  #t )

;;; Receive a real object (not a Fact)

(define (DM-receive-object)
  (let ((o (DM-receive 10)))
    (if o
        (if (DM-is-a? o DM-Fact-class)
            (DM-receive-object)
            o )
        (DM-receive-object) ) ) )

;;; Serve until receiving a given value.

(define (DM-serve-until-receiving value)
  (let ((o (DM-receive-object)))
    (if (and o (eq? o value))
        #t
        (DM-serve-until-receiving value) ) ) )

;;; end of dmtstlib.scm
