#! /bin/sh
# This test combines several URLscripts corresponding to scripts that appear
# in demo2.sh file. This test must be run from TARGET/DMeroon/demos.

# Load configuration parameters if not yet done (in demos/paths.sh).
# The first script sets up the main parameters describing how DMeroon was
# regenerated, the second one sets up the parameters of the demos.

if [ -z "${DMEROON_SERVER1}" ]
then
     if [ -f config.sh ]
     then  . config.sh
     else 
           echo "You are probably not in the TARGET directory."
           exit 1
     fi
     . DMeroon/demos/paths.sh
fi

# Allocate and publish a MutableVector in the first site.

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST1}:${DMEROON_PORT1} <<EOF
        "MutableVector" Class 3 allocate "mv" define
        mv setinitialized
        thesite .information .rest "user-dictionary" define
        user-dictionary dup "value" Field mv set
EOF

# Mutate this MutableVector from the second site.

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST2}:${DMEROON_PORT2} <<EOF
        "${DMEROON_HOST1}" ${DMEROON_PORT1} connect "othersite" define
        othersite .information .rest .value "mv" define
        mv dup "item" Field 0 true xset
        mv print # Should print that mv is obsolete
EOF

# end of test5.sh

