#! /bin/sh
# This test combines several URLscripts corresponding to scripts that appear
# in demo3.sh file. This test must be run from TARGET/DMeroon/demos.

# Load configuration parameters if not yet done (in demo1.sh).
# The first script sets up the main parameters describing how DMeroon was
# regenerated, the second one sets up the parameters of the demos.

if [ -z "${DMEROON_SERVER1}" ]
then
     if [ -f ../../config.sh ]
     then . ../../config.sh
     else 
           echo "You are probably not in the TARGET/DMeroon/demos directory."
           exit 1
     fi
     . paths.sh
fi

# Connect A to B and C (B and C are not connected directly).

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST1}:${DMEROON_PORT1} <<EOF
        "${DMEROON_HOST2}" ${DMEROON_PORT2} connect
        "${DMEROON_HOST3}" ${DMEROON_PORT3} connect
EOF

# Send nil from A to B so that B becomes aware of C. (B then prefetches 
# the clock of C etc.)

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST1}:${DMEROON_PORT1} <<EOF
        nil "${DMEROON_HOST2}" ${DMEROON_PORT2} site send
EOF

# Let B publish a MutableVector 

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST2}:${DMEROON_PORT2} <<EOF
        "MutableVector" Class 3 allocate "mv" define
        mv setinitialized
        thesite .information .rest "user-dictionary" define
        user-dictionary dup "value" Field mv set
EOF

echo -n "continue? " ; read ans

# Ask C to mutate this MutableVector (messages are exchanged via A)

${TOP}/DMeroon/Commands/urlscript ${DMEROON_HOST3}:${DMEROON_PORT3} <<EOF
        "${DMEROON_HOST2}" ${DMEROON_PORT2} site "othersite" define
        othersite .information .rest .value "mv" define
        mv dup "item" Field 0 true xset
        mv print # Should print that mv is obsolete
EOF

# end of test6.sh

