;;; $Id: libscm0.scm,v 1.4 1997/08/17 19:31:00 queinnec Exp $

;;; This is the library of predefined primitives that can be expressed 
;;; with the object system.

(define (boolean? o)
  (or (eq? o #t)
      (eq? o #f) ) )

;(define (cons x y)
;  (make-object <Pair> y x) )

(define (car c)
  (field-value c <Pair.head>) )

(define (cdr c)
  (field-value c <Pair.tail>) )

(define (pair? c)
  (is-a? c <Pair>) )

(define (set-car! c x)
  (set-field-value! c x <Pair.head>) )

(define (set-cdr! c x)
  (set-field-value! c x <Pair.tail>) )

(define (symbol? x)
  (is-a? x <Symbol>) )

(define (symbol->string s)
  (field-value s <Symbol.name>) )

(define (string? x)
  (is-a? x <String>) )

(define (string-length s)
  (indexed-field-length s <String.character>) )

(define (string-ref s i)
  (indexed-field-value s <String.character> i) )

(define (string-set! s i v)
  (set-indexed-field-value! s v <String.character> i) )

(define (vector? o)
  (is-a? o <Vector>) )

(define (vector-length v)
  (indexed-field-length v <Vector.item>) )

(define (vector-ref v i)
  (indexed-field-value v <Vector.item> i) )

(define (vector-set! v i c)
  (set-indexed-field-value! v c <Vector.item> i) )

(define (eof-object? o)
  (eq? o end-of-file) )

(define (input-port? o)
  (is-a? o <InputPort>) )

(define (output-port? o)
  (is-a? o <OutputPort>) )

(define (peek-char . port)
  (let* ((port (if (pair? port) (car port) (current-input-port)))
         (char (field-value port <InputPort.poken>)) )
    (if char char
        (let ((char (do-read-char port)))
          (set-field-value! port char <InputPort.poken>)
          char ) ) ) )

(define (read-char . port)
  (let* ((port (if (pair? port) (car port) (current-input-port)))
         (char (field-value port <InputPort.poken>)) )
    (if char 
        (begin (set-field-value! port #f <InputPort.poken>)
               char )
        (do-read-char port) ) ) )

;;; end of libscm0.scm
