;;; $Id: wmw.scm,v 1.1 1995/06/20 18:26:39 queinnec Exp $

;;;ooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooooo
;;; Now the difficult part: how to let the user add its own macros
;;; when writing Icslas code. A new macro is offered with the
;;; following semantics (or restrictions): It evaluates its body in 
;;; the expansion environment. To add a new macro, just enrich the
;;; current value of the icslas-macroexpand global variable with the 
;;; macro-*-extend[*] functions.

(define-icslas-expander (within-macro-world . body)
  (expand-eval `(begin . ,body)) )

;;; If you submit this expression to Icslas, wrapped inside a
;;; with-macro-world form then you will gain a macro definer under
;;; Icslas. Expressions of that file are all considered as wrapped
;;; inside a within-macro-world so the previously described facility
;;; is already usable from Icslas toplevel.

;(within-macro-world
  (set! icslas-macroexpand
        (macro-form-extend 
         icslas-macroexpand
         'define-macro
         (lambda (e m)
           (let* ((call      (cadr e))
                  (body      (cddr e))
                  (name      (car call))
                  (variables (cdr call)) )
             (set! icslas-macroexpand
                   (macro-form-extend
                    icslas-macroexpand
                    name
                    (expand-eval `(lambda (ee mm)
                                    (mm (apply (lambda ,variables . ,body)
                                               (cdr ee) )
                                        mm ) ) ) ) )
             icslas-unspecified ) ) ) )
;  )

;;;        (define-macro (macro-name macro-variables) body...)
;;; defines a macro that can be used under the Icslas toplevel. Error
;;; handling while macroexpanding is very minimal.  The language in
;;; which the macro is written is the underlying Scheme and not
;;; Icslas! See some tests in the icslas.tst file.

;;; end of wmw.scm
