;;; $Id: rtosc.scm,v 1.2 1996/08/29 15:34:09 queinnec Exp $

;;; This is the adaptation to OScheme of the language of Icslas.

;;; The normal and error output ports.

(define stderr (current-error-port))
(define stdout (current-output-port))

(define (flush-output-port out)
  (output-port-flush out) )

;;; We will load Marc Feeley's pretty-printer.

(define (pp e . port)
  (apply pretty-print e port) )

;;; Icslas use the 'monitor' special form that is implemented as a macro
;;; in Scheme. The implementation should define two helper functions:
;;;   a protected-eval function
;;; 	(protected-eval thunk) computes the thunk and returns a vector 
;;;     of its value. If an error occurs, it returns a list describing
;;;     the error.
;;;   a protected-error function that signals an error to the underlying 
;;;     Scheme implementation.

(define (protected-eval thunk)
  (call/cc 
   (lambda (exit)
     (error:case (vector (thunk))
       (#t (lambda erroneous
             (exit erroneous) )) ) ) ) )

(define (protected-error . hints)
  (apply error hints) )

;;; end of rtosc.scm
