/* $Id: xlaoscheme.c,v 1.4 1995/09/19 18:37:22 queinnec Exp $ */

/* This file describes how to bind Icslas within OScheme. 
 * The Os_ByteCode_initialize is automatically called from OScheme
 * at initialization time.
 */

#include "dmeroon.h"
#include "xla.h"

DM_DefineStringWithCstring(xlaoscheme_version,
  "$Id: xlaoscheme.c,v 1.4 1995/09/19 18:37:22 queinnec Exp $");

/******************************************************************
 * The following file defines functions wrapping Icslas functions and
 * macros. These functions check their argument and translate values
 * from Icslas and OScheme.
 */

#include "xlaoscf.c"

/* Some global variables are needed by the ByteCode interpreter. */

DM_Anomaly *DM_exception = NULL;
jmp_buf    *DM_jmp_buf   = NULL;

/******************************************************************
 * This is the procedure to initialize Icslas with OScheme.
 */

DM_SupportVoid
Os_ByteCode_initialize (OsInterp interp) {

  /* Initialize the ByteCode interpreter. */
  DM_xlaenv_initialize();
  DM_xlaobj_initialize();

  /* This is the automatically generated file that contains the
   * definitions of all the symbols that are needed to interface
   * Icslas resources from OScheme.
   */
#  include "xlaoscm.c"

  return DM_DONE;
}

/* end of xlaoscheme.c */
