;;; $Id: r4rsenv.scm,v 1.2 1995/07/06 18:25:10 queinnec Exp $

;;; This file defines the predefined global immutable environment for R4RS.

;;; Exportation:
;;;         g.r4rs a list of Predefined-Variables
;;; end of exportations

(define g.r4rs '())

;;; This macro allows to define the functions of R4RS with their arity.

(define-icslas-macro (defprimitive name comparator arity)
  `(begin
     (set! g.r4rs
           (cons (make-Predefined-Variable
                  ',name (make-Functional-Description
                          ,comparator ,arity ) )
                 g.r4rs ) )
     ',name ) )

;;; Comparators are =, >= or or=or=+1

(define (or=or=+1 arguments-number arity)
  (or (= arguments-number arity)
      (= arguments-number (+ arity 1)) ) )

;;; And now a long list of all r4rs functions.

(defprimitive boolean? = 1)
(defprimitive not = 1)
(defprimitive eqv? = 2)
(defprimitive eq? = 2)
(defprimitive equal? = 2)
(defprimitive pair? = 1)
(defprimitive cons = 2)
(defprimitive car = 1)
(defprimitive cdr = 1)
(defprimitive set-car! = 2)
(defprimitive set-cdr! = 2)
(defprimitive caar = 1)
(defprimitive cadr = 1)
(defprimitive cdar = 1)
(defprimitive cddr = 1)
(defprimitive caaar = 1)
(defprimitive caadr = 1)
(defprimitive cadar = 1)
(defprimitive caddr = 1)
(defprimitive cdaar = 1)
(defprimitive cdadr = 1)
(defprimitive cddar = 1)
(defprimitive cdddr = 1)
(defprimitive caaaar = 1)
(defprimitive caaadr = 1)
(defprimitive caadar = 1)
(defprimitive caaddr = 1)
(defprimitive cadaar = 1)
(defprimitive cadadr = 1)
(defprimitive caddar = 1)
(defprimitive cadddr = 1)
(defprimitive cdaaar = 1)
(defprimitive cdaadr = 1)
(defprimitive cdadar = 1)
(defprimitive cdaddr = 1)
(defprimitive cddaar = 1)
(defprimitive cddadr = 1)
(defprimitive cdddar = 1)
(defprimitive cddddr = 1)
(defprimitive null? = 1)
(defprimitive list? = 1)
(defprimitive list >= 0)
(defprimitive length = 1)
(defprimitive append >= 0)
(defprimitive reverse = 1)
(defprimitive list-tail = 2)
(defprimitive list-ref = 2)
(defprimitive memq = 2)
(defprimitive memv = 2)
(defprimitive member = 2)
(defprimitive assq = 2)
(defprimitive assv = 2)
(defprimitive assoc = 2)
(defprimitive symbol? = 1)
(defprimitive symbol->string = 1)
(defprimitive string->symbol = 1)
(defprimitive integer? = 1)
(defprimitive rational? = 1)
(defprimitive real? = 1)
(defprimitive complex? = 1)
(defprimitive number? = 1)
(defprimitive exact? = 1)
(defprimitive inexact? = 1)
(defprimitive = >= 2)
(defprimitive < >= 2)
(defprimitive > >= 2)
(defprimitive <= >= 2)
(defprimitive >= >= 2)
(defprimitive zero? = 1)
(defprimitive positive? = 1)
(defprimitive negative? = 1)
(defprimitive odd? = 1)
(defprimitive even? = 1)
(defprimitive max >= 1)
(defprimitive min >= 1)
(defprimitive + >= 0)
(defprimitive - >= 0)
(defprimitive * >= 0)
(defprimitive / >= 1)
(defprimitive abs = 1)
(defprimitive quotient = 2)
(defprimitive remainder = 2)
(defprimitive modulo = 2)
(defprimitive gcd >= 0)
(defprimitive lcm >= 0)
(defprimitive numerator = 1)
(defprimitive denominator = 1)
(defprimitive floor = 1)
(defprimitive ceiling = 1)
(defprimitive truncate = 1)
(defprimitive round = 1)
(defprimitive rationalize = 2)
(defprimitive sqrt = 1)
(defprimitive expt = 2)
(defprimitive make-rectangular = 2)
(defprimitive make-polar = 2)
(defprimitive real-part = 1)
(defprimitive imag-part = 1)
(defprimitive angle = 1)
(defprimitive exact->inexact = 1)
(defprimitive inexact->exact = 1)
(defprimitive number->string = 1)
(defprimitive string->number or=or=+1 1)
(defprimitive char? = 1)
(defprimitive char=? = 1)
(defprimitive char<? = 1)
(defprimitive char>? = 1)
(defprimitive char<=? =  1)
(defprimitive char>=? = 1)
(defprimitive char=-ci? = 1)
(defprimitive char<-ci? = 1)
(defprimitive char>-ci? = 1)
(defprimitive char<=-ci? =  1)
(defprimitive char>=-ci? = 1)
(defprimitive char-alphabetic? = 1)
(defprimitive char-numeric? = 1)
(defprimitive char-whitespace? = 1)
(defprimitive char-upper-case? = 1)
(defprimitive char-lower-case? = 1)
(defprimitive char->integer = 1)
(defprimitive integer->char = 1)
(defprimitive char-upcase = 1)
(defprimitive char-downcase = 1)
(defprimitive string? = 1)
(defprimitive make-string or=or=+1 1)
(defprimitive string >= 0)
(defprimitive string-length = 1)
(defprimitive string-ref = 2)
(defprimitive string-set! = 3)
(defprimitive string=? = 1)
(defprimitive string<? = 1)
(defprimitive string>? = 1)
(defprimitive string>=? = 1)
(defprimitive string<=? = 1)
(defprimitive string=-ci? = 1)
(defprimitive string<-ci? = 1)
(defprimitive string>-ci? = 1)
(defprimitive string>=-ci? = 1)
(defprimitive string<=-ci? = 1)
(defprimitive substring = 3)
(defprimitive string-append >= 0)
(defprimitive string->list = 1)
(defprimitive list->string = 1)
(defprimitive string-copy = 1)
(defprimitive string-fill! = 2)
(defprimitive vector? = 1)
(defprimitive make-vector or=or=+1 1)
(defprimitive vector >= 0)
(defprimitive vector-length = 1)
(defprimitive vector-ref = 2)
(defprimitive vector-set! = 3)
(defprimitive vector->list = 1)
(defprimitive list->vector = 1)
(defprimitive vector-fill! = 2)
(defprimitive procedure? = 1)
(defprimitive apply >= 2)
(defprimitive map >= 2)
(defprimitive for-each >= 2)
(defprimitive force = 1)
(defprimitive call/cc = 1)
(defprimitive call-with-input-file = 2)
(defprimitive call-with-output-file = 2)
(defprimitive with-input-file = 2)
(defprimitive with-output-file = 2)
(defprimitive input-port? = 1)
(defprimitive output-port? = 1)
(defprimitive current-input-port = 0)
(defprimitive current-output-port = 0)
(defprimitive open-input-file = 1)
(defprimitive open-output-file = 1)
(defprimitive close-input-port = 1)
(defprimitive close-output-port = 1)
(defprimitive read or=or=+1 0)
(defprimitive read-char or=or=+1 0)
(defprimitive peek-char or=or=+1 0)
(defprimitive eof-object? = 1)
(defprimitive char-ready? or=or=+1 0)
(defprimitive write or=or=+1 1)
(defprimitive display or=or=+1 1)
(defprimitive newline or=or=+1 0)
(defprimitive write-char or=or=+1 1)
(defprimitive load = 1)
(defprimitive transcript-on = 1)
(defprimitive transcript-off = 0)

;;; end of r4rsenv.scm
