;;; $Id: macs2c.scm,v 1.2 1996/08/28 17:48:10 queinnec Exp $

;;; This is the macro-related part of the adaption of Icslas to Scheme2C.

;;; You must first define a macro that allows to define a macro.  The
;;; defined macro will be used while processing the sources of Icslas.

(define-macro define-icslas-macro
  (lambda (e m)
    (let* ((call      (cadr e))
           (body      (cddr e))
           (name      (car call))
           (variables (cdr call)) )
      (m `(define-macro ,name
            (lambda (e m)
              (m (apply (lambda ,variables . ,body) (cdr e)) m) ) )
         m ) ) ) )

;;; Then define a macro that defines a macro that must be present at
;;; runtime. This is different from the previous one in a compiler if
;;; the compiler runs in a different memory image.

(define-icslas-macro (define-pervasive-icsla-macro call . body)
  (let* ((name      (car call))
         (variables (cdr call)) )
    `(eval '(define-macro ,name
              (lambda (e m)
                (m (apply (lambda ,variables . ,body) (cdr e)) m) ) )) ) )

;;; end of macs2c.scm
