;;; $Id: rts2c.scm,v 1.3 1996/08/29 15:34:12 queinnec Exp $

;;; This is the adaptation to Scheme->C of the language of Icslas.

;;; The normal and error output ports.
  
(define stderr stderr-port)
(define stdout stdout-port)

(define (flush-output-port out)
  (flush-buffer out) )

;;; Icslas use the 'monitor' special form that is implemented as a macro
;;; in Scheme. The implementation should define two helper functions:
;;;   a protected-eval function
;;; 	(protected-eval thunk) computes the thunk and returns a vector 
;;;     of its value. If an error occurs, it returns a list describing
;;;     the error.
;;;   a protected-error function that signals an error to the underlying 
;;;     Scheme implementation.

(define (protected-eval thunk)
  (call/cc
   (lambda (exit)
     (let ((old *error-handler*))
       (set! *error-handler*
             (lambda (symb fmt . culprits)
               (exit (list symb fmt culprits)) ) )
       (let ((result (vector (thunk))))
         (set! *error-handler* old)
         result ) ) ) ) )

(define (protected-error . hints)
  (apply error 'diagnose "Uncaught exception" hints) )

;;; Other peculiarities.

(define call/cc call-with-current-continuation)

;;; end of rts2c.scm
