;;; $Id: macscm.scm,v 1.1 1996/08/29 12:16:38 queinnec Exp $

;;; This is the macro-related part of the adaption of Icslas to SCM.

;;; You must first define a macro that allows to define a macro.  The
;;; defined macro will be used while processing the sources of Icslas.

(defmacro define-icslas-macro (call . body)
  `(defmacro ,(car call) ,(cdr call) . ,body) )

;;; Then define a macro that defines a macro that must be present at
;;; runtime. This is different from the previous one in a compiler if
;;; the compiler runs in a different memory image.

(defmacro define-pervasive-icslas-macro (call . body)
  `(eval '(defmacro ,(car call) ,(cdr call) . ,body)) )

;;; end of macscm.scm
