;;; $Id: rtscm.scm,v 1.2 1996/08/29 15:34:13 queinnec Exp $

;;; This is the adaptation of Icslas to SCM.

;;; The normal and error output ports.

(require 'stdio)

;;; How to flush them.

(define (flush-output-port out)
  (force-output out) )

;;; We will load Marc Feeley's pretty-printer.

(define (pp e . port)
  (apply pretty-print e port) )

;;; Icslas use the 'monitor' special form that is implemented as a macro
;;; in Scheme. The implementation should define two helper functions:
;;;   a protected-eval function
;;; 	(protected-eval thunk) computes the thunk and returns a vector 
;;;     of its value. If an error occurs, it returns a list describing
;;;     the error.
;;;   a protected-error function that signals an error to the underlying 
;;;     Scheme implementation.

(define (protected-eval thunk)
  (call/cc
   (lambda (exit)
     (set! error exit)
     (vector (thunk)) ) ) )

(define protected-error error)

;;; Other utilities

(define call/cc call-with-current-continuation)

;;; end of rtscm.scm
