;;; $Id: bc.tst,v 1.3 1995/06/26 12:16:39 queinnec Exp $

;;; This file contains additional test for the bytecode compiler.

;;;==================================================================
;;; Test code translation (the patch-jump! function).
;;; a single patch.
(if (pair? 'a)
    ((lambda (a b c d e f g h i j k l m n o p q r s t u v w x y z)
       ((lambda (a b c d e f g h i j k l m n o p q r s t u v w x y z)
          ((lambda (a b c d e f g h i j k l m n o p q r s t u v w x y z)
             ((lambda (a b c d e f g h i j k l m n o p q r s t u v w x y z)
                a )
              1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 ) )
           1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 ) )
        1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 ) )
     1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 )
    111 )
   111
;;; two embedded patches.
(if (pair? 'a)
    ((lambda (a b c d e f g h i j k l m n o p q r s t u v w x y z)
       (if (pair? a)
           ((lambda (a b c d e f g h i j k l m n o p q r s t u v w x y z)
              ((lambda (a b c d e f g h i j k l m n o p q r s t u v w x y z)
                 ((lambda (a b c d e f g h i j k l m n o p q r s t u v w x y z)
                    a )
                  1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 ) )
               1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 ) )
            1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 )
           333 ) )
     1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 )
    111 )
   111

;;;==================================================================
;;; testing eval at toplevel. (snarfed from book/src/chap8a.tst)
(eval 'car)
   ---
((eval 'car) '(a b c))
   a
((eval '(lambda (x) (list x x))) (+ 2 3))
   (5 5)
(eval 345)
   345

;;; with side effects on the global mutable environment
;;; Foo and bar already exist
(begin (set! foo 2)
       (eval '(set! foo 33))
       foo )
   33
(begin (set! bar 33)
       (set! foo 44)
       (eval '(set! bar (- foo bar)))
       bar )
   11

;;; More than one eval
((lambda (loop fact)
   (set! loop (lambda (i)
                (if (> i 0)
                    (begin (display (eval (list fact fact 10)))
                           (loop (- i 1)) )
                    'done ) ))
   (loop 0) )
 'loop '(lambda (f n) (if (= n 0) 1 (* n (f f (- n 1))))) )
   done

((eval '(lambda (x) (cons x x)))
 33 )
 (33 . 33)
(((eval '(lambda (f)
           (lambda (x) (f x)) ))
  list )
 44 )
   (44)

;;; Exercizing some errors. No test on syntax since interpreters of the
;;; book neglect this aspect. 
(eval car)
   *** ; Not a program (cannot cite a procedure).

;;; examples from the book
(begin (set! x 2)
       (set! z 1)
       (list ((lambda (x) (eval 'x))
              3 )
             ((lambda (x y) (eval y))
              4 (list 'eval 'x) )
             ((lambda (x y z) (eval y))
              5 (list 'eval 'z) 'x ) ) )
   (2 2 1)

;;;==================================================================
;;; Test load and compile-file.

(begin (compile-file "Test/challenge.scm")
       (load "Test/challenge.xlo") )
   (120 (2 3 5 7)) ; and prints symbol FACT
(begin (load "Test/challenge.xlo")
       (load "Test/challenge.xlo") )
   (120 (2 3 5 7)) ; and prints twice symbol FACT.

;;; end of bc.tst
