;;; $Id: icslas.tst,v 1.4 1995/07/07 19:34:25 queinnec Exp $

;;;                    Additional tests on Icslas

;;; Syntactic extensions with the `unspecified' predefined global variable.
(begin)
   ---
(if #f 1)
   ---
;;; add erroneous tests to check check.scm functions          FUTURE

;;; Syntatical tests.
((lambda (if quote set! lambda begin) 
   (list if quote set! lambda begin) )
 'a 'b 'c 'd 'e )
   (a b c d e)


;;;==================================================================
;;; Testing bind-exit (snarfed from Book/src/chap7d.tst)

(bind-exit (k) 1)
   1
(bind-exit (k) (k 'a))
   a
(bind-exit (k) (cons (k 'a) 1))
   a
(bind-exit (k) k)
   ---
(bind-exit (k)
  ((lambda (kk) (+ 1 (kk 'z)))
   k )
  (k 'a) )
   z
(bind-exit (k1)
  (* 2 (bind-exit (k2)
          (k1 3) )) )
   3
(bind-exit (k1)
  (* 2 (bind-exit (k2)
          (+ 5 (k1 3)) )) )
   3
(bind-exit (k1)
  (* 2 (bind-exit (k2)
          (+ 5 (k2 3)) )) )
   6
(bind-exit (k1)
  (* 2 ((bind-exit (k2)
          (+ 5 (k2 k1)) )
        3 )) )
   3
;;; the exit variable may be mutable.
(bind-exit (k)
  (* 2 (begin (set! k (lambda (x) x))
              (k 3) )) )
   6
(bind-exit (k)
  (* 2 (begin (set! k (list k))
              ((car k) 3) )) )
   3
;;; restaure lexical env ie invoke bind-exit in a non tail position.
((lambda (a)
   (bind-exit (k) a) )
 11 )
   11
((lambda (a)
   (bind-exit (k) a)
   a )
 11 )
   11
((lambda (a)
   (bind-exit (k)
      ((lambda (b) a)
       (cons a a) ) ) )
 11 )
   11
((lambda (a)
   (set! a (bind-exit (k)
             ((lambda (b) a)
              (k (cons a a)) )
             b ) )
   a )
 11 )
   (11 . 11)
;;; out of extent
((bind-exit (k) k) 33)
   ***
;;; exercize some errors when invoking continuations
(bind-exit (k) (k))
   *** ; arity error
(bind-exit (k) (k 1 2))
   *** ; arity error
((bind-exit (k) k) 1 2 3)
   *** ; arity error
(bind-exit (k) (cons 1 (apply k 2 '())))
   2 
(bind-exit (k) (cons 1 (apply k '(3))))
   3
;;; variable arity on continuations
(bind-exit (k) (cons 1 (apply k 1 2 '())))
   *** ; arity error
(bind-exit (k) (cons 1 (apply k '())))
   ***  ; arity error
((lambda (kk)
   (bind-exit (k1)
      (* 2 (bind-exit (k2)
              (set! kk k2)
              (k1 1) )) )
   (kk 3) )
 'wait )
   *** ; obsolete exit

;;;==================================================================
;;; Test exceptions. (snarfed from book/src/chap7d.tst)

(monitor (lambda (anomaly continuable?) 3)
         1 )
   1
(monitor (lambda (anomaly continuable?) 3)
         1 2 4 )
   4
(bind-exit (k)
  (monitor (lambda (anomaly continuable?) 
             (if continuable? 3 (k 5)) )
     (* 2 (diagnose 4 #t)) ) )
   6
(bind-exit (k)
  (monitor (lambda (anomaly continuable?) 
             (if continuable? 3 (k 5)) )
     (* 2 (diagnose 4 #f)) ) )
   5
(bind-exit (k1)
  (monitor (lambda (a1 c1?) (if c1? 7 (k1 13)))
    (monitor (lambda (anomaly continuable?) 
               (if continuable? (diagnose 11 #t) (diagnose 15 #f)) )
       (* 2 (diagnose 4 #t)) ) ) )
   14
(bind-exit (k1)
  (monitor (lambda (a1 c1?) (if c1? 7 (k1 13)))
    (monitor (lambda (anomaly continuable?) 
               (if continuable? (diagnose 11 #t) (diagnose 15 #f)) )
       (* 2 (diagnose 4 #f)) ) ) )
   13
;;; caatch system-raised anomalies.
;;; (1) catch an uninitialized global variable
foo-
   ***
(bind-exit (k)
  (monitor (lambda (anomaly continuable?) (k 3))
     foo- ) )
   3
(bind-exit (k)
  (monitor (lambda a (k 3))
     foo- ) )
   3
;;; (2) catch an arity error
(bind-exit (k)
  (monitor (lambda (e c) (k 22))
    (apply cons '()) ) )
   22
(bind-exit (k)
  (monitor (lambda (e c) (k 22))
    (apply (lambda () 1) '(2 3)) ) )
   22
(bind-exit (k)
  (monitor (lambda (e c) (k 22))
    (call/cc (lambda () (kk))) ) )
   22
(bind-exit (k)
  (monitor (lambda (e c) (k 22))
    (call/cc (lambda (kk) (kk))) ) )
   22

;;; end of icslas.tst
