;;; $Id: vector.tst,v 1.1 1996/08/29 08:41:19 queinnec Exp $

;;; Testing operations on vectors.

make-vector
   ---
(make-vector 3 'a)
   #(a a a)
(make-vector 0)
   #()
(vector? (make-vector 3 'a))
   #t
(vector? (make-vector 0 'a))
   #t
(vector? #f)
   #f
(vector? 42)
   #f
(vector-length (make-vector 0 'a))
   0
(vector-length (make-vector 3 'a))
   3
(vector-ref (make-vector 3 'a) 0)
   a
(vector-ref (make-vector 3 'a) 2)
   a
((lambda (v)
   (vector-set! v 2 'b)
   (vector-ref v 2) )
 (make-vector 3 'a) )
   b

;;; Checking errors
(vector-ref (make-vector 3 'a) -1)
   ***
(vector-ref (make-vector 3 'a) 3)
   ***
(vector-set! (make-vector 3 'a) -1 'b)
   ***
(vector-set! (make-vector 3 'a) 3 'b)
   ***

;;; Nary constructor
(vector)
   #()
(vector 'a 'b 'c)
   #(a b c)
(apply vector 'a 'b '(c))
   #(a b c)

;;; Default argument
"Test make-vector with a single argument"
   ---
(vector? (make-vector 3))
   #t
(vector-length (make-vector 4))
   4

;;; end of vector.tst
