/* 
 * This program tries to determine the kind of the current machine.
 * It is based on Manuel Serrano's Bigloo tools/arch.c program.
 */

#ifdef __STDC__
extern int puts (char *mes);
#else
extern int puts();
#endif

/*---------------------------------------------------------------------*/
/*    PRINT ...                                                        */
/*---------------------------------------------------------------------*/
#define PRINT( mes ) if( !done++ ) puts( mes )
int done = 0;

/*---------------------------------------------------------------------*/
/*    main ...                                                         */
/*---------------------------------------------------------------------*/
int
main( argc, argv )
int argc;
char *argv[];
{
/* gcc on sun4 solaris recognizes this: */
#if (defined( SPARC ) || defined( sparc )) && defined( __svr4__ )
   PRINT( "sun4_solaris" );
#endif
   
/* SUN's cc on sun4 solaris fails on the previous one. */
#if (defined( SPARC ) || defined( sparc )) && defined(sun) && defined(__SVR4)
   PRINT( "sun4_solaris" );
#endif
	
#if defined( SPARC ) || defined( sparc )
   PRINT( "sun4_bsd" );
#endif

#if( defined( sun ) && ( defined( mc68000 ) || defined( mc68020 ) ))
   PRINT( "sun3" );
#endif

#if defined( sony_news ) || defined( r3000 ) 
   PRINT( "news_mips" );
#endif

#if defined( i386 )
   PRINT( "intel386" );
#endif

#if ( defined( __pa_risesc ) || defined(_PA_RISC1_0) || defined(_PA_RISC1_1) )
   PRINT( "hp_ux" );
#endif

#if( defined( ultrix ) && defined( mips ) && defined( host_mips) )
   PRINT( "ultrix" );
#endif

/* Thanks to Drew Whitehouse [Drew.Whitehouse@anu.edu.au] Don't answer
 * sgi since if sgi appears in an Imakefile it will be expanded into
 * 1! Same problem for 'vax' word. */
#if defined( sgi )
   PRINT( "sgi_irix" );
#endif

#if defined( NeXT ) && defined( mc68000 )
	PRINT( "next" );
#endif

#if defined( RS6000 ) || defined( _IBMR2 )
	PRINT( "AIX" );
#endif

#if defined( __alpha )
	PRINT( "alpha" );
#endif
	
   if( !done )
	{
      puts( "unknown" );
		exit( -1 );
	}
	else
	   exit( 0 );
}
